/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mouse Gesture for Mozilla by Optimoz group.
 * Modified by Marc Boullet <boullet.marc@wanadoo.fr>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var aioGestTable;
// aioActionTable's 3rd column denotes rocker multiple operations. 0: Not allowed, 1: Allowed 2: Conditional
// 4th column denotes the buddy action if any 
var aioActionTable = [
      ["BrowserBack()", "g.browserBack", 2, "1"], // 0
      ["BrowserForward()", "g.browserForward", 2, "0"], // 1
      ["BrowserReload()", "g.browserReload", 0, ""], // 2
      ["BrowserReloadSkipCache()", "g.browserReloadSkipCache", 0, ""], // 3
      ["BrowserStop()", "g.browserStop", 0, ""], // 4
      ["aioHomePage()", "g.browserHome", 0, ""], // 5
      ["aioOpenNewWindow(false)", "g.openNewWindow", 0, ""], // 6
      ["aioDupWindow()", "g.duplicateWindow", 0, ""], // 7
      ["aioUpDir()", "g.upDir", 2, ""], // 8
      ["aioOpenInNewTab(false)", "g.browserOpenTabInFg", 0, ""], // 9
      ["aioDupTab()", "g.duplicateTab", 0, ""], // 10
      ["aioContent.mTabContainer.advanceSelectedTab(+1)", "g.nextTab", 1, "12"], // 11
      ["aioContent.mTabContainer.advanceSelectedTab(-1)", "g.previousTab", 1, "11"], // 12
      ["aioRemoveAllTabsBut()", "g.closeOther", 0, ""], // 13
      ["aioRestMaxWin()", "g.restMaxWin", 1, ""], // 14
      ["window.minimize()", "g.minWin", 0, ""], // 15
      ["BrowserFullScreen()", "g.fullScreen", 1, ""], // 16
      ["aioSelectionAsURL()", "g.openSelection", 0, ""], // 17
      ["aioCloseCurrTab(true)", "g.closeDoc", 0, ""], // 18
      ["BrowserViewSourceOfDocument(window._content.document)", "g.viewPageSource", 0, ""], // 19
      ["BrowserViewSourceOfDocument(aioSrcEvent.target.ownerDocument)", "g.viewFrameSource", 0, ""], // 20
      ["aioViewCookies()", "g.viewSiteCookies", 0, ""], // 21
      ["BrowserPageInfo()", "g.pageInfo", 0, ""], // 22
      ["toJavaScriptConsole()", "g.jsConsole", 0, ""], // 23
      ["openAboutDialog()", "g.about", 0, ""], // 24
      ["addBookmarkAs(aioContent)", "g.addBookmark", 0, ""], // 25
      ["aioDoubleWin()", "g.doubleStackWin", 0, ""], // 26
      ["aioSetImgSize(true,false)", "g.doubleImageSize", 1, "28"], // 27
      ["aioSetImgSize(false,false)", "g.halveImageSize", 1, "27"], // 28
      ["aioNukeAnything()", "g.hideObject", 0, ""], // 29
      ["ZoomManager.prototype.getInstance().enlarge()", "g.zoomIn", 1, "31"], // 30
      ["ZoomManager.prototype.getInstance().reduce()", "g.zoomOut", 1, "30"], // 31
      ["ZoomManager.prototype.getInstance().reset()", "g.resetZoom", 1, ""], // 32
      ["aioActionOnPage(0)", "g.w3cValidate", 0, ""], // 33
      ["aioLinksInWindows()", "g.linksInWindows", 0, ""], // 34
      ["aioLinksInTabs()", "g.linksInTabs", 0, ""], // 35
      ["aioMetaInfo()", "g.metaInfo", 0, ""], // 36
      ["aioScrollDocument(true,1)", "g.scrollDown", 1, "38"], // 37
      ["aioScrollDocument(true,-1)", "g.scrollUp", 1, "37"], // 38
      ["aioScrollDocument(false,0)", "g.scrollToTop", 0, ""], // 39
      ["aioScrollDocument(false,1000000)", "g.scrollToBottom", 0, ""], // 40
      ["aioResetImgSize(false)", "g.resetImage", 1, ""], // 41
      ["toggleSidebar('viewBookmarksSidebar')", "g.bookmarkSidebar", 1, ""], // 42
      ["aioNukeFlash()", "g.hideFlash", 0, ""], // 43
      ["aioCopyURLToClipBoard()", "g.URLToClipboard", 0, ""], // 44
      ["getWebNavigation().gotoIndex(0)", "g.firstPage", 0, ""], // 45
      ["aioGesturesPage()", "g.showGestures", 0, ""], // 46
      ["aioCloseCurrTab(false)", "g.closeTab", 0, ""], // 47
      ["aioIncURL(1)", "g.incURL", 2, "49"], // 48
      ["aioIncURL(-1)", "g.decURL", 2, "48"], // 49
      ["aioSchemas={};", "g.clearDigitFlipper", 0, ""], // 50
      ["aioLinksInFiles()", "g.linksInFiles", 0, ""], // 51
      ["aioUndoCloseTab()", "g.undoCloseTab", 0, ""], // 52
      ["PrintUtils.printPreview(onEnterPrintPreview, onExitPrintPreview);", "g.printPreview", 0, ""], //53
      ["aioOpenInNewTab(true)", "g.browserOpenTabInBg", 0, ""], // 54
      ["aioDeleteCookies()", "g.deleteSiteCookies", 0, ""], // 55
      ["aioUndoNukeAnything()", "g.undoHideObject", 0, ""], // 56
      ["aioFavoriteURL('1')", "g.openFav1", 0, ""], // 57
      ["aioFavoriteURL('2')", "g.openFav2", 0, ""], // 58
      ["BrowserOpenTab()", "g.openBlankTab", 0, ""], // 59
      ["aioCloseWindow()", "g.closeWindow", 0, ""], // 60
      ["aioOpenNewWindow(true)", "g.openWindowInBg", 0, ""], // 61
      ["aioFrameInfo()", "g.frameInfo", 0, ""], // 62
      ["aioOpenAioOptions()", "g.aioOptions", 0, ""], // 63
      ["toggleSidebar('viewHistorySidebar')", "g.historySidebar", 1, ""], // 64
      ["aioOpenBookmarksManager()", "g.bookmarkMgr", 0, ""], // 65
      ["aioActionOnPage(1)", "g.translate", 0, ""], // 66
      ["aioOpenDownloadManager()", "g.downloadMgr", 0, ""], // 67
      ["saveDocument(window._content.document)", "g.savePageAs", 0, ""], // 68
      ["aioGoToPreviousSelectedTab()", "g.prevSelectedTab", 1, ""], // 69
      ["aioShowHideStatusBar()", "g.showHideStatusBar", 1, ""], // 70
      ["aioSrcEvent.target.ownerDocument.location.reload()", "g.reloadFrame", 0, ""], // 71
      ["aioSetImgSize(true,true)", "g.enlargeObject", 1, "73"], // 72
      ["aioSetImgSize(false,true)", "g.reduceObject", 1, "72"], // 73
      ["aioResetImgSize(true)", "g.resetSize", 1, ""], //74
      ["aioShowHideFindBar()", "g.showHideFindBar", 1, ""], // 75
      ["aioContent.reloadAllTabs()", "g.reloadAllTabs", 0, ""], // 76
      ["aioNextPrevLink(true)", "g.nextLink", 0, ""], // 77
      ["aioFastForward()", "g.fastForward", 0, ""], // 78
      ["aioSelectionAsSearchTerm()", "g.searchSelection", 0, ""], // 79
      ["aioSaveImageAs()", "g.saveImageAs", 0, ""], // 80
      ["aioNextPrevLink(false)", "g.prevLink", 0, ""], // 81
      ["aioGotoLastTab()", "g.lastTab", 0, ""] // 82
     ];
var aioSchemas = {};
var aioLastTabInfo = [];
var aioUndoHide = [];
var aioUnique = 0;
var aioDeletingRightmost;
const aioKGestures = "chrome://allinonegest/locale/aiogest.html";

function aioStatusMessage(msg, timeToClear) {
  if (!aioStatusBar) return;
  aioStatusBar.label = msg;
  if (timeToClear) setTimeout(aioStatusMessage, timeToClear, "", 0);
}

function aioInitGestTable() {
  var i;
  if (aioFirst)
     for (i = 0; i < aioActionTable.length; ++i) aioActionTable[i][1] = aioGetStr(aioActionTable[i][1])
  var gestTable = aioActionString.split("|");
  var funcTable = aioFuncString.split("|");
  aioGestTable = [];
  for (i = 0; i < gestTable.length; ++i)
    if (gestTable[i]) aioGestTable[gestTable[i]] =  funcTable[i] - 0;
}

function aioFireGesture(aGesture) {
  var index = aioGestTable[aGesture];
  if (index == null) {
     index = aioGestTable["+" + aGesture.substr(-2)];
     if (index == null)
        index = aioGestTable["+" + aGesture.substr(-3)];
  }
  if (index == null) {
     index = aioGestTable["/" + aGesture];
     if (index == null) aioStatusMessage(aioUnknownStr + ": " + aGesture, 2000);
     else aioStatusMessage(aioGetStr("g.disabled") + ": " + aioActionTable[index][1], 2000);
  }
  else
     try {
       eval(aioActionTable[index][0]);
       aioStatusMessage(aioActionTable[index][1], 2000);
     }
     catch(err) {}
  aioKillGestInProgress();
  aioDownButton = aioNoB;
}

function aioSetTabId(node) {
  if (!node) return null;
  var nodeId = node.getAttribute("aioTabId");
  if (!nodeId) {
     nodeId = "t" + aioUnique++;
     node.setAttribute("aioTabId", nodeId);
  }
  return nodeId;
}

function aioSetRemoveTab(e) {
  window.removeEventListener("mousemove", aioSetRemoveTab, true);
  if (typeof(aioContent.undoRemoveTab) == "function") return;
  aioContent.aioNativeRemoveTab = aioContent.removeTab;
  aioContent.removeTab = function(aTab) {
    if (aTab.localName != "tab") aTab = aioContent.mCurrentTab;
    var lBrowser = aioContent.getBrowserForTab(aTab);
    var ds = lBrowser.docShell;
    if (ds.contentViewer && !ds.contentViewer.permitUnload()) return;
    var tabObj = {};
    tabObj.next = aioSetTabId(aTab.nextSibling);
    tabObj.myId = aioSetTabId(aTab);
    aioDeletingRightmost = aioContent.mTabContainer.selectedIndex == (aioContent.mTabContainer.childNodes.length -1);
    tabObj.hist = lBrowser.sessionHistory;
    aioLastTabInfo.push(tabObj);
    if (aioLastTabInfo.length > 5) aioLastTabInfo.shift();
    aioContent.aioNativeRemoveTab(aTab);
  }
}

function aioTabFocus(e) { // derived from "Focus Last Selected Tab" by Daniel Lindkvist
  var lTab;
  if (e.target.localName == "tabs") return;
  if (aioRendering.selectedIndex != aioContent.mTabContainer.selectedIndex)
     aioRendering.selectedIndex = aioContent.mTabContainer.selectedIndex;
  var nbTabs = aioRendering.childNodes.length;
  if (nbTabs < aioTabsNb) { // a tab has been closed
     aioTabsNb = nbTabs;
     while (true) {
       if (aioTabFocusHistory.length < 1) break;
       var lHistory = aioTabFocusHistory.pop();
       if (!aioFocusMode) break; // standard mode
       if (aioFocusMode == 1) {
          if (aioDeletingRightmost) break;
          var newIndex = aioContent.mTabContainer.selectedIndex - 1;
          if (newIndex < 0) break;
          aioContent.mTabContainer.selectedIndex = newIndex;
          e.preventDefault();
          return;
       }          
       var tabId = aioFocusMode == 2 ? aioTabFocusHistory[aioTabFocusHistory.length - 1].focused
                      : lHistory.openedBy;
       if (!tabId) break;
       for (var i = 0; i < nbTabs; ++i) {
         lTab = aioContent.mTabContainer.childNodes[i];
         if (lTab.getAttribute("aioTabId") == tabId) {
            if (aioContent.mTabContainer.selectedIndex != i) {
               aioContent.mTabContainer.selectedIndex = i;
               e.preventDefault();
               return;
            }
            break;
         }
       }
       break;
     }
  }
  aioTabsNb = nbTabs;
  var activeTab = aioContent.mTabContainer.childNodes[aioContent.mTabContainer.selectedIndex];
  var activeId = activeTab.getAttribute("aioTabId");
  if (activeId)
     if (aioTabFocusHistory[aioTabFocusHistory.length - 1].focused == activeId) return; // already at top
     else {
        var openerId = "";
        for (i = 0; i < aioTabFocusHistory.length; ++i) //search for a duplicated entry
          if (aioTabFocusHistory[i].focused == activeId) {
             openerId = aioTabFocusHistory[i].openedBy;
             aioTabFocusHistory.splice(i, 1); // Found: delete it
          }
        aioTabFocusHistory.push({focused: activeId, openedBy: openerId});
     }
  else { // tab's never been visited
     activeId = "t" + aioUnique++;
     activeTab.setAttribute("aioTabId", activeId);
     openerId = aioTabFocusHistory[aioTabFocusHistory.length - 1].focused;
     aioTabFocusHistory.push({focused: activeId, openedBy: openerId});
  }
}

function aioTabLoad(e) {
  if (aioRendering.childNodes.length > aioTabsNb) aioTabsNb = aioRendering.childNodes.length;
}

/*  gesture Actions */

function aioGoToPreviousSelectedTab() {
  var lTab;
  if (aioTabFocusHistory.length < 2) return;
  var tabId = aioTabFocusHistory[aioTabFocusHistory.length - 2].focused;
  for (var i = 0; i < aioTabsNb; ++i) {
    lTab = aioContent.mTabContainer.childNodes[i];
    if (lTab.getAttribute("aioTabId") == tabId) {
       aioTabFocusHistory.pop();
       aioContent.selectedTab = lTab;
       return;
    }
  }
}

function aioFavoriteURL(suffix) {
  var shortcutURL = BMSVC.resolveKeyword(aioGetStr("g.keywordForGesture") + suffix, { });
  if (!shortcutURL) return;
  if (shortcutURL.toLowerCase().substr(0, 11) != "javascript:")
     aioLinkInTab(shortcutURL, true, false);
  else loadURI(shortcutURL);
}

function aioIncURL(inc) { // derived from MagPie by Ben Goodger
  var currSchema, newValue, newIndex, str, url; 
  var currSpec = aioContent.selectedBrowser.webNavigation.currentURI.spec;
  for (var i in aioSchemas) {
     if (currSpec.substr(0, i.length) != i) continue;
     currSchema = aioSchemas[i];
     newValue = parseInt(currSpec.substring(currSchema.startIndex, currSchema.endIndex), 10);
     inc > 0 ? ++newValue : --newValue;
     if (newValue < 0) {
        alert(aioGetStr("noDecrement"));
        return;
     }
     newIndex = newValue.toString();
     str = "";
     for (var j = newIndex.length; j < currSchema.selectedLength; ++j) str += "0";
     str += newIndex;
     url = currSpec.substr(0, currSchema.startIndex) + str + currSpec.substr(currSchema.endIndex);
     aioSchemas[i].endIndex = currSchema.startIndex + str.length;
     aioContent.selectedBrowser.loadURI(url);
     return;
  }

  var rv = { };
  openDialog(aioDir + "aioSchemaBuilder.xul", "", "chrome,centerscreen,modal=yes", currSpec, rv);
  if ("key" in rv) {
     aioSchemas[rv.key] = {startIndex: rv.startIndex, endIndex: rv.endIndex, selectedLength: rv.endIndex - rv.startIndex};
     aioIncURL(inc);
  }
}

function aioGesturesPage() {
  aioLinkInTab(aioKGestures + "?" + aioActionString.replace(/\|/g, ",") +
        "&" + aioFuncString.replace(/\|/g, ","), true, false);
}

function aioCopyURLToClipBoard() {
  var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
  if (!str) return;
  str.data = window._content.document.location.href;
  var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
  if (!trans) return;
  trans.addDataFlavor("text/unicode");
  trans.setTransferData("text/unicode", str, str.data.length * 2);
  var clipId = Components.interfaces.nsIClipboard;
  var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipId);
  if (!clip) return;
  clip.setData(trans, null, clipId.kGlobalClipboard);
}

function getElemsByTagNameForAllFrames(frameDoc, tagName) {
  var embeds = [];
  var frames = frameDoc.getElementsByTagName("frame");
  for (var i = 0; i < frames.length; ++ i)
      embeds = embeds.concat(getElemsByTagNameForAllFrames(frames[i].contentDocument, tagName));
  frames = frameDoc.getElementsByTagName("iframe");
  for (i = 0; i < frames.length; ++ i)
      embeds = embeds.concat(getElemsByTagNameForAllFrames(frames[i].contentDocument, tagName));
  var lEmbeds = frameDoc.getElementsByTagName(tagName);
  for (i = 0; i < lEmbeds.length; ++i) embeds.push(lEmbeds[i]);
  return embeds;
}

function aioNukeFlash() {
  var currFlash, height, width, top, next, span, text, view, disp, style;
  var topDocument = aioSrcEvent.target.ownerDocument.defaultView.top.document;
  var embeds = getElemsByTagNameForAllFrames(topDocument, "embed");
  for (var i = 0; i < embeds.length; ++i) {
    currFlash = embeds[i];
    if (currFlash.getAttribute("type") != "application/x-shockwave-flash") continue;
    if (currFlash.parentNode.nodeName.toLowerCase() == "object") {
       top = currFlash.parentNode.parentNode; next = currFlash.parentNode;
    }
    else {
       top = currFlash.parentNode; next = currFlash;
    }
    if (next.previousSibling && next.previousSibling.nodeName.toLowerCase() == "span"
        && next.previousSibling.hasAttribute("aioFlash")) continue;
    view = next.ownerDocument.defaultView;
    width = parseInt(view.getComputedStyle(next, "").getPropertyValue("width"));
    height = parseInt(view.getComputedStyle(next, "").getPropertyValue("height"));
    disp = view.getComputedStyle(next, "").getPropertyValue("display");
    if (height && width) {
       style = next.getAttribute("style") || "";
       next.setAttribute("style", style + "display:none;");
       span = document.createElementNS(xhtmlNS, "span");
       text = document.createTextNode("[" + aioGetStr("g.clickToView") + "]");
       span.appendChild(text);
       top.insertBefore(span, next);
       span.setAttribute("style", "height:" + (height - 2) + "px;width:" + (width - 2) + "px;border:1px solid black;display:-moz-inline-box;");
       span.setAttribute("aioFlash", disp);
       span.addEventListener("click", aioPlayFlash, true);
    }
  }
}

function aioPlayFlash(e) {
  e.currentTarget.removeEventListener("click", aioPlayFlash, true);
  var flashNode = e.currentTarget.nextSibling;
  var disp = e.currentTarget.getAttribute("aioFlash");
  e.currentTarget.parentNode.removeChild(e.currentTarget);
  var style = flashNode.getAttribute("style") || "";
  flashNode.setAttribute("style", style + "display:" + disp + ";");
}

function aioNukeAnything() {
  var node = aioSrcEvent.target;
  if (!node) return;
  var view = node.ownerDocument.defaultView;
  var disp = view.getComputedStyle(node, "").getPropertyValue("display");
  node.setAttribute("aioDisp", "display:" + disp + ";");
  var style = node.getAttribute("style") || "";
  node.setAttribute("style", style + "display:none;");
  aioUndoHide.push(node);
}

function aioUndoNukeAnything() {
  try {
    var node = aioUndoHide.pop();
    if (!node || !node.hasAttribute("aioDisp")) return;
    var style = node.getAttribute("style") || "";
    node.setAttribute("style", style + node.getAttribute("aioDisp"));
  }
  catch(err) {}
}

function aioScrollDocument(relativeScroll, aValue) {
  var scrollObj = aioFindNodeToScroll(aioSrcEvent.target);
  if (scrollObj.scrollType >= 2) return;
  if (relativeScroll) {
     var val = Math.round(scrollObj.realHeight * 0.8 * aValue)
     if (!val) val = aValue;
     if (scrollObj.isXML) aioSrcEvent.view.scrollBy(0, val)
     else scrollObj.nodeToScroll.scrollTop += val;
  }     
  else
     if (scrollObj.isXML) aioSrcEvent.view.scrollTo(0, aValue)
     else scrollObj.nodeToScroll.scrollTop = aValue;
}

function aioSelectionAsURL() {
  var focusedWindow = document.commandDispatcher.focusedWindow;
  var winWrapper = new XPCNativeWrapper(focusedWindow, 'getSelection()');
  var url = winWrapper.getSelection().toString();
  if (!url) return;
  // the following by Ted Mielczarek
  url = url.replace(/\s/g, ""); // Strip any space characters
  url = url.replace(/^[^a-zA-Z]+/, ""); // strip bad leading characters
  url = url.replace(/[\.,\'\"\)\?!>\]]+$/, ""); // strip bad ending characters
  if (!url) return;
  url.replace(/\\/g,"/"); // change \ to /
  if (url.indexOf(".") == -1) return; // can't be valid
  if (url.search(/^\w+:/) == -1) // make sure it has some sort of protocol
     if (url.indexOf("@") == -1) url = "http://" + url;
     else url = "mailto:" + url;
  aioLinkInTab(url, true, false);
}

function aioSelectionAsSearchTerm() {
  var focusedWindow = document.commandDispatcher.focusedWindow;
  var winWrapper = new XPCNativeWrapper(focusedWindow, 'getSelection()');
  var searchStr = winWrapper.getSelection().toString();
  var searchBar = document.getElementById("searchbar");
  if (!searchBar) return;
  searchBar = searchBar.mTextbox;
  if (!searchBar) return;
  searchBar.value = searchStr;
  searchBar.mEnterEvent = null;
  BrowserOpenTab();
  searchBar.onTextEntered();
}

function aioImageResize(s) {
  aioOnImage.removeAttribute("width");
  aioOnImage.removeAttribute("height");
  var style = aioOnImage.getAttribute("style") || "";
  aioOnImage.setAttribute("style", style + s);
}

function aioSetImgSize(aEnlarge, aMixed) {
  if (!aioOnImage) {
     if (!aMixed) return;
     if (aEnlarge) ZoomManager.prototype.getInstance().enlarge();
     else ZoomManager.prototype.getInstance().reduce();
     return;
  }
  var imgStr = aioOnImage.getAttribute("aioImgSize");
  if (!imgStr) {
     var view = aioOnImage.ownerDocument.defaultView;
     var w = parseInt(view.getComputedStyle(aioOnImage, "").getPropertyValue("width"));
     var h = parseInt(view.getComputedStyle(aioOnImage, "").getPropertyValue("height"));
     var imgTab = [];
     imgTab[0] = w; imgTab[1] = h; imgTab[2] = 1;
  }
  else imgTab = imgStr.split("|");
  imgTab[2] *= aEnlarge ? 2 : 0.5;
  aioOnImage.setAttribute("aioImgSize", imgTab.join("|"));
  w = Math.round(imgTab[0] * imgTab[2]); h = Math.round(imgTab[1] * imgTab[2]);
  if (w && h) aioImageResize("width:" + w + "px; height:" + h + "px;");
  else aioResetImgSize(false);
}

function aioResetImgSize(aMixed) {
  if (!aioOnImage) {
     if (!aMixed) return;
     ZoomManager.prototype.getInstance().reset();
     return;
  }
  var imgStr = aioOnImage.getAttribute("aioImgSize");
  if (!imgStr) return;
  var imgTab = imgStr.split("|");
  imgTab[2] = "1";
  aioOnImage.setAttribute("aioImgSize", imgTab.join("|"));
  aioImageResize("width:" + imgTab[0] + "px; height:" + imgTab[1] + "px;");
}

function aioSaveImageAs() {
  if (!aioOnImage) return;
  saveURL(aioOnImage.src, null, "SaveImageTitle", false);
}

function aioCloseCurrTab(lastTabClosesWindow) {
  if (aioRendering.childNodes.length > 1 || !lastTabClosesWindow) aioContent.removeCurrentTab();
  else BrowserCloseWindow();
}

function aioUndoCloseTab() {
  if (typeof(aioContent.undoRemoveTab) == "function") {
     aioContent.undoRemoveTab();
     return;
  }
  if (!aioLastTabInfo.length) return;
  var nbTabs = aioContent.mTabContainer.childNodes.length;
  var lastTabInfo = aioLastTabInfo.pop();
  var lTab = aioContent.addTab();
  aioContent.selectedTab = lTab;
  if (lastTabInfo.hist.count) {
     var history = aioContent.webNavigation.sessionHistory;
     history.QueryInterface(Components.interfaces.nsISHistoryInternal);
     for (var i = 0; i < lastTabInfo.hist.count; ++i)
        history.addEntry(lastTabInfo.hist.getEntryAtIndex(i, false), true);
     aioContent.webNavigation.gotoIndex(lastTabInfo.hist.index);
  }
  if (typeof(aioContent.moveTabTo) != "function" || !lastTabInfo.next) return;
  for (i = 0; i < nbTabs; ++i)
    if (aioContent.mTabContainer.childNodes[i].getAttribute("aioTabId") == lastTabInfo.next) break;
  if (i != nbTabs) aioContent.moveTabTo(lTab, i);
}

function aioGotoLastTab() {
  aioContent.selectedTab = aioContent.mTabContainer.childNodes[aioContent.mTabContainer.childNodes.length - 1];
}

function aioRemoveAllTabsBut() {
  var ltab = aioContent.mCurrentTab;
  if (aioNeverWarnOnCloseOtherTabs) {
     var childNodes = aioContent.mTabContainer.childNodes;
     for (var i = childNodes.length - 1; i >= 0; --i)
       if (childNodes[i] != ltab) aioContent.removeTab(childNodes[i]);
  }
  else aioContent.removeAllTabsBut(ltab);
}

function aioLinkInTab(url, usePref, bg) {
  var tab = aioContent.addTab(url, getReferrer(document));
  var loadInBg = (usePref && (aioPrefRoot.getBoolPref("browser.tabs.loadInBackground") != bg)) || (!usePref && bg);
  if (!loadInBg) aioContent.selectedTab = tab;
}

function aioDupTab() {
  aioLinkInTab(window._content.document.location.href, true, false);
}

function aioOpenInNewTab(bg) {
  if (aioOnLink.length) {
     aioLinkInTab(aioOnLink[0].href, false, bg);
     markLinkVisited(aioOnLink[0].href, aioOnLink[0].node);
  }
  else
     if (!bg) BrowserOpenTab();
     else aioLinkInTab("about:blank", false, true);
}

function aioLinksInTabs() {
  for (var i = 0; i < aioOnLink.length; ++i) {
    aioContent.addTab(aioOnLink[i].href, getReferrer(document));
    markLinkVisited(aioOnLink[i].href, aioOnLink[i].node);
  }
}

function aioLinksInFiles() {
  var hRefLC, dontAskBefore;
  try {dontAskBefore = aioPrefRoot.getBoolPref("browser.download.useDownloadDir");}
  catch(err) {dontAskBefore = false;}
  for (var i = 0; i < aioOnLink.length; ++i) {
    hRefLC = aioOnLink[i].href.toLowerCase();
    if (hRefLC.substr(0, 7) != "mailto:" && hRefLC.substr(0, 11) != "javascript:" &&
        hRefLC.substr(0, 5) != "news:" && hRefLC.substr(0, 6) != "snews:")
       saveURL(aioOnLink[i].href, aioGetTextForTitle(aioOnLink[i].node), null, true, dontAskBefore);
  }
}

function aioNewWindow(url, flag) {
  var handler = Components.classes["@mozilla.org/commandlinehandler/general-startup;1?type=browser"].getService()
                .QueryInterface(Components.interfaces.nsICmdLineHandler);
  var startpage = url || handler.defaultArgs;
  var charsetArg = null;
  if (window._content && window._content.document)
     charsetArg = "charset=" + window._content.document.characterSet;
  return window.openDialog(getBrowserURL(), "_blank", "chrome,all,dialog=no" + flag, startpage, charsetArg);
}

function aioLinksInWindows() {
  if (!aioOnLink.length) return;
  if (aioSingleNewWindow) {
     var hRefTable = [];
     for (var i = 0; i < aioOnLink.length; ++i) {
        hRefTable[i] = aioOnLink[i].href;
        markLinkVisited(aioOnLink[i].href, aioOnLink[i].node);
     }
     aioNewWindow(hRefTable.join("|"), "");
  }
  else
     for (i = 0; i < aioOnLink.length; ++i) {
        aioNewWindow(aioOnLink[i].href, "");
        markLinkVisited(aioOnLink[i].href, aioOnLink[i].node);
     }
}

function aioSetToNormalZ(aWindow) {
  window.focus();
  var treeowner = aWindow.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation)
                     .QueryInterface(Components.interfaces.nsIDocShellTreeItem).treeOwner;
  var xulwin = treeowner.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIXULWindow);
  xulwin.zLevel = xulwin.normalZ;
}

function aioOpenNewWindow(background) {
  var s = background ? ",alwaysLowered" : "";
  if (aioOnLink.length) {
     var win = aioNewWindow(aioOnLink[0].href, s);
     markLinkVisited(aioOnLink[0].href, aioOnLink[0].node);
  }
  else
     if (aioOnImage) win = aioNewWindow(aioOnImage.src, s);
     else win = aioNewWindow("", s);
  if (background) setTimeout(aioSetToNormalZ, 200, win);
}

function aioDupWindow() {
  aioNewWindow(window._content.document.location.href, "");
}

function aioCloseWindow() {
  var numTabs = aioRendering.childNodes.length;
  if (numTabs <= 1 || !aioPrefRoot.getBoolPref("browser.tabs.warnOnClose")) BrowserCloseWindow();
  else if (aioContent.warnAboutClosingTabs(true)) BrowserCloseWindow();
}

function aioDoubleWin() {
  if (!aioOnLink.length) return;
  window.moveTo(0, 0);
  window.resizeTo(screen.availWidth / 2, screen.availHeight);
  aioNewWindow(aioOnLink[0].href, "");
  window.moveTo(screen.availWidth / 2, 0);
  markLinkVisited(aioOnLink[0].href, aioOnLink[0].node);
}

function aioNextPrevLink(next) { // submitted by Christian Kruse
  if (next && document.getElementById("nextPleasePopupMenu")) {
     document.getElementById("nextPleasePopupMenu").doCommand();
     return;
  }
  if (!next && document.getElementById("prevPleasePopupMenu")) {
     document.getElementById("prevPleasePopupMenu").doCommand();
     return;
  }
  var re = [];
  var doc = aioSrcEvent.target.ownerDocument;
  var links = doc.getElementsByTagName("link");
  for (var i = 0; i < links.length; ++i)
    if (links[i].getAttribute("rel") == "next")
       if (links[i].href) {loadURI(links[i].href); return;}
  if (!aioNextsString) return;
  var nextArray = next ? aioNextsString.split("|") : aioPrevsString.split("|");
  for (var j = 0; j < nextArray.length; ++j)
     re[j] = new RegExp(nextArray[j], "i");
  links = doc.links;
  for (j = 0; j < re.length; ++j)
    for (i = 0; i < links.length; ++i)
      if (links[i].textContent && links[i].textContent.search(re[j]) != -1 && links[i].href) {
         loadURI(links[i].href);
         return;
      }
}

function aioFastForward() {
  var sessionH = getWebNavigation().sessionHistory;
  if (sessionH.index < 0 || sessionH.count <= 0) return; // Firefox bug
  if (sessionH.index + 1 < sessionH.count) BrowserForward();
  else aioNextPrevLink(true);
}

function aioHomePage() {
  var homePage = gHomeButton.getHomePage();
  if (!aioGoUpInNewTab) {
     loadOneOrMoreURIs(homePage);
     return;
  }
  var urls = homePage.split("|");
  var firstTabAdded = aioContent.addTab(urls[0]);
  for (var i = 1; i < urls.length; ++i) aioContent.addTab(urls[i]);
  aioContent.selectedTab = firstTabAdded;
  content.focus();
}

function aioUpDir() { // from Stephen Clavering's GoUp
  function getUp(url) {
    var origUrl = url;
    // trim filename (this makes subdriectory digging easier)
    var matches = url.match(/(^.*\/)(.*)/);
    if (!matches) return ""; //only fails if "url" has no /'s
    url = matches[1];
    if (url != origUrl && !/(index|main)\.(php3?|html?)/i.test(url)) return url;
    // dig through subdirs
    matches = url.match(/^([^\/]*?:\/\/.*\/)[^\/]+?\//);
    if (matches) return matches[1];
    // we've reach (ht|f)tp://foo.com/, climb up through subdomains
    // split into protocol and domain
    matches = url.match(/([^:]*:\/\/)?(.*)/);
    var protocol = matches[1];
    var domain = matches[2];
    matches = domain.match(/^[^\.]*\.(.*)/);
    if (matches) return (protocol + matches[1]);
    // nothing found
    return "";
  }
  var url = getUp(window._content.document.location.href);
  if (!url) return;
  if (aioGoUpInNewTab) aioLinkInTab(url, false, false);
  else loadURI(url);
}

function aioRestMaxWin() {
  if (window.windowState == STATE_MAXIMIZED) window.restore();
  else window.maximize();
}

function aioFrameInfo() {
  var targetDoc = aioSrcEvent.target.ownerDocument;
  if (targetDoc.defaultView.frameElement) BrowserPageInfo(targetDoc); // it's a frame
  else BrowserPageInfo();
}

function aioShowHideStatusBar() {
  var bar = document.getElementById("status-bar");
  if (bar) bar.hidden = !bar.hidden;
}

function aioShowHideFindBar() {
   if (document.getElementById("FindToolbar").hidden) onFindCmd();
   else closeFindBar();
}

function aioViewCookies() { //Contributed by Squarefree.com
  if (window._content.document.cookie)
    alert(aioGetStr("cookies") + "\n\n" +
       window._content.document.cookie.replace(/; /g,"\n"));
  else alert(aioGetStr("noCookies"));
}

function aioDeleteCookies() { //Contributed by Squarefree.com
  var d, sl, p, i, cookie;
  var cookieStr = window._content.document.cookie;
  if (!cookieStr) alert(aioGetStr("noCookies"));
  var cookies = cookieStr.split("; ");
  for (d = "." + window._content.document.location.host; d; d = ("" + d).substr(1).match(/\..*$/))
    for (sl = 0; sl < 2; ++sl)
      for (p = "/" + window._content.document.location.pathname; p; p = p.substring(0, p.lastIndexOf('/')))
        for (i in cookies) {
          cookie = cookies[i];
          if (cookie) window._content.document.cookie = cookie + ";domain = " + d.slice(sl) + "; path=" +
                   p.slice(1) + "/" + "; expires=" + new Date((new Date).getTime()-1e11).toGMTString();
        }
}

function aioMetaInfo() {
  var metas, metastr, mymeta;
  metas = window._content.document.getElementsByTagName("meta");
  if (metas.length) {
    metastr = aioGetStr("meta") + "\n\n";
    for (var i = 0; i < metas.length; ++i) {
      mymeta = metas.item(i);
      metastr += "<META ";
      if (mymeta.name) metastr += "name=\"" + mymeta.name + "\" ";
      if (mymeta.httpEquiv) metastr+= "http-equiv=\"" + mymeta.httpEquiv + "\" ";
      if (mymeta.content) metastr += "content=\"" + mymeta.content + "\" ";
      if (mymeta.scheme) metastr += "scheme=\"" + mymeta.scheme + "\" ";
      metastr += ">\n";
    }
    alert(metastr);
  }
  else alert(aioGetStr("noMeta"));
}

function aioActionOnPage(caseNb) { // code by Cusser
  var service, serviceDomain;
  switch(caseNb) {
    case 0: service = "http://validator.w3.org/check?uri=";
            serviceDomain = "validator.w3.org";
            break;
    case 1: service = "http://translate.google.com/translate?prev=/language_tools&u=";
            serviceDomain = "translate.google.com";
  }
  var targetURI = getWebNavigation().currentURI.spec; 
  if (targetURI.indexOf(serviceDomain) >= 0) BrowserReload(); // already activated
  else loadURI(encodeURI(service + targetURI));
}

function aioOpenAioOptions() {
  window.openDialog(aioDir + "pref/aioOptions.xul", "", "chrome,dialog,modal,resizable");
}

function aioOpenBookmarksManager() {
  toOpenWindowByType("bookmarks:manager",
                     "chrome://browser/content/bookmarks/bookmarksManager.xul");
}

function aioOpenDownloadManager() {
  toOpenWindowByType("Download:Manager",
                     "chrome://mozapps/content/downloads/downloads.xul",
                     "chrome,dialog=no,resizable");
}


