var getFileSizeService=
{
  channel:null,
  fullheader:null,
  realcount:0,
  stringbundle:null,
  request: function()
  {
    var SBService = Components.classes["@mozilla.org/intl/stringbundle;1"]
          .getService(Components.interfaces.nsIStringBundleService);
    this.stringbundle=SBService.createBundle("chrome://getfilesize/locale/getfilesize.properties");
    this.fullheader=document.getElementById("link-httpheader-text");
    var target=document.getElementById("link-url-text");
    if(!target || !target.value) return false;
    try{
      var uri=Components.classes["@mozilla.org/network/standard-url;1"]
            .createInstance(Components.interfaces.nsIURI);
      uri.spec = target.value;
      if(!uri.scheme || uri.scheme.toUpperCase() !="HTTP") return false;
      var ioService = Components.classes["@mozilla.org/network/io-service;1"]
            .getService(Components.interfaces.nsIIOService);
      this.channel = ioService.newChannelFromURI(uri)
            .QueryInterface(Components.interfaces.nsIHttpChannel);
      this.channel.requestMethod="HEAD";
      var referer=window.arguments[0].ownerDocument.defaultView.location.href;
      if(nsPreferences.getIntPref("network.http.sendRefererHeader",2)>1)
        this.channel.setRequestHeader('Referer',referer, null);
      this.channel.visitRequestHeaders(this);
      this.channel.loadFlags |=  1 | 128;
      this.channel.asyncOpen(this,null);
      return true;
    }catch(e){}
    return false;
  },
  visitHeader :function(header , value )
  {
    this.fullheader.value += header + ": " + value +"\n";
    if(header =="Content-Length") this.formatSize(value);
    else if(header =="Last-Modified") this.formatDate(value);
    else if(header =="Content-Type") this.formatType(value);
  },
  formatSize :function(size)
  {
    var intsize = parseInt(size);
    var textsize="";
    if(intsize >1024*1024*1024)
    {
      textsize= ((intsize+0.1)/(1024*1024*1024)).toString();
      textsize=textsize.split(/\./)[0]+"."+textsize.split(/\./)[1].slice(0,2);
      textsize=this.stringbundle.formatStringFromName ("gigabytes",[textsize,size],2);
    }
    else if(intsize >1024*1024)
    {
      textsize= ((intsize+0.1)/(1024*1024)).toString();
      textsize=textsize.split(/\./)[0]+"."+textsize.split(/\./)[1].slice(0,2);
      textsize=this.stringbundle.formatStringFromName ("megabytes",[textsize,size],2);
    }
    else if(intsize>512)
    {
      textsize= ((intsize+0.1)/(1024)).toString();
      textsize=textsize.split(/\./)[0]+"."+textsize.split(/\./)[1].slice(0,2);
      textsize=this.stringbundle.formatStringFromName ("kilobytes",[textsize,size],2);
    }
    else
    {
      textsize=this.stringbundle.formatStringFromName ("bytes",[size],1);
    }
    document.getElementById("link-httpsize-text").value=textsize;
  },
  formatDate :function(str)
  {
    var lastMod=new Date();
    lastMod.setTime(Date.parse(str));
    document.getElementById("link-httpdate-text").value=lastMod.toLocaleString();
  },
  formatType :function(str)
  {
    document.getElementById("link-httptype-text").value=str;
  },

  fillInBlank :function()
  {
    var target=document.getElementById("link-httpsize-text");
    var missing=this.stringbundle.GetStringFromName("missing");
    if(!target.value)
    {
/*      try{
        this.channel.QueryInterface(Components.interfaces.nsICachingChannel);
        if(this.channel.isFromCache())
          alert(this.channel);
      }catch(e){alert(e)}
*/
      target.value = missing;
      target.setAttribute("style","font-style:italic");
    }

    target=document.getElementById("link-httptype-text");
    if(!target.value)
    {
      target.value = missing;
      target.setAttribute("style","font-style:italic");
    }

    target=document.getElementById("link-httpdate-text");
    if(!target.value)
    {
      target.value = missing;
      target.setAttribute("style","font-style:italic");
    }
  },

  onDataAvailable: function (request, ctxt, input, offset, count)
  {
    this.realcount +=count;
    var bInput=Components.classes["@mozilla.org/binaryinputstream;1"]
            .createInstance(Components.interfaces.nsIBinaryInputStream);
    bInput.setInputStream(input);
    this.fullheader.value +=bInput.readBytes(count);
  },

    onStartRequest: function (request, ctxt)
  {
    request.QueryInterface(Components.interfaces.nsIHttpChannel);
    this.fullheader.value +="\n"+"Status: "+request.responseStatus.toString()+"\n";
    request.visitResponseHeaders(this);
    request.cancel(0);
    this.fillInBlank();
  },
  onStopRequest: function (request, ctxt, status)
  {
    if(this.realcount>0)
      this.formatSize(this.realcount.toString());
  }
};

function getFileSizeInitialize()
{
  if(!nsPreferences.getBoolPref("extensions.extendedlink.showhttpheader",false))
    document.getElementById("link-httpheader").setAttribute("hidden","true");
  if(!getFileSizeService.request())
    document.getElementById("link-getfilesize").setAttribute("hidden","true");
}

window.addEventListener("load",getFileSizeInitialize,false);
