var imageToolbarBackupBlocker, imageToolbarReset;
var imageToolbarMinArea, imageToolbarDelayTime, imageToolbarOffsetX, imageToolbarOffsetY, imageToolbarOverrideSize;
var imageToolbarToolbar;
var imageToolbarCurrentImage = null;
var imageToolbarRelativeToMouse;
var imageToolbarMouseY, imageToolbarMouseX;
var delayImageToolbarPopup;
var imageToolbarFolder;
var imageToolbarArray = new Array();
var imageToolbarPrefs;
var imageToolbarSaveDelay;
var imageToolbarSaveButton, imageToolbarCopyButton, imageToolbarPrintButton, imageToolbarMailButton, imageToolbarFolderButton;
var imageToolbarTempWindow;
var imageToolbarPreviousTab, imageToolbarNewTab;

var filepickerCID = '@mozilla.org/filepicker;1';
var filepickerIID = Components.interfaces.nsIFilePicker;

var supportstrCID = '@mozilla.org/supports-string;1';
var supportstrIID = Components.interfaces.nsISupportsString;

var fileCID       = '@mozilla.org/file/local;1';
var fileIID       = Components.interfaces.nsILocalFile;

var urifixCID     = '@mozilla.org/docshell/urifixup;1';
var urifixIID     = Components.interfaces.nsIURIFixup;

var persistCID    = '@mozilla.org/embedding/browser/nsWebBrowserPersist;1';
var persistIID    = Components.interfaces.nsIWebBrowserPersist;

function getDownloadsFolder(aFolder) {

  var fileLocator = Components.classes["@mozilla.org/file/directory_service;1"]
                      .getService(Components.interfaces.nsIProperties);
  
  var dir = fileLocator.get(getSpecialFolderKey(aFolder), Components.interfaces.nsILocalFile);
  
  return dir;
  
}

function imageToolbarBlocker(targ)
{
  return true;
}

function getSpecialFolderKey(aFolderType) {

  return aFolderType == "Desktop" ? "DeskP" : "Pers";
  return "Home";
  
}

function imageToolbarInit() {
  
  imageToolbarPrefs = Components.classes["@mozilla.org/preferences-service;1"]
                      .getService(Components.interfaces.nsIPrefService)
                      .getBranch("imagetoolbar.");

  var pref =         Components.classes["@mozilla.org/preferences-service;1"]
                     .getService(Components.interfaces.nsIPrefService)
                     .getBranch("browser.download.");
                            
  var defaultFolder;
  const nsIFilePicker = Components.interfaces.nsIFilePicker;
  const nsILocalFile = Components.interfaces.nsILocalFile;

  if (!imageToolbarPrefs.prefHasUserValue("imageFolder")) {
  
    if (!pref.prefHasUserValue("dir")) {
    
      defaultFolder = getDownloadsFolder("Desktop");
      imageToolbarPrefs.setComplexValue("imageFolder", nsILocalFile, defaultFolder);
      
    }
    
    else { 
    
      defaultFolder = pref.getComplexValue("dir", nsILocalFile);
      imageToolbarPrefs.setComplexValue("imageFolder", nsILocalFile, defaultFolder);
      
    }
                            
  }
  
  if (!imageToolbarPrefs.prefHasUserValue("minHeight")) imageToolbarPrefs.setIntPref("minHeight",200);
  if (!imageToolbarPrefs.prefHasUserValue("minWidth")) imageToolbarPrefs.setIntPref("minWidth",200);
  if (!imageToolbarPrefs.prefHasUserValue("popupDelay")) imageToolbarPrefs.setIntPref("popupDelay",500);
  if (!imageToolbarPrefs.prefHasUserValue("ctrlOverrideSize")) imageToolbarPrefs.setBoolPref("ctrlOverrideSize",true)
  if (!imageToolbarPrefs.prefHasUserValue("offsetX")) imageToolbarPrefs.setIntPref("offsetX",10);
  if (!imageToolbarPrefs.prefHasUserValue("offsetY")) imageToolbarPrefs.setIntPref("offsetY",10);
  if (!imageToolbarPrefs.prefHasUserValue("buttonArray")) imageToolbarPrefs.setCharPref("buttonArray","0,0,0,0,0");
  if (!imageToolbarPrefs.prefHasUserValue("display.save")) imageToolbarPrefs.setBoolPref("display.save",true);
  if (!imageToolbarPrefs.prefHasUserValue("display.copy")) imageToolbarPrefs.setBoolPref("display.copy",true);
  if (!imageToolbarPrefs.prefHasUserValue("display.print")) imageToolbarPrefs.setBoolPref("display.print",false);  
  if (!imageToolbarPrefs.prefHasUserValue("display.mail")) imageToolbarPrefs.setBoolPref("display.mail",false);
  if (!imageToolbarPrefs.prefHasUserValue("display.folder")) imageToolbarPrefs.setBoolPref("display.folder",true);
  if (!imageToolbarPrefs.prefHasUserValue("display.relativeToMouse")) imageToolbarPrefs.setBoolPref("display.relativeToMouse",false);
  if (!imageToolbarPrefs.prefHasUserValue("extensionsToIgnore")) imageToolbarPrefs.setCharPref("extensionsToIgnore","");
  if (!imageToolbarPrefs.prefHasUserValue("display.smallIcons")) imageToolbarPrefs.setBoolPref("display.smallIcons",false);
  if (!imageToolbarPrefs.prefHasUserValue("overwrite")) imageToolbarPrefs.setBoolPref("overwrite",false);
  if (!imageToolbarPrefs.prefHasUserValue("altButton")) imageToolbarPrefs.setIntPref("altButton",1);
  if (!imageToolbarPrefs.prefHasUserValue("promptFilenameIncrement")) imageToolbarPrefs.setBoolPref("promptFilenameIncrement",true);
  if (!imageToolbarPrefs.prefHasUserValue("rememberLastFolder")) imageToolbarPrefs.setBoolPref("rememberLastFolder",true);
  
  window.addEventListener("mouseover", imageToolbarEnabledCheck, false);  // Check for frames, etc
  if (gBrowser) gBrowser.mTabBox.addEventListener("select",imageToolbarEnabledCheck, false); // Check on tab selection
  imageToolbarEnabledCheck();

}

function imageToolbarSelectFolder() { 

  // Function derived from selectFolder() in pref-download.js

  const nsIFilePicker = Components.interfaces.nsIFilePicker;
  const nsILocalFile = Components.interfaces.nsILocalFile;
  
  var fp = Components.classes["@mozilla.org/filepicker;1"]
           .createInstance(nsIFilePicker);

  try {
  
    var initialDir = imageToolbarFolder;
    if (initialDir) fp.displayDirectory = initialDir;
     
  }
  
  catch (ex) {
  
    // ignore exception: file picker will open at default location
    
  }

  fp.init(window, "Choose Directory", nsIFilePicker.modeGetFolder);
  fp.appendFilters(nsIFilePicker.filterAll);
  
  var ret = fp.show();

  if (ret == nsIFilePicker.returnOK) {
  
    var localFile = fp.file.QueryInterface(nsILocalFile);

    imageToolbarPrefs.setComplexValue("imageFolder", nsILocalFile, localFile);
    imageToolbarFolder = imageToolbarPrefs.getComplexValue("imageFolder", nsILocalFile);
    
    return true;
    
  }
  
  else {
  
    return false;
  
  }
    
}

function imageToolbarEnabledCheck(e) {

  if (!e) var e = window.event;
  if (!e) {
  
    try {
  
      imageToolbarEnable(document.commandDispatcher.focusedWindow.document);
      
    }
    
    catch (e) {}
  
  }
  
  else if (e.target) {
  
    // Can't seem to assign the attribute to ownerDocument, so just attaching it to the first child
    // since it doesn't really matter, as long as its attached to something. Theoretically there should
    // never be a document without a first child, and if there is - it really doesn't matter whether this
    // triggers correctly or not.
    
    try {

      if (e.target.ownerDocument.firstChild.getAttribute("imageToolbarEnabled")) return;
      if (!e.target.ownerDocument.firstChild.getAttribute("imageToolbarEnabled")) {
    
        if (!e.target.ownerDocument.images) return;
          
      }

    e.target.ownerDocument.firstChild.setAttribute("imageToolbarEnabled","true");
    imageToolbarEnable(e.target.ownerDocument);
      
    }
  
    catch (e) {}
    
  }
  
}

function imageToolbarEnable(targetDoc) {

  try { var theimages = targetDoc.images; }
  catch (e) {}
  
  if (!theimages)
    return;
    
  try {
    var documentHead = targetDoc.getElementsByTagName("head")[0];
    if (documentHead) {
      for (var i=0; i < documentHead.childNodes.length; i++) {
        if (documentHead.childNodes[i].nodeName.toLowerCase() == "meta"
        && documentHead.childNodes[i].httpEquiv.toLowerCase() == "imagetoolbar"
        && (documentHead.childNodes[i].content.toLowerCase() == "false"
        || documentHead.childNodes[i].content.toLowerCase() == "no")) {
        
          try {
            targetDoc.firstChild.setAttribute("imageToolbarMetaDisabled","true");
          }
          catch (e) {}
          break;
          
        }
      }
    }
  }
  
  catch (e) {}
  
  for (var index = 0; index < theimages.length; index++) {
    var img = theimages[index];
    img.addEventListener("mouseover",imageToolbarMouseoverHandler,false);
    img.addEventListener("focus",imageToolbarMouseoverHandler,false);
    img.addEventListener("mouseout",imageToolbarClose,false);
    var imageArea = img.height * img.width;
    img.setAttribute("area",imageArea);
  }

  return false;
  
}

function imageToolbarCreate() {

  imageToolbarSaveButton = imageToolbarPrefs.getBoolPref("display.save");
  imageToolbarCopyButton = imageToolbarPrefs.getBoolPref("display.copy");
  imageToolbarMailButton = imageToolbarPrefs.getBoolPref("display.mail");
  imageToolbarPrintButton = imageToolbarPrefs.getBoolPref("display.print");
  imageToolbarFolderButton = imageToolbarPrefs.getBoolPref("display.folder");
  
  imageToolbarToolbar = imageToolbarCurrentImage.ownerDocument.createElementNS("http://www.w3.org/1999/xhtml", "div");
  
  imageToolbarToolbar.style.cssFloat = "left";
  imageToolbarToolbar.style.display = "none";
  imageToolbarToolbar.style.border = "none";
  imageToolbarToolbar.style.padding = "0px";
  imageToolbarToolbar.style.position = "absolute";  
  imageToolbarToolbar.style.top = "0px";
  imageToolbarToolbar.style.left = "0px";
  imageToolbarToolbar.style.zIndex = "100"; // should make it appear on some more sites   
  imageToolbarToolbar.setAttribute("id","mozilla-image-toolbar-div");
  
  var toolbar = document.getElementById("mozilla-image-toolbar");
  
  var toolbarcopy = toolbar.cloneNode(true);
  toolbarcopy.setAttribute("hidden","false");
  
  imageToolbarToolbar.addEventListener("mouseout",imageToolbarClose,false);
  imageToolbarToolbar.appendChild(toolbarcopy);
  
  try {
  
    imageToolbarCurrentImage.ownerDocument.body.appendChild(imageToolbarToolbar);
  
  }
  
  catch (e) {}
  
  var saveButton = imageToolbarCurrentImage.ownerDocument.getElementById("imageToolbarSaveImage");
  var copyButton = imageToolbarCurrentImage.ownerDocument.getElementById("imageToolbarCopyImage");
  var mailButton = imageToolbarCurrentImage.ownerDocument.getElementById("imageToolbarEmailImage");
  var printButton = imageToolbarCurrentImage.ownerDocument.getElementById("imageToolbarPrintImage");
  var folderButton = imageToolbarCurrentImage.ownerDocument.getElementById("imageToolbarOpenFolder");

  saveButton.addEventListener("click",imageToolbarSaveImage,true);
  if (imageToolbarSaveButton == false) saveButton.style.display = "none";
  
  copyButton.addEventListener("click",imageToolbarCopyImage,false);
  if (imageToolbarCopyButton == false) copyButton.style.display = "none";
    
  mailButton.addEventListener("click",imageToolbarMailImage,false);
  if (imageToolbarMailButton == false) mailButton.style.display = "none";
    
  printButton.addEventListener("click",imageToolbarPrintImage,false);
  if (imageToolbarPrintButton == false) printButton.style.display = "none";
    
  folderButton.addEventListener("click",imageToolbarFolderOpen,false);
  if (imageToolbarFolderButton == false) folderButton.style.display = "none";
  
  var defaultStylesheet = imageToolbarCurrentImage.ownerDocument.createElementNS("http://www.w3.org/1999/xhtml", "link");
  defaultStylesheet.setAttribute("rel","stylesheet");
  defaultStylesheet.setAttribute("type","text/css");
  defaultStylesheet.setAttribute("href","chrome://imagetoolbar/content/imagetoolbar.css");
  
  if (imageToolbarPrefs.prefHasUserValue("display.defaultskin")) var useDefaultPref = imageToolbarPrefs.getBoolPref("display.defaultskin");

  if (!useDefaultPref || useDefaultPref == false) {

    var customStylesheet = imageToolbarCurrentImage.ownerDocument.createElementNS("http://www.w3.org/1999/xhtml", "link");
    customStylesheet.setAttribute("rel","stylesheet");
    customStylesheet.setAttribute("type","text/css");  
    customStylesheet.setAttribute("href","chrome://browser/skin/imagetoolbar.css");
    
  }  
    
  try {
  
    imageToolbarCurrentImage.ownerDocument.body.appendChild(defaultStylesheet);
    if (!useDefaultPref || useDefaultPref == false) imageToolbarCurrentImage.ownerDocument.body.appendChild(customStylesheet);
      
  }
  
  catch (e) {}
    
}

function savePrompt(url, savefile, filename, autoLocation) {

  const nsILocalFile = Components.interfaces.nsILocalFile;
  var fp = Components.classes[filepickerCID].createInstance(filepickerIID);
  var bundle = document.getElementById("imageToolbarStrings");
  var saveImageTitle = bundle.getString("savetitle");
  
  var i = 1;
  var newFilename = filename;
  var ext = filename.substring(filename.lastIndexOf('.'),filename.length);

  if (savefile.exists() && imageToolbarPrefs.getBoolPref("promptFilenameIncrement"))
  {
    while (savefile.exists())
    {
      if (filename.indexOf('.') != -1) {
    
        var file = filename.substring(0,filename.length-ext.length);
        newFilename = file + "-" + i + ext;
          
        if (!autoLocation)  
          savefile = imageToolbarPrefs.getComplexValue("imageFolder", nsILocalFile); 
        else
          savefile.initWithPath(autoLocation);
        savefile.appendRelativePath(newFilename);
          
        i++;
      
      } 
    }
  }

  fp.init(window, saveImageTitle, 1); // 1 for modeSave
   
  if (autoLocation)
  {
    var temp = imageToolbarFolder;
    temp.initWithPath(autoLocation);
    fp.displayDirectory = temp;
  }
  else
  {
    if (imageToolbarPrefs.getBoolPref("rememberLastFolder") == true)
      fp.displayDirectory = imageToolbarFolder;
      /*
        This is the ugliest hack I've ever done, but will be properly seen to in IT0.6
        It simply breaks the filepicker by giving it a filename for the folder to display
        and errors out, using the last used folder to fall back on.
      */
    else
      fp.displayDirectory = imageToolbarFolder.parent;
  }
    
  fp.defaultString = newFilename;

  fp.appendFilters(8); // images only
   
  if (fp.show() == 0) {
  
    var newPath;
    if (fp.file.path.indexOf(ext) != newFilename.length) {
      newPath = fp.file.path + ext;
    }
    else
      newPath = fp.file.path;
      
    var stripExt = newPath.substring(0,newPath.length-ext.length);
    
    if (stripExt.substring(stripExt.lastIndexOf("."),stripExt.length) == ".jpg" ||
      stripExt.substring(stripExt.lastIndexOf("."),stripExt.length) == ".jpeg" ||
      stripExt.substring(stripExt.lastIndexOf("."),stripExt.length) == ".bmp" ||
      stripExt.substring(stripExt.lastIndexOf("."),stripExt.length) == ".png" ||
      stripExt.substring(stripExt.lastIndexOf("."),stripExt.length) == ".gif" ||
      stripExt.substring(stripExt.lastIndexOf("."),stripExt.length) == ".mng")
      {
        newPath = stripExt;
      }

    savefile.initWithPath(newPath);
    saveURL(url, savefile, null, false, true);
    
  }

}

function imageToolbarButtonAction(aEvent,aPref) {

  var altButton = imageToolbarPrefs.getIntPref("altButton");
  
  if (aEvent.button == 2)
    aEvent.preventDefault();

  if (aPref == "0") {
    
    if (aEvent.ctrlKey || aEvent.button == altButton)
      return false;
    else
      return true;
    
  }
  
  else {
  
    if (aEvent.ctrlKey || aEvent.button == altButton)
      return true;
    else
      return false;
  
  }

}

function imageToolbarSaveImage(e) {
  
  // function by MonkeeSage, modified by Cusser
  
  if (!e) var e = window.event;
  document.popupNode = imageToolbarCurrentImage;
   
  var url      = imageToolbarCurrentImage.src; // convenience variable
  var filename = url.substring(url.lastIndexOf('/') + 1)
  
  if (url.indexOf("?") != -1 && url.indexOf("=") != -1) {
  
    // sniff the real filename from the headers...
    var httpRequest = new XMLHttpRequest();
    
    httpRequest.open('GET', url, false); // syncronous transfer
    httpRequest.overrideMimeType('text/xml'); // prevent leakage
    httpRequest.send(null);
    
    // data comes after send for sync'd GET, no callbacks needed...
    try {
    
      var fname = httpRequest.getResponseHeader('content-disposition');
      if (fname) {
         if (/filename="?([^";]+)"?/.test(fname)) {
            fname = RegExp.$1;
         }
         else {
            delete fname;
         }
      }
      else {
         fname = httpRequest.getResponseHeader('content-location');
      }
    
      if (fname) {
         filename = fname;
      }
      
    }
    
    catch(e) {
    
      // foobar! using default filename...
    
    }
    
  }
  
  const nsILocalFile = Components.interfaces.nsILocalFile;
  imageToolbarFolder = imageToolbarPrefs.getComplexValue("imageFolder", nsILocalFile);  
  var savefile = imageToolbarFolder;
  
  if (!savefile.exists()) {
  
    var bundle = document.getElementById("imageToolbarStrings");
    var nofolder = bundle.getString("nofolder");
  
    alert(nofolder);
    var success = imageToolbarSelectFolder();
    if (success == false) return;
  
  }
  
  savefile.appendRelativePath(filename);
  
  var overwrite = imageToolbarPrefs.getBoolPref("overwrite");
    
  if (imageToolbarButtonAction(e,imageToolbarArray[0]) == false) {
    
    if (!imageToolbarSaveDelay) {
    
      imageToolbarSaveDelay = true;
        
      if (savefile.exists() && overwrite == false)
  	    savefile.createUnique(0, 0777);
      
      try {
        // Support for Download Sort
        if (ds_getTargetFile) {
          saveURL(url, null, null, false, true);
          window.setTimeout("imageToolbarSaveDelay = false",250);
          return;
        }
      }
      catch (e) {} 
      
      // If Download Sort is not enabled, use default method
      saveURL(url, savefile, null, false, true);
      window.setTimeout("imageToolbarSaveDelay = false",250);
      
    }
  
  }
  
  else {
  
    // Save prompt
    
    var ext = filename.substring(filename.lastIndexOf('.'),filename.length);
    
    /* Download Sort code duplicated to provide adequate support */
    try {
      var foundExt = checkForExtension(ext); // Returns -1 if not found
      if (foundExt != -1) {
        var aSource = ds_RDF.GetResource("NC:ExtensionRoot:" + ext);
        var locRDF = ds_RDF.GetResource("http://home.netscape.com/NC-rdf#location");
        var autoLocation = ds_datasource.GetTarget(aSource, locRDF, true);
        autoLocation = autoLocation.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
      }
    }
    catch (e) {}
    
    if (autoLocation)
    {
      savefile.initWithPath(autoLocation);
      savefile.appendRelativePath(filename);
    }
    savePrompt(url, savefile, filename, autoLocation);
  
  }
  
}

function imageToolbarCopyImage(e) {

  if (!e) var e = window.event;
  document.popupNode = imageToolbarCurrentImage;
  
  if (imageToolbarButtonAction(e,imageToolbarArray[1]) == false) {
    goDoCommand('cmd_copyImageContents');
    
  }    

  else {
    
    goDoCommand('cmd_copyImageLocation');
    
  }
     
}

function imageToolbarMailImage(e) {

  if (imageToolbarButtonAction(e,imageToolbarArray[2]) == false) {   
  }
  
  else {
    
    var mailSubject = "" // Changable pref
    sendLink(imageToolbarCurrentImage.src, mailSubject);
    
  }
  
}

function imageToolbarPrintImage(e) {

  // Print Preview
  imageToolbarPreviousTab = window.getBrowser().selectedTab;
  imageToolbarNewTab = getBrowser().addTab(imageToolbarCurrentImage.src);
  // imageToolbarNewTab.style.visibility = "hidden";
  // Uncomment when there's support for checking for printers.
  window.getBrowser().selectedTab = imageToolbarNewTab;
  PrintUtils.printPreview(onEnterPrintPreview, imageToolbarExitPP);
    
}

function imageToolbarExitPP () {

  try {
    onExitPrintPreview();
  }
  catch (e) {
    // foobar
  }
  
  window.getBrowser().removeTab(window.getBrowser().selectedTab);
  window.getBrowser().selectedTab = imageToolbarPreviousTab;

}

function imageToolbarFolderOpen(e) {

  var folder = imageToolbarFolder;

  if (imageToolbarButtonAction(e,imageToolbarArray[4]) == false) {
    var success = imageToolbarSelectFolder();
    if (success == false) return;
    
  }
  
  else {
  
    if (folder.exists()) folder.reveal();
    
    else {
      
      var bundle = document.getElementById("imageToolbarStrings");
      var nofolder = bundle.getString("nofolder");
    
      alert(nofolder);
      var success = imageToolbarSelectFolder();
      if (success == false) return;
      folder.reveal();
      
    }
  
  }
      
}

function imageToolbarClose(e) {

  if (delayImageToolbarPopup) window.clearTimeout(delayImageToolbarPopup);

  var targ;
  if (!e) var e = window.event;
  if (e.relatedTarget) targ = e.relatedTarget;
  
  if (targ == imageToolbarCurrentImage) return false;
  
  if (targ) var targClass = targ.getAttribute("class");
  
  if (targClass) {
  
    if (targ.getAttribute("class") == "mozilla-image-toolbar") return false;
    else if (targ.getAttribute("class") == "toolbar-primary chromeclass-toolbar") return false;
    
  }
  
  if (imageToolbarToolbar) imageToolbarToolbar.style.display = "none";
  imageToolbarCurrentImage = null;
  
  if (imageToolbarRelativeToMouse == true) {
  
    try { 
    
      window.removeEventListener("mousemove",imageToolbarCoords,false);
      
    }
    
    catch (e) {}
    
  }
  
  if (imageToolbarReset == "false") {
  
    gBrowser.mCurrentBrowser.isAutoscrollBlocker = imageToolbarBackupBlocker;
    imageToolbarReset = "true";
    
  }
  
  return false;
  
}

function imageToolbarMouseoverHandler(e) {

  var targ, link = false;
  if (!e) var e = window.event;
  if (e.target) targ = e.target;
  
  // Clicking an image link gives focus, thus revealing the toolbar
  // Therefore I've checked for hyperlinked images and prevents
  // the toolbar from showing if one is found.
  
  node = targ;
  for (var i=0; i<=3; i++)
  {
    if (node.parentNode)
    {
      if (e.target.parentNode.tagName.toUpperCase() == "A")
        link = true;
      node = node.parentNode;
    }
  }
  
  if (e.type == "focus" && link == true)
    return false;
  
  if (e.relatedTarget) {
    var oldTarg = e.relatedTarget;
    if (oldTarg.tagName.toLowerCase() == "toolbar" || oldTarg.tagName.toLowerCase() == "toolbarbutton")
      return false;
  }

  imageToolbarMinArea = imageToolbarPrefs.getIntPref("minHeight") * imageToolbarPrefs.getIntPref("minWidth");;
  imageToolbarDelayTime = imageToolbarPrefs.getIntPref("popupDelay");
  imageToolbarOverrideSize = imageToolbarPrefs.getBoolPref("ctrlOverrideSize");
  imageToolbarRelativeToMouse = imageToolbarPrefs.getBoolPref("display.relativeToMouse");

  if ((e.ctrlKey == false) || (imageToolbarOverrideSize == false)) {

    if (targ.getAttribute("area") < imageToolbarMinArea) {
    
      if (imageToolbarToolbar) { 
      
        imageToolbarToolbar.style.display = "none";
        imageToolbarCurrentImage=null;
        
      }
      
      return false;
    
    }
    
    else {
    
      var extensions = imageToolbarPrefs.getCharPref('extensionsToIgnore');
      
      if (extensions.length > 0) {
      
        extensions = extensions.toLowerCase();
        extensions = extensions.split(' ');

        for (var l = 0; l < extensions.length; l++) {
  
          var testExt = new RegExp('\\.' + extensions[l], 'i'); 
          var targSrc = targ.src.substring(targ.src.indexOf("."),targ.src.length);
    
          if (testExt.test(targSrc)) return false;

        }
        
      }
      
    }
  
  }
  
  if (delayImageToolbarPopup) window.clearTimeout(delayImageToolbarPopup);
  
  imageToolbarCurrentImage = targ;
  
  var testToolbar;
  
  try {
    testToolbar = imageToolbarCurrentImage.ownerDocument.getElementById("mozilla-image-toolbar-div");
  }
  catch (e) {}
  
  if (!testToolbar) imageToolbarCreate();
  
  if (e.ctrlKey == true) showImageToolbar();
  else delayImageToolbarPopup = window.setTimeout(showImageToolbar,imageToolbarDelayTime);
  
  if (imageToolbarRelativeToMouse == true) window.addEventListener("mousemove",imageToolbarCoords,false);
  
  return;

}

function getPosition(elm, side) {
   var pos, pElm;
   side = side.substring(0, 1).toUpperCase() + side.substring(1);
   eval('pos = elm.offset' + side);
   pElm = elm.offsetParent;
   while (pElm) {
      eval('pos += pElm.offset' + side);
      pElm = pElm.offsetParent;
   }
   return pos;
}

function imageToolbarCoords(e) {

  imageToolbarMouseX = e.clientX;
  imageToolbarMouseY = e.clientY;

}

function showImageToolbar() {

  var overrideMeta = "null";
  var isMap = false;
  var imageToolbarMetaDisabled = false;
  
  try {
    imageToolbarMetaDisabled = imageToolbarCurrentImage.ownerDocument.firstChild.getAttribute("imageToolbarMetaDisabled");
  }
  catch (e) {}
  
  try {
    if (imageToolbarCurrentImage.getAttribute("usemap") || imageToolbarCurrentImage.getAttribute("ismap"))
      isMap = true;
  }
  catch (e) {}
  
  try {
    if (!imageToolbarCurrentImage.getAttribute("galleryimg"))
      overrideMeta = "null"
    else if (imageToolbarCurrentImage.getAttribute("galleryimg") == "false" || imageToolbarCurrentImage.getAttribute("galleryimg") == "no")
      overrideMeta = "hide";
    else if (imageToolbarCurrentImage.getAttribute("galleryimg") == "true" || imageToolbarCurrentImage.getAttribute("galleryimg") == "yes")
      overrideMeta = "show";
  }
  catch (e) {}
  
  if (isMap == true && overrideMeta != "show")
    return;

  if (overrideMeta == "hide")
    return;
    
  if (imageToolbarMetaDisabled && overrideMeta != "show")
    return;

  const nsILocalFile = Components.interfaces.nsILocalFile;
  imageToolbarOffsetX = imageToolbarPrefs.getIntPref("offsetX");
  imageToolbarOffsetY = imageToolbarPrefs.getIntPref("offsetY");
  imageToolbarFolder = imageToolbarPrefs.getComplexValue("imageFolder", nsILocalFile);
  imageToolbarArray = imageToolbarPrefs.getCharPref("buttonArray").split(",");

  if (imageToolbarReset != "false") {

    imageToolbarBackupBlocker = gBrowser.mCurrentBrowser.isAutoscrollBlocker;
    gBrowser.mCurrentBrowser.isAutoscrollBlocker = imageToolbarBlocker;
    imageToolbarReset = "false";
    
  }

  imageToolbarToolbar = imageToolbarCurrentImage.ownerDocument.getElementById("mozilla-image-toolbar-div");
  
  var useSmallIcons = imageToolbarPrefs.getBoolPref("display.smallIcons");
  if (useSmallIcons)
    imageToolbarToolbar.firstChild.firstChild.setAttribute("iconsize","small");

  var leftBorder = imageToolbarCurrentImage.ownerDocument.defaultView.getComputedStyle(imageToolbarCurrentImage,null).getPropertyValue("border-left-width");
  var topBorder = imageToolbarCurrentImage.ownerDocument.defaultView.getComputedStyle(imageToolbarCurrentImage,null).getPropertyValue("border-top-width");
  var leftPadding = imageToolbarCurrentImage.ownerDocument.defaultView.getComputedStyle(imageToolbarCurrentImage,null).getPropertyValue("padding-left");
  var topPadding = imageToolbarCurrentImage.ownerDocument.defaultView.getComputedStyle(imageToolbarCurrentImage,null).getPropertyValue("padding-top");  
  
  function trimPx(string) {      
        
    return parseFloat(string);
      
  }
  
  leftBorder = trimPx(leftBorder);
  topBorder = trimPx(topBorder);
  leftPadding = trimPx(leftPadding);  
  topPadding = trimPx(topPadding);

  var mx, my;
  
  if (imageToolbarRelativeToMouse == true) {
  
    try {
    
      window.removeEventListener("mousemove",imageToolbarCoords,false);
      
    }
    
    catch (e) {}
  
    mx = imageToolbarMouseX;
    my = imageToolbarMouseY;
  
  }
  
  else {
  
    mx = getPosition(imageToolbarCurrentImage,"left") + leftPadding + leftBorder + imageToolbarOffsetX;
    my = getPosition(imageToolbarCurrentImage,"top") + topPadding + topBorder + imageToolbarOffsetY;
  
    var scrollX = imageToolbarCurrentImage.ownerDocument.defaultView.scrollX;
    var scrollY = imageToolbarCurrentImage.ownerDocument.defaultView.scrollY;
  
    if (scrollX > mx) mx = scrollX + imageToolbarOffsetX;
    if (scrollY > my) my = scrollY + imageToolbarOffsetY;
  
  }
  
  imageToolbarToolbar.style.display = "block";
  imageToolbarToolbar.style.top = my+"px";
  imageToolbarToolbar.style.left = mx+"px";

}
