var imageToolbarPrefs = Components.classes["@mozilla.org/preferences-service;1"].
                            getService(Components.interfaces.nsIPrefService).getBranch("imagetoolbar.");
                            
var pref = Components.classes["@mozilla.org/preferences-service;1"].
                            getService(Components.interfaces.nsIPrefService).getBranch("browser.download.");
                            
const nsILocalFile = Components.interfaces.nsILocalFile;

if (imageToolbarPrefs.prefHasUserValue("imageFolder")) var previousFolder = imageToolbarPrefs.getComplexValue("imageFolder", nsILocalFile);
                          
function getDownloadsFolder(aFolder) {

  var fileLocator = Components.classes["@mozilla.org/file/directory_service;1"]
                      .getService(Components.interfaces.nsIProperties);
  
  var dir = fileLocator.get(getSpecialFolderKey(aFolder), nsILocalFile);
  
  return dir;
  
}

function getSpecialFolderKey(aFolderType) {

  return aFolderType == "Desktop" ? "DeskV" : "Pers";
  return "Home";
  
}

var imageToolbarSettings = {

	onLoad: function() {
                 
    var defaultFolder;
    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    const nsILocalFile = Components.interfaces.nsILocalFile;
  
    if (!imageToolbarPrefs.prefHasUserValue("imageFolder")) {
    
      if (!pref.prefHasUserValue("dir")) {
      
        defaultFolder = getDownloadsFolder("Desktop");
        imageToolbarPrefs.setComplexValue("imageFolder", nsILocalFile, defaultFolder);
        
      }
      
      else { 
      
        defaultFolder = pref.getComplexValue("dir", nsILocalFile);
        imageToolbarPrefs.setComplexValue("imageFolder", nsILocalFile, defaultFolder);
        
      }
                              
    }
	
    if (!imageToolbarPrefs.prefHasUserValue("minHeight")) imageToolbarPrefs.setIntPref("minHeight",200);
    if (!imageToolbarPrefs.prefHasUserValue("minWidth")) imageToolbarPrefs.setIntPref("minWidth",200);
    if (!imageToolbarPrefs.prefHasUserValue("popupDelay")) imageToolbarPrefs.setIntPref("popupDelay",500);
    if (!imageToolbarPrefs.prefHasUserValue("ctrlOverrideSize")) imageToolbarPrefs.setBoolPref("ctrlOverrideSize",true)   
    if (!imageToolbarPrefs.prefHasUserValue("offsetX")) imageToolbarPrefs.setIntPref("offsetX",10);
    if (!imageToolbarPrefs.prefHasUserValue("offsetY")) imageToolbarPrefs.setIntPref("offsetY",10);
    if (!imageToolbarPrefs.prefHasUserValue("buttonArray")) imageToolbarPrefs.setCharPref("buttonArray","0,0,0,0,0");
    if (!imageToolbarPrefs.prefHasUserValue("display.save")) imageToolbarPrefs.setBoolPref("display.save",true);
    if (!imageToolbarPrefs.prefHasUserValue("display.copy")) imageToolbarPrefs.setBoolPref("display.copy",true);
    if (!imageToolbarPrefs.prefHasUserValue("display.print")) imageToolbarPrefs.setBoolPref("display.print",true);  
    if (!imageToolbarPrefs.prefHasUserValue("display.mail")) imageToolbarPrefs.setBoolPref("display.mail",false);
    if (!imageToolbarPrefs.prefHasUserValue("display.folder")) imageToolbarPrefs.setBoolPref("display.folder",true);
    if (!imageToolbarPrefs.prefHasUserValue("display.relativeToMouse")) imageToolbarPrefs.setBoolPref("display.relativeToMouse",false);    
    if (!imageToolbarPrefs.prefHasUserValue("extensionsToIgnore")) imageToolbarPrefs.setCharPref("extensionsToIgnore","");
    if (!imageToolbarPrefs.prefHasUserValue("display.smallIcons")) imageToolbarPrefs.setBoolPref("display.smallIcons",false);
    if (!imageToolbarPrefs.prefHasUserValue("overwrite")) imageToolbarPrefs.setBoolPref("overwrite",false);
    if (!imageToolbarPrefs.prefHasUserValue("altButton")) imageToolbarPrefs.setIntPref("altButton",1);
  if (!imageToolbarPrefs.prefHasUserValue("promptFilenameIncrement")) imageToolbarPrefs.setBoolPref("promptFilenameIncrement",true);
  
	  var imageToolbarArray = imageToolbarPrefs.getCharPref("buttonArray").split(",");
	
	  this.folderbox = document.getElementById("folderbox");
	  this.delaybox = document.getElementById("delaybox");
	  this.minwidthbox = document.getElementById("minwidthbox");
	  this.minheightbox = document.getElementById("minheightbox");
	  this.offsetybox = document.getElementById("offsetybox");
	  this.offsetxbox = document.getElementById("offsetxbox");
	  this.saveenabled = document.getElementById("save_enabled");
	  this.copyenabled = document.getElementById("copy_enabled");
	  this.printenabled = document.getElementById("print_enabled");
    this.folderenabled = document.getElementById("folder_enabled");
	  this.saveaction = document.getElementById("saveaction");
	  this.copyaction = document.getElementById("copyaction");
	  this.printaction = document.getElementById("printaction");
    this.folderaction = document.getElementById("folderaction");
    this.cursorrelative = document.getElementById("cursorrelative");
    this.ctrlsize = document.getElementById("ctrlsize");
    this.disableext = document.getElementById("disableext");
    this.iconsize = document.getElementById("iconsize");
    this.overwrite = document.getElementById("overwrite");
    this.increment = document.getElementById("increment");
    this.middlemb = document.getElementById("middlemb");
    this.rightmb = document.getElementById("rightmb");
    
    if (imageToolbarPrefs.getIntPref("altButton") == 1)
      this.middlemb.setAttribute("selected",true);
    else
      this.rightmb.setAttribute("selected",true);
    
    this.disableext.setAttribute("value",imageToolbarPrefs.getCharPref("extensionsToIgnore"));
    this.ctrlsize.setAttribute("checked",imageToolbarPrefs.getBoolPref("ctrlOverrideSize"));
    this.iconsize.setAttribute("checked",imageToolbarPrefs.getBoolPref("display.smallIcons"));
    this.overwrite.setAttribute("checked",imageToolbarPrefs.getBoolPref("overwrite"));
    this.increment.setAttribute("checked",imageToolbarPrefs.getBoolPref("promptFilenameIncrement"));
    this.cursorrelative.setAttribute("checked",imageToolbarPrefs.getBoolPref("display.relativeToMouse"));
    this.folderbox.setAttribute("value",imageToolbarPrefs.getComplexValue("imageFolder", nsILocalFile).path);
    this.delaybox.setAttribute("value",imageToolbarPrefs.getIntPref("popupDelay"));
	  this.minwidthbox.setAttribute("value",imageToolbarPrefs.getIntPref("minWidth"));
	  this.minheightbox.setAttribute("value",imageToolbarPrefs.getIntPref("minHeight"));
	  this.offsetybox.setAttribute("value",imageToolbarPrefs.getIntPref("offsetY"));
	  this.offsetxbox.setAttribute("value",imageToolbarPrefs.getIntPref("offsetX"));
	  this.saveenabled.setAttribute("checked",imageToolbarPrefs.getBoolPref("display.save"));
	  this.copyenabled.setAttribute("checked",imageToolbarPrefs.getBoolPref("display.copy"));
	  this.printenabled.setAttribute("checked",imageToolbarPrefs.getBoolPref("display.print"));
    this.folderenabled.setAttribute("checked",imageToolbarPrefs.getBoolPref("display.folder"));
	  this.saveaction.value = imageToolbarArray[0];
	  this.copyaction.value = imageToolbarArray[1];
	  this.printaction.value = imageToolbarArray[3];
	  this.folderaction.value = imageToolbarArray[4]; 

	},

  useDownloadFolder: function() {
  
    var defaultFolder;
    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    const nsILocalFile = Components.interfaces.nsILocalFile;
  
    if (!pref.prefHasUserValue("dir")) {
          
      defaultFolder = getDownloadsFolder("Desktop");
      imageToolbarPrefs.setComplexValue("imageFolder", nsILocalFile, defaultFolder);
      
    }
    
    else { 
    
      defaultFolder = pref.getComplexValue("dir", nsILocalFile);
      imageToolbarPrefs.setComplexValue("imageFolder", nsILocalFile, defaultFolder);
      
    }
           
    this.folderbox = document.getElementById("folderbox");
    this.folderbox.value = imageToolbarPrefs.getComplexValue("imageFolder", nsILocalFile).path;
  
  },
  
  browseFolder: function() {
  
    // Function derived from selectFolder() in pref-download.js
  
    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    const nsILocalFile = Components.interfaces.nsILocalFile;
    
    var fp = Components.classes["@mozilla.org/filepicker;1"]
                        .createInstance(nsIFilePicker);
  
    fp.init(window, "Choose Directory", nsIFilePicker.modeGetFolder);
    
    try {
    
      var initialDir = imageToolbarFolder;
      if (initialDir) fp.displayDirectory = initialDir;
       
    }
    
    catch (ex) {
    
      // ignore exception: file picker will open at default location
      
    }
    
    fp.appendFilters(nsIFilePicker.filterAll);
    var ret = fp.show();
  
    if (ret == nsIFilePicker.returnOK) {
    
      var localFile = fp.file.QueryInterface(nsILocalFile);
      imageToolbarPrefs.setComplexValue("imageFolder", nsILocalFile, localFile);
      
    }
    
    this.folderbox = document.getElementById("folderbox");
    this.folderbox.value = imageToolbarPrefs.getComplexValue("imageFolder", nsILocalFile).path;
          
  },
	
	onAccept: function() {
	
	  this.folderbox = document.getElementById("folderbox");
	  this.delaybox = document.getElementById("delaybox");
	  this.minwidthbox = document.getElementById("minwidthbox");
	  this.minheightbox = document.getElementById("minheightbox");
	  this.offsetybox = document.getElementById("offsetybox");
	  this.offsetxbox = document.getElementById("offsetxbox");
	  this.saveenabled = document.getElementById("save_enabled");
	  this.copyenabled = document.getElementById("copy_enabled");
	  this.printenabled = document.getElementById("print_enabled");
    this.folderenabled = document.getElementById("folder_enabled");
	  this.saveaction = document.getElementById("saveaction");
	  this.copyaction = document.getElementById("copyaction");
	  this.printaction = document.getElementById("printaction");
    this.folderaction = document.getElementById("folderaction");
    this.cursorrelative = document.getElementById("cursorrelative");
    this.ctrlsize = document.getElementById("ctrlsize");
    this.disableext = document.getElementById("disableext");
    this.iconsize = document.getElementById("iconsize");
    this.overwrite = document.getElementById("overwrite");
    this.increment = document.getElementById("increment");
    this.middlemb = document.getElementById("middlemb");
    this.rightmb = document.getElementById("rightmb");
        
    imageToolbarPrefs.setIntPref("minHeight",this.minheightbox.value);
    imageToolbarPrefs.setIntPref("minWidth",this.minwidthbox.value);
    imageToolbarPrefs.setIntPref("popupDelay",this.delaybox.value);
    imageToolbarPrefs.setIntPref("offsetX",this.offsetxbox.value);
    imageToolbarPrefs.setIntPref("offsetY",this.offsetybox.value);
    
    // This is an ugly way of doing things, I set the prefs to false, then check for those to change to true.
    
    imageToolbarPrefs.setBoolPref("display.copy",false);
    imageToolbarPrefs.setBoolPref("display.save",false);
    imageToolbarPrefs.setBoolPref("display.print",false);
    imageToolbarPrefs.setBoolPref("display.folder",false);
    imageToolbarPrefs.setBoolPref("display.relativeToMouse",false);
    imageToolbarPrefs.setBoolPref("ctrlOverrideSize",false);
    imageToolbarPrefs.setBoolPref("display.smallIcons",false);
    imageToolbarPrefs.setBoolPref("overwrite",false);
    imageToolbarPrefs.setBoolPref("promptFilenameIncrement",false);
    
    if (this.middlemb.selected == true) imageToolbarPrefs.setIntPref("altButton",1);
    if (this.rightmb.selected == true) imageToolbarPrefs.setIntPref("altButton",2);
    if (this.copyenabled.checked == true) imageToolbarPrefs.setBoolPref("display.copy",this.copyenabled.checked);
    if (this.saveenabled.checked == true) imageToolbarPrefs.setBoolPref("display.save",this.saveenabled.checked);
    if (this.printenabled.checked == true) imageToolbarPrefs.setBoolPref("display.print",this.printenabled.checked);
    if (this.folderenabled.checked == true) imageToolbarPrefs.setBoolPref("display.folder",this.folderenabled.checked);
    if (this.cursorrelative.checked == true) imageToolbarPrefs.setBoolPref("display.relativeToMouse",this.cursorrelative.checked);
    if (this.ctrlsize.checked == true) imageToolbarPrefs.setBoolPref("ctrlOverrideSize",this.ctrlsize.checked);
    if (this.iconsize.checked == true) imageToolbarPrefs.setBoolPref("display.smallIcons",this.iconsize.checked);
    if (this.overwrite.checked == true) imageToolbarPrefs.setBoolPref("overwrite",this.overwrite.checked);
    if (this.increment.checked == true) imageToolbarPrefs.setBoolPref("promptFilenameIncrement",this.increment.checked);
    
    var buttonArray = this.saveaction.value + "," + this.copyaction.value + "," + "0,0," + this.folderaction.value;

    imageToolbarPrefs.setCharPref("buttonArray",buttonArray);
    imageToolbarPrefs.setCharPref("extensionsToIgnore",this.disableext.value);    
    
    // Saves prefs
    Components.classes["@mozilla.org/preferences-service;1"].
        getService(Components.interfaces.nsIPrefService).savePrefFile(null);
	
	},
	
	onCancel: function() {
	
	  const nsILocalFile = Components.interfaces.nsILocalFile;
    if (previousFolder)
      imageToolbarPrefs.setComplexValue("imageFolder", nsILocalFile, previousFolder);
    // Cant figure out a way of converting the nsILocalFile to a string for display only purposes, so therefore
    // I'm storing the pref after the user browses, and restore it if they click cancel.
	
	}

}