/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * Copyright (c) 2001-2002  Ted Mielczarek
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

var NukeAnything = {
  init: function() {
    var menu = document.getElementById("contentAreaContextMenu");
    menu.addEventListener("popupshowing",NukeAnything.showHide,false);

    // stick the Nuke Frame item where it ought to go
    var menuitem = document.getElementById("nukeanything-do-nuke-frame");
    var menupopup = document.getElementById("frame").firstChild;
    menuitem.parentNode.removeChild(menuitem);
    menupopup.appendChild(menuitem);
  },

  showHide: function() {
    if(gContextMenu) {
     var menuitem = document.getElementById("nukeanything-do-nuke");
     if(menuitem)
        menuitem.hidden = gContextMenu.isTextSelection();
     menuitem = document.getElementById("nukeanything-do-nuke-selection");
     if(menuitem)
        menuitem.hidden = !gContextMenu.isTextSelection();

     // shouldn't need this since the entire frame submenu is hidden
     menuitem = document.getElementById("nukeanything-do-nuke-frame");
     if(menuitem)
        menuitem.hidden = !gContextMenu.inFrame;
    }

  },

  doNukeAnything: function() {
    if(gContextMenu) {
      var obj = gContextMenu.target;
      if(obj) {
        // go away!
        obj.style.display = "none";
      }
    }
  },

  doNukeSelection: function() {
    var focusedWindow = document.commandDispatcher.focusedWindow;
    var sel = focusedWindow.__proto__.getSelection.call(focusedWindow);
    // boom!
    sel.deleteFromDocument();
    sel.collapseToStart();
  },

  checkFrames: function(frames, framedoc) {
    if(!frames || frames.length == 0)
      return false;

    for(var f=0; f<frames.length; f++) {
      if(frames[f].contentDocument == framedoc) {
	 // go away!
	 frames[f].style.display = "none";
	 return true;
      }
      // check to see if this document has frames in it
      var doc = frames[f].contentDocument;
      if(NukeAnything.checkFrames(doc.getElementsByTagName("frame"), framedoc))
	return true;
      if(NukeAnything.checkFrames(doc.getElementsByTagName("iframe"), framedoc))
	return true;
    }

    return false;
  },

  doNukeFrame: function() {
    var b = getBrowser();
    if(gContextMenu && b) {
      var framedoc = gContextMenu.target.ownerDocument;
      if(framedoc) {
	var doc = b.contentDocument;
	NukeAnything.checkFrames(doc.getElementsByTagName("frame"), framedoc);
	NukeAnything.checkFrames(doc.getElementsByTagName("iframe"), framedoc);
      }
    }
  }
}

// do the init on load
window.addEventListener("load",NukeAnything.init, false); 