
    /**     **
       *     *
      *   ** *  Session Saver 0.2d : rue + Pike
     *   *  **
 *  ****  ** */



/*
** Main object
*/

var SessionSaver = {
	
	// Pref-branch properties
	prefBranch:     'sessionsaver.',
	prefBranchWindows:   'windows.', // the "live" capture of the current session
	prefBranchStatic:     'static.', // all manually captured sessions
	staticBranchDefault: 'default.', // the default manual-session
	prefBranchSettings: 'settings.',
	rootBranch: Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch(null),

	// Called when window first loads
	onLoad: function(evt) {
	
		window.removeEventListener('load', ssLoad, true); // remove startup-check (only run once)
		
		// Setup object properties
		this.promptService   = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService); 
		this.windowMediator  = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator); // for getWindows()
		this.observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		this.prefService     = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService);
		this.rootBranch         = this.prefService.getBranch(null);
		this.Branch             = this.prefService.getBranch(this.prefBranch);
		this.windowBranch       = this.prefService.getBranch(this.prefBranch + this.prefBranchWindows);
		this.staticBranch       = this.prefService.getBranch(this.prefBranch + this.prefBranchStatic);
		this.settingsBranch     = this.prefService.getBranch(this.prefBranch + this.prefBranchSettings);
		this.browserChromeUrl   = this.rootBranch.getCharPref('browser.chromeURL');
		this.autoLoad           = !this.settingsBranch.prefHasUserValue("autoload")         ||  this.settingsBranch.getBoolPref("autoload");         // default:true
		this.autoLoadBranch     = (this.settingsBranch.prefHasUserValue('autoload.branch')) ?   this.settingsBranch.getCharPref('autoload.branch') : this.prefBranchWindows; // default:'windows.'
		this.crashLoad          = !this.settingsBranch.prefHasUserValue("crashload")        ||  this.settingsBranch.getBoolPref("crashload");        // default:true
		this.crashLoadBranch    =  this.prefBranchWindows;
		this.overwriteWindows   = !this.settingsBranch.prefHasUserValue('overwritewindows') ||  this.settingsBranch.getBoolPref('overwritewindows'); // default:true
		this.overwriteTabs      = !this.settingsBranch.prefHasUserValue('overwritetabs')    ||  this.settingsBranch.getBoolPref('overwritetabs');    // default:true
		this.concatenate        =  this.settingsBranch.prefHasUserValue('concatenate')      &&  this.settingsBranch.getBoolPref('concatenate');      // default:false
		this.shutdownSave       = !this.settingsBranch.prefHasUserValue('shutdownsave')     ||  this.settingsBranch.getBoolPref('shutdownsave');     // default:true
		this.shutdownSaveBranch = (this.settingsBranch.prefHasUserValue('shutdownsave.branch')) ? this.settingsBranch.getCharPref('shutdownsave.branch') : this.prefBranchStatic+this.staticBranchDefault; // default:'static.default.'
		this.snapback_noFX      =  this.settingsBranch.prefHasUserValue('nofx')             &&  this.settingsBranch.getBoolPref('nofx');             // default:false
		this.snapback_willFocus = !this.settingsBranch.prefHasUserValue('willfocus')        ||  this.settingsBranch.getBoolPref('willfocus');        // default:false
		this.lastSessionCrashed =  this.settingsBranch.prefHasUserValue("shutdown")         && !this.settingsBranch.getBoolPref("shutdown");         // default:false, needs to come before "checkLoaded()"
		this.winLocalPrefix = 'session';
		this.winPrefPrefix  = 'saved';
		this.oldD = [" ",  "|", "||", "|||"]; // old-style delimiters
		this.D    = ["  ", "| "," |", " ||"]; // new-style
		this.tabCounter = 0;  // ensure unique tab-count
		this.activeTabs = {}; // set by onTabLoad() -- the hash of active tabs, for snapback
		this.closedTabs = []; // ditto -- the array of Closed tabs, for snapback
		this.msgboardElem = document.getElementById("sessionsaver-messageboard"); // per sessionsavwr.xul, for dtd-import in js -- used by SessionSaver.msgboard()
		
		// Menu handling -- for initMenu()
		this.rdf   = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService);
		this.utils = Components.classes['@mozilla.org/rdf/container-utils;1'].getService(Components.interfaces.nsIRDFContainerUtils);
		this.dataPrefix    = 'http://sessionsaver.mozilla.org/rdf#';
		this.mozillaMenuId = "sessionsaver-mozillamenu";
		this.firefoxMenuId = "sessionsaver-firefoxamenu";
		this.initMenu(this.mozillaMenuId);
		this.initMenu(this.firefoxMenuId);
		
		// Hidden window stuff
		this.firstWindow = !this.checkLoaded(); // load shutdown-observer / startup-flag
		this.hiddenObserver = this.hiddenWnd.SessionSaverObserver; // global shutdown-observer
		this.hiddenHash = this.hiddenObserver.activeWindows; // global-hash of "active" windows
		this.setPrefs(); // run any version-update stuffs
		this.checkShutdownRequest(true); // re-activate, if a shutdown was previously observed
		
		// Removal menu (older browsers, only)
		if (this.hiddenObserver.getDontWarn(2)) { 
			var idArray = ['sessionsaver-remove-mozillaseparator','sessionsaver-remove-firefoxseparator','sessionsaver-remove-mozillamenu','sessionsaver-remove-firefoxmenu'];
			while (idArray[0])  {  try{ document.getElementById(idArray.shift()).hidden = false; } catch(e) {}  }    }

		// The intelligent orbiter
		this.orbiterSaveBranch = this.mb("startupfailure");
		var orbiterPreviousCrashed = this.firstWindow && this.lastSessionCrashed && this.settingsBranch.prefHasUserValue("orbiter"); // did the last session crash during recall?
		if (orbiterPreviousCrashed) {
			var buttonPressed = this.promptService.confirmEx(window,this.mb('orbiterconfirmtitle'),this.mb('orbiterconfirmmsg'),this.promptService.BUTTON_TITLE_IS_STRING * this.promptService.BUTTON_POS_0 + this.promptService.BUTTON_TITLE_IS_STRING * this.promptService.BUTTON_POS_1,this.mb('continue'),this.mb('abort'),null,null,{});
			if (buttonPressed == 1) {
				var dontLoad = true;
				var problemBranch = this.settingsBranch.getCharPref("orbiter");
				this.settingsBranch.deleteBranch("orbiter");
				var wasCrashLoad = (this.crashLoad && this.crashLoadBranch==problemBranch);
				var wasFixedLoad = (!wasCrashLoad && this.autoLoad && this.prefBranchWindows!=problemBranch);
				var wasFixedSync = (wasFixedLoad && this.autoLoadBranch!=this.prefBranchWindows && this.shutdownSave && this.shutdownSaveBranch==this.autoLoadBranch);
				// if the startup-session is fixed/non-updated -- the only option: disable 'autoload'
				if (wasFixedLoad && !wasFixedSync) 
					this.settingsBranch.setBoolPref("autoload", false), alert(this.mb('orbiterdisabledmsg')), this.openSettings().addEventListener("load", function(evt){var wnd = evt.target.defaultView || evt.target.ownerDocument.defaultView; /*alert("opener: "+wnd.opener);*/ var elem = wnd.document.getElementById("autoload"); /*alert("SessionSaverSettings: "+wnd.SessionSaverSettings);*/ wnd.SessionSaverSettings.showExpert(false), wnd.SessionSaverSettings.newOrSavedFlasher("FlasherA").start(elem, false, "fade-in", 70, null,null,null,null,null,null, 'setTimeout');}, 1000, this); // 11 params: elem, append, flashType, speed, dontRun, overlap, overlapPrincipal, overlapFlip, runningTime, runRelative, timerType
				// ..or it's "updatable" or was crash-recovering -- rename + move it
				else { 
					this.hiddenObserver.replicateBranch(problemBranch, this.prefBranchStatic+this.orbiterSaveBranch);
					this.Branch.deleteBranch(problemBranch); // probably unnecessary, but.. better-safe-than-sorry
					var sessionDescription = this.orbiterSaveBranch.replace(/\.$/,"").replace(/[_]/g," ");
					alert(this.mb('orbitersavedmsg')+sessionDescription+"\n"); }
			}
		}
		// Bluefyre's Startup prompt
		if (this.firstWindow && !orbiterPreviousCrashed) // if the orbiter already tripped, dont ask again
			if (this.autoLoad || (this.crashLoad && this.lastSessionCrashed))
				if (this.hiddenObserver.bluefyreStyle && this.hiddenObserver.bluefyreFlip in {Startup:0,Both:0})
					if (this.Branch.prefHasUserValue((this.lastSessionCrashed?this.crashLoadBranch:this.autoLoadBranch)+"zorder")) { // (this.prefBranchWindows+"zorder")) // if there's something to restore
						var isRecover = (this.crashLoad && this.lastSessionCrashed),  isResume = !isRecover && (this.autoLoad && ((this.autoLoadBranch == this.prefBranchWindows) || (this.shutdownSave && this.autoLoadBranch == this.shutdownSaveBranch)));
						     if (isRecover) var confirmTitle = this.mb("recovertitle"), confirmMsg = this.mb("recovermsg"), confirmButton = this.mb("recover" ), declineButton = this.mb("clear");
						else if (isResume )     confirmTitle = this.mb("resumetitle" ), confirmMsg = this.mb("resumemsg" ), confirmButton = this.mb("resume"  ), declineButton = this.mb("clear");
						else                    confirmTitle = this.mb("restoretitle"), confirmMsg = this.mb("restoremsg"), confirmButton = this.mb("activate"), declineButton = this.mb("ignore");
						dontLoad = (1 == this.promptService.confirmEx(window,confirmTitle,confirmMsg,this.promptService.BUTTON_TITLE_IS_STRING * this.promptService.BUTTON_POS_0 + this.promptService.BUTTON_TITLE_IS_STRING * this.promptService.BUTTON_POS_1,confirmButton,declineButton,null,null,{}) );  }
		// Patch Tabbrowser
		this.TabbrowserPatchUp(); // (though we'll have to run it again, later -- per other extensions' delayed mods; miniT)
		window.setTimeout(function(ssObj){ssObj.TabbrowserPatchUp();}, 500,this);
		
		
		// If first window
		if (this.firstWindow) {
			// ..should we autoload / did the last session crash?
			if (!dontLoad && (this.autoLoad || (this.crashLoad && this.lastSessionCrashed))) {
			
				var startupBranch = this.lastSessionCrashed?this.crashLoadBranch:this.autoLoadBranch;
				this.hiddenObserver.orbiterCount = 1;
				this.hiddenObserver.orbiterActive = true; // since we'll be opening all child-windows for our session synchronously, we'll have them only register with the orbiter-count while this flag is set
				this.orbiterChild = 1;
				this.settingsBranch.setCharPref('orbiter', startupBranch); // we're the first window -- orbiter pending.
				this.prefService.savePrefFile(null); // store the orbiter immediately
							
				// check startup-page type (0:blank, 1:homepage(s), 2:last)
				var startupPagePref = this.rootBranch.prefHasUserValue("browser.startup.page") ? this.rootBranch.getIntPref("browser.startup.page") : 1; // the pref defaults to 1 internally, so we're good.
				switch (startupPagePref) { 
					case 0: var homepages = "about:blank"; break;
					case 1: homepages = new String();
								try { var pageArray = this.rootBranch.getChildList("browser.startup.homepage", {}); } catch(e) { break; }
								for (var n in pageArray)
									if (! /^browser\.startup\.homepage(\.count|_)/.test(pageArray[n])) {
										try { homepages += " "+this.rootBranch.getComplexValue(pageArray[n], Components.interfaces.nsIPrefLocalizedString).data; } catch(e) {}   }
							break;
					case 2: var historyService = Components.classes["@mozilla.org/browser/global-history;1"].getService(Components.interfaces.nsIBrowserHistory);
							homepages = new String();
							homepages += historyService.lastPageVisited; // will be an empty-string "", if no page is stored
							break;
				}
				
				// check for window URL arguments
				if (window.arguments && window.arguments.length > 0)
					// overwrite existing tabs unless a non-homepage URL argument was passed
					for (var i=0, overwriteTabs=true; i < window.arguments.length; i++)
						for (var j=0, subArguments=window.arguments[i].split("\n"); j < subArguments.length; j++) {
							if (homepages.indexOf(subArguments[j]) == -1) overwriteTabs = false;
							else subArguments.splice(j--, 1), window.arguments[i]=subArguments.join("\n");   }
				else overwriteTabs = true; // overwrite if no window-url's were passed
				
				// Load saved session
				this.sessionRecall(overwriteTabs, startupBranch);
				return;
			}
		}
		// Not the first window:
		else if (opener && opener.SessionSaver) { // once loaded, check to see if there's any pending tabs to restore
			var tabObject = opener.SessionSaver[window.name];
			if (tabObject && tabObject[0] == window) {
				if (this.hiddenObserver.orbiterActive) { this.orbiterChild = 1; this.hiddenObserver.orbiterCount++; }
				this.windowRecall(tabObject[1], tabObject[2], tabObject[3]); // @params: storedWinName, prefArray, overwriteTabs
				delete opener.SessionSaver[window.name]; // remove "pending recall" from opener
				return; }
		}

		this.onLoadPtII("none"); // attach the pref-observer -- no recall occurred
		
	},
	
	// Completes our load-process: called by sessionRecall, tabRecall() or onLoad()
	onLoadPtII: function(marker) {
		if (this.activated) return; // if already loaded, don't continue
		this.activated = true;
		
		if (this.firstWindow) this.hiddenObserver.orbiterActive = false;
		
		this.hiddenObserver.addWindow(window, this); // add our window to the global-hash -- also builds a unique window-name for us
		// Pref-Observer + cleanup
		this.prefObserverLoad(); // load pref-observer - set menuitems + listeners
		if (this.origBrowserCloseWindow = window.BrowserCloseWindow) // backup the original
			window.BrowserCloseWindow   = this.onCloseWrap;          // see ya.
		if (this.origWindowIsClosing    = window.WindowIsClosing)    // backup the original
			window.WindowIsClosing      = this.onCloseWrapII;        // zap.
		if (window.__ssOrigClose        = window.close)              // backup the original
			window.close                = this.onCloseWrapIII;       // cheers.
	},
	// Decrements the orbiterCount when all startup-tabs have loaded
	orbiterControl: function(override) {
		//setTimeout(function(){throw "orbiterControl: "+arguments[0]+" -> "+arguments[1]+" :: "+arguments[2];},0, this.orbiterChild,this.hiddenObserver.orbiterCount,override);
		if (this.orbiterChild && (override || !--this.orbiterChild)
				&& this.hiddenObserver.orbiterCount && !--this.hiddenObserver.orbiterCount) { // orbiter success.
			 //setTimeout(function(){throw "orbiterControl: done.";},0);
			 this.settingsBranch.deleteBranch("orbiter"); 
			 this.prefService.savePrefFile(null); }
	},
	/*
		Possible routes for closure:
		i.  OlderBrowser
			- [X]:                             -> [WindowIsClosing]
			- File > Close: BrowserCloseWindow ->                   -> window.close
			- Shutdown:                        ->                   -> window.close
		ii. NewerBrowser
			- [X]:                                [WindowIsClosing] -> window.close
			- File > Close: BrowserCloseWindow -> [WindowIsClosing] -> window.close
			- Shutdown:     BrowserCloseWindow -> [WindowIsClosing] -> window.close
		* bracketed routine alerts warnOnClose, which we're intercepting
		** somehow, the tabbrowser loses its selected-tab just before window.close
	*/	
	// Trips for File > Close -- older browsers
	onCloseWrap: function() { 
		//alert("onCloseWrap: "+SessionSaver.origBrowserCloseWindow);
		var a = arguments, ssLevelI = true;  // closure-chained calls will have the ssLevel-variable in scope
		return SessionSaver.onClose() && (
				(typeof(SessionSaver.origBrowserCloseWindow) == 'function') ?
						( (a.length > 0) ? SessionSaver.origBrowserCloseWindow(a[0],a[1],a[2],a[3],a[4]) : SessionSaver.origBrowserCloseWindow() ) 
						: true);
	},
	// Trips for File > Close (newer) + [X] (older+newer)
	onCloseWrapII: function() {
		//alert("onCloseWrapII: "+SessionSaver.origWindowIsClosing);
		var a = arguments, ssLevelII = true;  // closure-chained calls will have the ssLevel-variable in scope
		return (typeof(ssLevelI)!='undefined'||SessionSaver.onClose()) && (
				(typeof(SessionSaver.origWindowIsClosing) == 'function') ?
						( (a.length > 0) ? SessionSaver.origWindowIsClosing(a[0],a[1],a[2],a[3],a[4]) : SessionSaver.origWindowIsClosing() ) 
						: true);
	},
	// Trips *after* File > Close (all) + [X] (all) + shutdown (all)
	onCloseWrapIII: function() {
		//alert("onCloseWrapIII: "+window.__ssOrigClose);
		var a = arguments; 
		return ((typeof(ssLevelI)!='undefined'||typeof(ssLevelII)!='undefined')||SessionSaver.onClose(null,true)) && (
				(typeof(window.__ssOrigClose) == 'function') ?
						( (a.length > 0) ? window.__ssOrigClose(a[0],a[1],a[2],a[3],a[4]) : window.__ssOrigClose() ) 
						: true);
	},
	// MessageBoard for DTD-import (of js-strings)
	mb: function(entry) { 
		if (!this.mbCache) this.mbCache = {}; // XXX it seems dtd-strings are only imported at overlay-compilation time -- manually adding them to an un-appended element, then inserting, fails  [naturally, they're called "pre-parser" for a reason -rue]
		return (this.mbCache[entry]) ? this.mbCache[entry] : (this.mbCache[entry] = this.msgboardElem.getAttribute(entry).replace(/[\\]n/g, "\n")); 
	},
	
	// Converts the chromeProperties from bool -> numeric (and back again)
	convertObj: #1={'true':1,'false':0,'1':true,'0':false,'null':null,'':null,'undefined':null},
	boolToPref: #1#, // "yum" -- sharp-variables

	// Initializes the datasource for our Tools-menu
	initMenu: function(menuId, menu) {
		if (!menu) menu = document.getElementById(menuId);
		if (!menu) return;
		if (!menuId) menuId = menu.id;
		
		//remove the old database in case there is one
		var sources = menu.database.GetDataSources(), item, oldDataSource;
		while (sources.hasMoreElements()) {
			item = sources.getNext();
			oldDataSource = item.QueryInterface(Components.interfaces.nsIRDFDataSource);
			menu.database.RemoveDataSource(oldDataSource); }
		var datasource = Components.classes['@mozilla.org/rdf/datasource;1?name=in-memory-datasource'].createInstance(Components.interfaces.nsIRDFDataSource);
		menu.database.AddDataSource(datasource);
		
		var sequence = this.utils.MakeSeq(datasource, this.rdf.GetResource('urn:root:sessions'));
		
		// don't list duplicates (branches have multiple prefs)
		var sessionArray = this.Branch.getChildList(this.prefBranchStatic, {}); // array of pref-names holding custom-sessions
		sessionArray.sort(); // the ordering is initially skewed / random
		sessionArray.unshift(this.prefBranchStatic+this.staticBranchDefault+"zorder"); // always include the default branch
		var checkHash = {}, defaultArray = [], branch;
		var checkRe = /(.*\.)[^\.]+$/, defaultRe = new RegExp("^"+ this.prefBranchStatic.replace(/([^\w\d])/g,"\\$1") +"default","i");
		for (var l = 0; l < sessionArray.length; l++) {
			branch = sessionArray[l] = sessionArray[l].match(checkRe)[1];
			if ( checkHash[branch]) { sessionArray.splice(l--,1); continue; }
			if ((checkHash[branch]=true) && defaultRe.test(branch)) defaultArray.push(sessionArray.splice(l--,1)[0]);
		}
		//setTimeout(function(s){throw s;},0,sessionArray.toString()+"  ->  "+defaultArray.toString());
		// XXX Future Note: brilliant!- the 'concat()' method allows instant duplication of an array !
		sessionArray = defaultArray.concat(sessionArray);
		var branchRe = new RegExp("^"+ this.prefBranchStatic +"(.*)\\.$");
		for (var n = 0, a=-1; n < sessionArray.length; n++) {
			var resource = this.rdf.GetResource(sessionArray[n]);
			branch = sessionArray[n].match(branchRe)[1];
			var sessionBranch = branch+".";
			var sessionDescription = branch.replace(/[_]/g, " ").split(" ");
			for (var x in sessionDescription) sessionDescription[x] = sessionDescription[x].replace(/^./, sessionDescription[x].charAt(0).toUpperCase());
			//var dscPrefix = n%2 ? " +":" -";
			//sessionDescription = " -    "+sessionDescription.join(" ");
			var accessKey = (sessionBranch == this.staticBranchDefault || ++a > 26) ? "" : this.mb('sskey'+String.fromCharCode(97+a));
			var accessKeyDisplay = (accessKey == "") ? this.mb('decordefaultleft') : accessKey+this.mb('decorright');
			sessionDescription = " "+ accessKeyDisplay +"   "+sessionDescription.join(" ");
			var sessionLocation = sessionArray[n];
			datasource.Assert(resource, this.rdf.GetResource(this.dataPrefix + 'label'), this.rdf.GetLiteral(sessionDescription), true);
			datasource.Assert(resource, this.rdf.GetResource(this.dataPrefix + 'value'), this.rdf.GetLiteral(sessionLocation), true);
			datasource.Assert(resource, this.rdf.GetResource(this.dataPrefix + 'br'   ), this.rdf.GetLiteral(sessionBranch), true); // wow- using "#branch" resulted in much wierdness: the attribute's ultimate value was always pre-pended with "static."
			datasource.Assert(resource, this.rdf.GetResource(this.dataPrefix + 'desc' ), this.rdf.GetLiteral(branch), true);
			datasource.Assert(resource, this.rdf.GetResource(this.dataPrefix + 'aky'  ), this.rdf.GetLiteral(accessKey), true);
			sequence.AppendElement(resource);
		}
		
		menu.builder.rebuild();
	},
	// Initializes each datasource for our SnapBack Dropdown-menus
	initSnapBackMenu: function(menuId, menu) {
		if (!menu) menu = document.getElementById(menuId);
		if (!menu) return;
		if (!menuId) menuId = menu.id;
		
		if (typeof(menu.__ssMenuCounter)=='undefined')
			menu.__ssMenuCounter = this.menuCounter = (typeof(this.menuCounter)=='undefined') ? 1 : this.menuCounter++;
		
		// remove the old database in case there is one
		var sources = menu.database.GetDataSources(), item, oldDataSource; // XXX hmm.. the datasources attribute has to be set before script-instantiated elements can be inserted
		while (sources.hasMoreElements())
			item = sources.getNext(), oldDataSource = item.QueryInterface(Components.interfaces.nsIRDFDataSource), menu.database.RemoveDataSource(oldDataSource);
		var datasource = Components.classes['@mozilla.org/rdf/datasource;1?name=in-memory-datasource'].createInstance(Components.interfaces.nsIRDFDataSource);
		menu.database.AddDataSource(datasource);
		
		var isTabMenu = /tabback/.test(menuId); // XXX 'sequence' is defined using this (next)
		var ref = 'urn:root:snapback'+  (isTabMenu?'tabs':'windows')  +menu.__ssMenuCounter;
		menu.setAttribute("ref", ref);
		var sequence = this.utils.MakeSeq(datasource, this.rdf.GetResource(ref));
		var uri = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
		
		var titleLimit = 27,      hostLimit  = 15;
		var emptyRe = /^\s*$/,    spaceRe = /[\s\W]/,    vowelRe = /[aeiou]/g,    headTailSpaceRe = /^\s*(.*?)\s*$/;
		
		var snapBackArray = ((isTabMenu) ? this.closedTabs : this.hiddenObserver.closedWindows).slice(0,10);
		var hostHash = {};
		for (var n = 0, a=-1, finalArray=[], labelArray=[]; n < snapBackArray.length; n++) {
			var resource = this.rdf.GetResource(""+n);
			var title = (isTabMenu ? snapBackArray[n][4] : snapBackArray[n][0][0]  ).replace(headTailSpaceRe, "$1").toLowerCase(); //"Window "+n;
			var host  =  "";
			var spec  =  isTabMenu ? snapBackArray[n][5] : "";
			try{ if (spec != "") (uri.spec = spec) && (host = uri.host.replace(/^www\./,"")); } catch(e) {  setTimeout(function(){throw "e: "+e;},0);  }
			// ..a lot.
			var spacer1 =this.mb("spaceri"), spacer2 =this.mb("spacerii"), spacer3 =this.mb("spaceriii"), joinder =this.mb("joinder"), elipsis =this.mb("elipsis"), blank =this.mb("blank"), tabRight =this.mb("tabdecorright"), tabLeft =this.mb("tabdecorleft"), tabSingular =this.mb("tab"), tabPlural =this.mb("tabs"), hostLeft =this.mb("hostdecorleft"), hostRight =this.mb("hostdecorright"), accessDefault =this.mb('decordefaultleft'), accessRight =this.mb('decorright');
			var description_ptII, preSliceTitle, isDuplicate = false;

			if (host!="" || !isTabMenu) { // remove duplicate portions from head + tail
				var matchedB,matchBII, matchedF=matchedB=matchBII= 0, localRes, localProp, localOld, localNew, origTitle = title, origHost = host.replace(/.*?([^\.]+\.[^\.]+)$/, "$1"), tempHash;
				if (!hostHash[origHost] || ((tempHash = hostHash[origHost]) && false)) hostHash[origHost] = [], tempHash = null; //, tempHash = [origHost,null];
				if (tempHash) // stuff: o'hearn  +  stuff: william orbit  ->  o'hearn + william orbit
					for (var t in tempHash) {
						var matchLimit = 5, countF = -1, countB = title.length, titleCached = tempHash[t][0], countB2 = titleCached.length;
						if (title == titleCached) { isDuplicate=tempHash[t][1], matchedF=matchedB=1; break; } // we'll just borrow the duplicate's label -- thus, a single update reflects everywhere
						if (!matchedF) {  // forward-search
							while (title[++countF] && title[countF] == titleCached[countF]) if (spaceRe.test(title[countF+1])) matchedF = countF+1;
							// XXX new technique: wrapping the 'else-clause' into the if's conditional
							if ((matchedF && matchedF > matchLimit-1 && matchedF < title.length-matchLimit) || ((matchedF = 0) && false)) title = title.slice(matchedF);
							if ( matchedF && matchedF > matchLimit-1 && matchedF < titleCached.length-matchLimit && !finalArray[tempHash[t][1]] [0][0]++) 
								// assert the cached + altered title back into the ds
								titleCached = titleCached.slice(matchedF).replace(headTailSpaceRe, "$1"), finalArray[tempHash[t][1]] [1][3] = (titleCached.length>titleLimit)?titleCached.slice(0,titleLimit)+elipsis:titleCached, localRes  = finalArray[tempHash[t][1]] [2], localProp = this.rdf.GetResource(this.dataPrefix + 'label'), localOld  = datasource.GetTarget(localRes, localProp, true), localNew  = this.rdf.GetLiteral(  finalArray[tempHash[t][1]] [1].join("")  ), datasource.Change(localRes, localProp, localOld, localNew, true)/*, setTimeout("throw '1localOld: "+localOld.Value.replace(/\'/g,"`")+"  ->  localNew: "+localNew.Value.replace(/\'/g,"`")+"'",0)*/;
						}
						// XXX backward-replacement isn't always intuitive -- we can end up with stuff like: "amazon book search: o'hearn" + "amazon music search: o'hearn"  ->  "book" + "music" (which, by the way, didn't happen, because those results were under the min-limit; so the tail-match was discarded)
						if (!matchedB) {  // backward-search
							while (title[--countB] && title[countB] == titleCached[--countB2]) if (spaceRe.test(title[countB-1])) matchedB = countB-1, matchBII = (title[countB2-1]&&spaceRe.test(title[countB2-1]))? countB2-1:countB2;
							if ((matchedB && matchedB > matchLimit && title.length-matchedB > matchLimit) || ((matchedB = 0) && false)) title = title.slice(0, matchedB+1);
							if ( matchBII && matchBII > matchLimit && titleCached.length-matchBII > matchLimit && !finalArray[tempHash[t][1]] [0][1]++) 
								titleCached = titleCached.slice(0, matchBII+1).replace(headTailSpaceRe, "$1"), finalArray[tempHash[t][1]] [1][3] = (titleCached.length>titleLimit)?titleCached.slice(0,titleLimit)+elipsis:titleCached, localRes  = finalArray[tempHash[t][1]] [2], localProp = this.rdf.GetResource(this.dataPrefix + 'label'), localOld  = datasource.GetTarget(localRes, localProp, true), localNew  = this.rdf.GetLiteral(  finalArray[tempHash[t][1]] [1].join("")  ), datasource.Change(localRes, localProp, localOld, localNew, true)/*, setTimeout("throw '2localOld: "+localOld.Value.replace(/\'/g,"`")+"  ->  localNew: "+localNew.Value.replace(/\'/g,"`")+"'",0)*/;
						}
						if (matchedF && matchedB) break;
					}
				// forums.mozillazine.org  ->  [ f.mzln.org ]  ::  books.amazon.com  ->  [ b.amzn.com ]
				if (host.length > hostLimit && host.split(".").length > 1 && (host=host.split("."))) {
					for (var c = 0, alpha, alphaString; c < host.length-1 && host.join(".").length > hostLimit; c++) { 
						if ((host[c] = host[c][0] + host[c].slice(1).replace(vowelRe,"")) // ditch vowels
								&& host.join(".").length > hostLimit
								&& (alpha = {}) && (alphaString = "") ) { 
							for (var d in host[c]) if (!alpha[host[c][d]]) alphaString += alpha[host[c][d]] = host[c][d]; // ditch duplicate letters
							host[c] = alphaString; }
						if (c+1 < host.length-1 && host.join(".").length > hostLimit) host[c] = host[c][0]; }  // ditch all but the first letter
					host= hostLeft+ host.join(".") +hostRight; }
				hostHash[origHost].push([origTitle,n]);
			}
			if (!isTabMenu) host  = tabLeft+ snapBackArray[n][0][2]+(n==0?((parseInt(snapBackArray[n][0][2])>1?tabPlural:tabSingular)):"") +tabRight;

			// XXX theoretically, we could end up with a duplicate that would have been altered by secondary points, after the unaltered original. presently, the duplicate's changes would be lost.
			if (isDuplicate == false)
				 title            = preSliceTitle = (emptyRe.test(title)) ? (host==""||(host=="blank"&&(host=""))?blank:(isTabMenu?(spec=="about:blank"?blank:spec):blank)) : title.replace(headTailSpaceRe, "$1").toLowerCase(),
				 description_ptII = (host!=""?(joinder+host+spacer3):"");
			else title            = preSliceTitle = finalArray[isDuplicate][1][3],       
			     description_ptII = finalArray[isDuplicate][1][4];
			var accessKey = (++a > 26) ? "" : this.mb('sskey'+String.fromCharCode(97+a));
			var accessKeyDisplay = (accessKey == "") ? accessDefault : accessKey +accessRight;
			if (title.length > titleLimit) title = title.slice(0,titleLimit) +elipsis;
			var description = spacer1 + accessKeyDisplay + spacer2 + title + description_ptII;
			datasource.Assert(resource, this.rdf.GetResource(this.dataPrefix + 'label'), this.rdf.GetLiteral(description), true);
			datasource.Assert(resource, this.rdf.GetResource(this.dataPrefix + 'pos'  ), this.rdf.GetLiteral(n), true); // wow- using "#branch" resulted in much wierdness: the attribute's ultimate value was always pre-pended with "static."
			datasource.Assert(resource, this.rdf.GetResource(this.dataPrefix + 'aky'  ), this.rdf.GetLiteral(accessKey), true);
			sequence.AppendElement(resource);
			finalArray[n] = [[matchedF,matchedB],[spacer1,accessKeyDisplay,spacer2,preSliceTitle,description_ptII],resource]; // we could .push(), too; no difference
		}
		menu.builder.rebuild();
	},

	// Prompts for a session-name, then captures to it
	sessionPrompt: function() {
		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var done = false;
		var origEntry = "", modEntry;
		var junkTest = false, spaceTest = false;
		var junkRe = new RegExp("[^"+"wd.-+!@#$%^&*()=~?:;[]{}|\\/<>".replace(/(.)/g,"\\$1")+"]"); // -- /[^\w\d.\-+!@#$%^&*()=~?:;\[\]\{\}|\\\/\\<>]/ //[^_0-9a-zA-Z] -- en + em-dash don't play nice
		var spaceRe = new RegExp("^_*$");
		var titleText = this.mb('capturetitle');
		while(!done) {
			var promptText = this.mb('capturemsg');
			var alert = new Array();
			if (junkTest) alert.push(junkTest);
			if (spaceTest) alert.push(spaceTest);
			if (alert.length > 0) alert.unshift("\n");
			promptText += alert.join("");
			try{ origEntry = prompt(promptText, origEntry, titleText); }
			catch(e) {
				// @params: prompt(window, title, message, *out entry-text, checkbox message, *out checkbox-checked)
				var origEntryWrapped = {value:origEntry};
				origEntry = promptService.prompt(window, titleText,promptText,origEntryWrapped, null,{}) ?
						origEntryWrapped.value : null;			
			}
			if (typeof(origEntry) == "string") {
				modEntry = origEntry.replace(/ /g,'_'); // spaces -> underscores
				junkTest = junkRe.test(modEntry) ? this.mb('capturestandard'):false;
				spaceTest = spaceRe.test(modEntry) ? this.mb('capturespace'):false;
				if (!junkTest && !spaceTest) {
					this.hiddenObserver.captureAll(this.prefBranchStatic+modEntry+".", true, true); // @params: prefBranchSession, suppressSave, saveOnLast
					done = true; }
			}
			else done = true; 
		}
	},
	
	// Recaptures window on window-Close
	onClose: function(evt, isBaseClosure) {
		var shutdownRequested = this.checkShutdownRequest(null, true);
		if ((evt && /*window.__ssOrigClose*/ !shutdownRequested) || !this.autoMode) return true; // only continue if we wont be handled later (origClose) or we're running automated (n27)
		//alert("onClose: \n\n"+Boolean(this.origBrowserCloseWindow)+"\n\n    ->   \n\n"+Boolean(this.origWindowIsClosing)+"\n\n    ->   \n\n"+Boolean(window.__ssOrigClose));
		var isAutoRestore = this.autoLoad && (this.autoLoadBranch==this.prefBranchWindows || (this.shutdownsave && this.shutdownSaveBranch == this.autoLoadBranch));
		var lastBrowser = (this.getWindows("navigator:browser").length == 1); // we're not closed yet -- length:1
		if (lastBrowser && isAutoRestore) this.hiddenObserver.removeWarnOnClose(); // if we're closing the last browser, and explicitly restoring the current session at startup
		if (lastBrowser && !shutdownRequested && (shutdownRequested=true)) this.hiddenObserver.observe(null, "quit-application-requested", null);
		if (!isBaseClosure && (!shutdownRequested||this.hiddenObserver.saveConfirm)) // in case the user opts-out, as we're racing the shutdown-request
			try{ this.onTabLoad(null,null,null,true); } catch(e){setTimeout(function(e){throw 'SS onClose: '+e;},0,e); } // for shutdown by windowClosure -- recapture current scroll-states
		return true;
	},
	
	// Schedules pref-removal on window-Unload
	onUnload: function(evt) {
		if (evt.target // sidebar-closure trips us, and doesn't seem to include a target
				&& evt.target == evt.originalTarget // the targets don't match when a new document is simply unloading the old
				&& evt.target.nodeName.toLowerCase() != "tabbrowser") { // if the window is closing, not a tab..
			var metadata = [this.curTitle,this.curHost,this.lastTabCountForWindow];
			var lastBrowser = (this.getWindows("navigator:browser").length == 0); // everything's closed -- length:0
			var shutdownRequested = this.checkShutdownRequest(null, true);
			var pendingOrNot =  (lastBrowser || shutdownRequested) ?
				 "SessionSaver-WindowClosePending" // last browser or shutting-down -- schedule this window for removal, when another browser opens
				 : "SessionSaver-WindowClosed";    // not last + not shutting-down -- remove this window's session
			this.hiddenObserver.observe(metadata, pendingOrNot, this.winName); // XXX Note: passing our metadata-array via the observer-service resulted in an xpcom-wrapping -- with no discernable way of unwrapping
			if (lastBrowser && !shutdownRequested) this.hiddenObserver.observe(null, "quit-application-requested", null); // manually trip it, if necessary -- the hidden-window's onunload-handler will check, also
			
			this.orbiterControl(true); // orbiter check
		}
	},
	
	// Recaptures window on tab-close
	onTabUnload: function(evt) {
		// if not shutting down..
		if (!this.checkShutdownRequest(null, true) && evt.target == evt.originalTarget) // the targets don't match when a new document is simply unloading the old
			this.onTabLoad(); // a tab was closed -- recapture window
	},
	
	onTextInput: function(evt) {
		if (this.textInputRun) return;
		this.textInputRun = true; // in case we end up racing multiple calls
		var page = evt.originalTarget.ownerDocument;
		while (page.defaultView.frameElement) page = page.defaultView.frameElement.ownerDocument;
		//var browser = this.getBrowserForPage(page);
		var previousTime = page.__ssTextInputPrevious;
		if (previousTime && new Date().valueOf() - previousTime < 3000) return;
		page.__ssTextInputPrevious = new Date().valueOf(); // the property will be destroyed, on page-unload
		this.textInputRun = false;
	},
	
	// Stores the session for this window in its corresponding pref
	onTabLoad: function(evt, prefBranchSession, suppressSave, isWindowClosure, n) {
		
		// Ignore frame-loads
		if (evt && evt.originalTarget.defaultView &&
				evt.originalTarget.defaultView != evt.originalTarget.defaultView.top) // ps: onTabUnload() calls us without an event..
			return;
		
		// Retry later, if window-content is mid transition
		if (window._content == null && ((typeof(n) == 'undefined'?(n=0):n++)||true) && n < 10) // trickz fo' shorta code
			return window.setTimeout(function() {SessionSaver.onTabLoad(null,prefBranchSession,suppressSave,isWindowClosure,n);}, 100); // 10x retry-limit
			
		if (!(suppressSave||isWindowClosure)) this.checkShutdownRequest(true); // to "re-activate" pref-saving if a shutdown was prior-invoked (and stopped) -- suppressSave is sent by the shutdown-capture, so we'll ignore that case
		
		// if the 'sessionBranch' parameter wasn't passed, assume auto-save
		if (typeof(prefBranchSession) != "string") prefBranchSession = this.prefBranchWindows;

		// Save history locations for tabs
		var selectedtab = 0;
		var tabHistoryAll = new Array(), oldHistory, tabSession;
		var Tabbrowser = window.getBrowser();
		var Tabs = Tabbrowser.mTabContainer.childNodes;
		this.lastTabCountForWindow = Tabs.length; // for window-SnapBack
		this.activeTabsTemp = {}; // for tab-SnapBack (below) -- stored as property, so recallScroll() can access it, for snapbacked-flag removal
		var previousTabIDs = [];  // ditto.
		
		for (var i = 0; i < Tabs.length; i++) {
			var curTab = Tabs[i];
			var curBrowser = Tabbrowser.getBrowserForTab(curTab);
			//var curBrowser = Tabbrowser.browsers[i];
			try { oldHistory = curBrowser.sessionHistory; } 
			catch(e) { oldHistory = null; }
			
			tabSession = new Array();
			var postDataStream;
			if (oldHistory && oldHistory.count > 0) {
				var activeIndex = (oldHistory.index < 0) ? 0 : ((oldHistory.index > oldHistory.count-1) ? oldHistory.count-1 : oldHistory.index ); // ensure active-index exists
				tabSession.push("z"+curBrowser.markupDocumentViewer.textZoom); // text-zoom
				tabSession.push(activeIndex); // active-entry's index
				for (var j = 0, index = oldHistory.index; j < oldHistory.count; j++) { // the count is tested "live" -- preferable
					var historyData = new Array(), shHistoryEntry = oldHistory.getEntryAtIndex(j, false).QueryInterface(Components.interfaces.nsISHEntry); // it's a wrapped nsISHEntry + nsIHistoryEntry
					var url = shHistoryEntry.URI.spec;
					if (j == index) { // XXX NOT tested "live" -- theoretically, this would be a problem either way: if the index was updated to a shorter length and the cached-index was never reached, or the live-index jumped backwards, and was effectively skipped.  we'll err with the slight speed-gain from caching.
						try {
							var frames = curBrowser.contentWindow.frames, f = frames.length, frame;
							var frameArray = [];
							while (f-- > 0 && (frame=frames[f])) {
								if (!(frame.document && frame.document.location)) continue;
								var frameURL = escape(frame.document.location.href);
								var frameId = frame.frameElement.id ? escape(frame.frameElement.id) : "";
								frameArray.unshift(frameURL+","+frame.scrollX+","+frame.scrollY+","+frameId); } // XXX unshift, because we're counting down, remember!
							if (frameArray.length > 0) tabSession.unshift("f"+frameArray.join(":")); // frame-data -> send to front
						} catch(e) {}
						if (postDataStream = shHistoryEntry.postData) {
							var input = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
							input.init(postDataStream.QueryInterface(Components.interfaces.nsIInputStream)); 
							//setTimeout("throw('postData"+i+": "+postDataStream+" -> *"+postDataStream.available()+"*')",0);
							var postDataText = input.read(input.available());
							//setTimeout("throw('postDataText: *"+postDataText+"*')",0);
							if (postDataText != "") tabSession.unshift("p"+postDataText); } // post-data -> send to front
						if (url == "about:config") { // special case for about:config
							var doc = curBrowser.contentDocument, configTree = doc.getElementById("configTree"), configBox = doc.getElementById("textbox");
							historyData.push( (configTree ? configTree.treeBoxObject.getFirstVisibleRow():0) +","+ (configBox ? escape(configBox.value):"")  ); }
						else historyData.push( curBrowser.contentWindow.scrollX+","+curBrowser.contentWindow.scrollY ); // active-index scroll-position
						try{ var activeTitle = curBrowser.contentDocument.title } catch(e) { activeTitle = shHistoryEntry.title; } // for SnapBack -- snapbacked tabs don't have a title in their history-entry
						var activeURL = url;  } // ditto.
					else {
						var x={},y={};
						shHistoryEntry.getScrollPosition(x, y); // XXX we could get the max-value against zero, here
						historyData.push( String(x.value)+","+String(y.value) );  } // scroll-position
					historyData.push(url); // url
					tabSession.push(  historyData.join(this.D[1])  ); // scroll + url 
				}
			}
			else { // if no history is available (popups, etc.), manually create the entry
				activeURL = curBrowser.contentDocument.location.toString().replace(/&amp;/g, "&"); // url
				historyData = ["0,0",activeURL].join(this.D[1]); // scroll-position, url
				try { tabSession.push("z"+curBrowser.markupDocumentViewer.textZoom); } // text-zoom
				catch(e) { tabSession.push("z"+1); } 
				tabSession.push(0); // zero-index
				tabSession.push(historyData); // scroll + url
				try { activeTitle = curBrowser.contentDocument.title; } catch(e) { activeTitle = ""; } // url is caught, above -- again, SnapBack
			}
			// catch the current-tab
			var  isCurrentTab = (curTab == Tabbrowser.selectedTab);
			if ( isCurrentTab)    selectedtab = ordinal;
			if ((isCurrentTab && activeTitle && activeTitle != "") || !selectedtab || !this.curTitle || this.curTitle == "") // fallback through all tabs, in case the selected-tab has no title
				this.curTitle = activeTitle, this.curHost = activeURL; // for snapback-tabs
			
			var ordinal = (typeof(curTab.ordinal) == 'number') ? curTab.ordinal : i; // get ordinal (tab-modifier, eg. miniT), or normal index
			
			// Brilliant SnapBack - tabs
			// XXX we want to insert before the last "known" tab it was in front of -- this will be tricky
			var id = (!curTab.__ssSnapBackID) ? (curTab.__ssSnapBackID=""+this.tabCounter++) : curTab.__ssSnapBackID; // tag each browser, for snapback identification
			var snapBackPending = (this.activeTabs[id] && this.activeTabs[id][6]); // check for "snapback" flag -- for tabs which were opened, but whose history hasn't been added yet (pending timeout)
			if (snapBackPending == true) this.activeTabs[id][2] = previousTabIDs.join(" "), this.activeTabs[id][6] = "true", tabHistoryAll[ordinal] = this.activeTabs[id][1];
			this.activeTabsTemp[id] = snapBackPending ? this.activeTabs[id] : [ordinal,tabSession.join(this.D[2]),previousTabIDs.join(" "),id,activeTitle,activeURL,false];
			previousTabIDs.push(id);
			if (i+1 == Tabs.length) { 
				for (var c in this.activeTabs) if (!this.activeTabsTemp[c]) this.closedTabs.unshift(  this.activeTabs[c]  ); // XXX the id must be a string, or we end up setting id0 twice ( -- the existence test fails)
				this.activeTabs = this.activeTabsTemp; delete this.activeTabsTemp; }

			if (!tabHistoryAll[ordinal]) // if snapback didn't already handle it..
				tabHistoryAll[ordinal] = tabSession.join(this.D[2]); // join this tab's histories, and add them (directly) to the master-array
		}
		tabHistoryAll = tabHistoryAll.join(this.D[3]);   // join all tab-histories

		var chromeProperties = ""+ // coercion to string
				this.boolToPref[menubar.visible]+this.boolToPref[toolbar.visible]+
				this.boolToPref[locationbar.visible]+this.boolToPref[personalbar.visible]+
				this.boolToPref[statusbar.visible]+this.boolToPref[scrollbars.visible]; // window-chrome settings

		var prefArray = new Array(); // our window's attribute-array
		var tabCount = Tabbrowser.browsers.length;
		
		// window-zoom-state (d1 n20)
		var mainWindow = window.document.getElementById("main-window");
		var isMaximized = (window.windowState == window.STATE_MAXIMIZED);
		var ssWindowState = isMaximized ? 1:0; // the state_maximized property isn't set (yet) when we load, so we'll use our own system
		// on initial-load, the window's content-area isn't sized / positioned properly, so we'll prefer the attributes
		var content = window._content;
		var width =   (mainWindow.hasAttribute("width"  )) ? mainWindow.getAttribute("width"  ) : content.outerWidth;  // width
		var height =  (mainWindow.hasAttribute("height" )) ? mainWindow.getAttribute("height" ) : content.outerHeight; // height
		var screenX = (mainWindow.hasAttribute("screenX")) ? mainWindow.getAttribute("screenX") : content.screenX;     // pos.x
		var screenY = (mainWindow.hasAttribute("screenY")) ? mainWindow.getAttribute("screenY") : content.screenY;     // pos.y
		
		// XXX 'winName' is recycled only on startup-restore -- to ensure no conflicts
		prefArray.push(this.winName);       // window-name
		prefArray.push(width);              // width
		prefArray.push(height);             // height
		prefArray.push(screenX);            // screen-pos. x
		prefArray.push(screenY);            // screen-pos. y
		prefArray.push(chromeProperties);   // window chrome
		prefArray.push(selectedtab);        // selected-tab's index
		prefArray.push(tabCount);           // total tabs
		prefArray.push(tabHistoryAll);      // indexed-string of tab histories
		prefArray.push(ssWindowState);      // window-zoom-state (d1 n20)
		prefArray = prefArray.join(this.D[0]);

		// more uniform with sessionRecall()'s code:
		var sessionBranch = this.prefService.getBranch(this.prefBranch + prefBranchSession);
		sessionBranch.setCharPref(this.winName, prefArray);
		
		if (!suppressSave) this.hiddenObserver.observe(isWindowClosure, "SessionSaver-SavePrefFile", this.winName); // notify our hidden-window observer to save
	},
	
	// Loads the appropriate number of recalled-windows
	sessionRecall: function(overwriteTabs, prefBranchSession) {
		// if the 'prefBranchSession' parameter wasn't passed, assume auto-recall
		if (typeof(prefBranchSession) != 'string') prefBranchSession = this.prefBranchWindows;
		var sessionBranch = this.prefService.getBranch(this.prefBranch + prefBranchSession);
		
		// if the 'overwrite' parameter wasn't passed, get the pref
		if (typeof(overwriteTabs) != 'boolean') overwriteTabs = this.overwriteTabs;
		var wndArray, prefArray, prefName, morePrefArray;
		
		// if the cookies pref is present (d1 nightly 25)
		var cookies = (sessionBranch.prefHasUserValue("cookies")) ? sessionBranch.getCharPref("cookies") : ""; // could use 'null', but this way, we only test for one condition, next
		if (cookies != "") {
			// wipe all existing session-cookies, if overwriting windows + tabs (startup-restore really doesn't matter)
			if (this.overwriteWindows && overwriteTabs) {
				var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager); 
				var oldCookies = cookieManager.enumerator; 
				while (oldCookies.hasMoreElements()) {   
					var c = oldCookies.getNext().QueryInterface(Components.interfaces.nsICookie); 
					if (c.expires == 0) cookieManager.remove(c.host,c.name,c.path,false); } //void remove ( AUTF8String domain , ACString name , AUTF8String path , PRBool blocked ) -- blocked indicates if the host should be permanently blocked
			}
			// add-in this session's
			var ioService = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
			var cookieService = Components.classes["@mozilla.org/cookieService;1"].getService(Components.interfaces.nsICookieService);
			var current; cookies = cookies.split("  |");
			while (current = cookies.shift()) {
				var origCurrent = current;
				current = current.match(/^([^ ]+) (.+)$/);
				if (!(current && current[1] && current[2])) { if (!erred) setTimeout("throw 'cookies: "+cookies+"';"); var erred = true; setTimeout("throw 'cookie failed: "+origCurrent+"';"); continue; }
				var uri = ioService.newURI(current[1], null, null);
				var cookieString = current[2] +"expires=0;"; // "pair=nostuff;domain=places.com;path=/;expires=0;";
				cookieService.setCookieString(uri, null, cookieString, null); } // XXX do NOT set a cookie without a uri -- crashes moz1.3.1
		}

		// if the z-order pref is present (d1 nightly 7)
		if (sessionBranch.prefHasUserValue("zorder") && sessionBranch.getCharPref("zorder") != "") {
			wndArray = sessionBranch.getCharPref("zorder").split(",");
			for (var m in wndArray) wndArray[m] = prefBranchSession + wndArray[m];
			var branches = this.Branch.getChildList(prefBranchSession, {}); // array of pref-names holding window-sessions
			var pruneString = wndArray.join(" ") +" "+ prefBranchSession+"zorder"; // ..save the z-order, too -!
			pruneString += " "+prefBranchSession+"cookies"; // ..and the cookies -!!
			for (var b in branches) if (pruneString.indexOf(branches[b]) == -1) this.Branch.deleteBranch(branches[b]); // prune non-z-indexed branches (unneeded)
		}
		else {
			wndArray = this.Branch.getChildList(prefBranchSession, {}); // array of pref-names holding window-sessions
			function compareFunction(a, b) {
				a = parseInt(a.replace(/\D*(\d+)$/, "$1")); // get trailing digits from string
				b = parseInt(b.replace(/\D*(\d+)$/, "$1"));
				return a-b; }
			wndArray.sort(compareFunction); // the ordering is initially skewed / random
		}
		
		// ignore empty prefs (user reset) and z-order pref
		for (var i = 0 ; i < wndArray.length ; i++) 
			if (!this.Branch.prefHasUserValue(wndArray[i]) || /(cookies|zorder)$/.test(wndArray[i]) ) 
				wndArray.splice(i--, 1);
		
		// if overwriting windows, close excess (d1 nightly 19)
		if ((wndArray.length > 0) && (this.overwriteWindows || prefBranchSession == this.prefBranchWindows)) {
			var openWindows = this.getWindows("navigator:browser"); // Note: we can't use z-order listing, because it does something really weird when there's only one window (moz1.3.1) : the first window is ignored, while a child is force-opened, which then loads normally
			var p = -1;
			while (openWindows.length > wndArray.length)
				if (openWindows[++p] != window) { openWindows[p].close(); openWindows.splice(p--, 1); }
		}
		
		// if the window-concatenation pref is present (d1 nightly 17)
		if (this.concatenate) {
			for (var more = 0, tripFlag = 0; more < wndArray.length; more++) {
				morePrefArray = this.Branch.getCharPref(wndArray[more]).split(this.D[0]); // get stored window-session from pref
				if (!prefArray) { prefArray=morePrefArray; prefName=wndArray[more]; continue; } // only get 'prefArray' once -- skip adjustments, when doing so
				
				prefArray[1]   = Math.max(prefArray[1]?prefArray[1]:morePrefArray[1], morePrefArray[1]); // use the greatest width of all
				prefArray[2]   = Math.max(prefArray[2]?prefArray[2]:morePrefArray[2], morePrefArray[2]); // use the greatest height of all
				prefArray[3]   = Math.min(prefArray[3]?prefArray[3]:morePrefArray[3], morePrefArray[3]); // use the left-most x.position
				prefArray[4]   = Math.min(prefArray[4]?prefArray[4]:morePrefArray[4], morePrefArray[4]); // use the top-most y.position
				prefArray[5]   = (tripFlag++ == 0) ? prefArray[5].replace(/0/g, "1") : prefArray[5]; // we could parseInt() and get the max, but this would (theoretically) be undesirable, since concatenated popups wouldn't have certain chrome, yet in tabbed/concatenated mode, we'd want them to
				prefArray[7]  += morePrefArray[7]; // tabCount: we don't even use this, but it doesn't hurt..
				//var localCount = morePrefArray[7];
				//selectedtab  = selectedtab + localCount-1; // selectedtab is zero-based
				prefArray[6]   = morePrefArray[6];
				prefArray[8]   = (more > 0) ? new Array(morePrefArray[8], prefArray[8]).join(this.D[3]) : prefArray[8];
				prefArray[9]   = (tripFlag++ == 1 && typeof(prefArray[9]) != "undefined") ? 0 : prefArray[9]; // don't maximize (d1 n20)
				wndArray.splice(more--, 1); }
		}

		for (var w = 0 ; w < wndArray.length ; w++) {
			if (this.concatenate) {if (!prefArray) break;}
			else {
				prefArray = this.Branch.getCharPref(wndArray[w]).split(this.D[0]); // get stored window-session from pref
				if (wndArray.length == 1) {									// if only restoring one window:
					if (parseInt(prefArray[1]) < 200) prefArray[1] = 640; 	// disallow width  below 200px
					if (parseInt(prefArray[2]) < 150) prefArray[2] = 480; 	// disallow height below 150px
					if (parseInt(prefArray[3]) > screen.width-200)  prefArray[3] = 0; 	// disallow x.position beyond 200px from right
					if (parseInt(prefArray[4]) > screen.height-150) prefArray[4] = 0; 	// disallow y.position beyond 150px from bottom
					prefArray[5] = prefArray[5].replace(/0/g, "1"); 					// force full-chrome
				}
				prefName = wndArray[w]; }
						
			if (openWindows && openWindows[0]) // current window will be included
				openWindows.shift().SessionSaver.windowRecall(prefName, prefArray, overwriteTabs);
			else this.childRecall(prefName, prefArray); // ..otherwise, load the child.
		}
		
		if (!prefArray) this.onLoadPtII("partial"); // attach pref-observer, if load didn't complete
	},
	
	// Opens a child window with relevant session-data
	childRecall: function(prefName, prefArray) {
		var name = prefArray[0]+new Date().valueOf(); // make name "unique" (for window-mediator)
		var propArray = this[name] = ['placeholder', prefName, prefArray, true]; // store tab-histories as window.opener.(this.)name[]
		var windowArgs = ",width="+prefArray[1]+",height="+prefArray[2]+",screenx="+prefArray[3]+",screeny="+prefArray[4]; // doesn't always resize/position properly, so we also manually set these on window-load (first listener)
		var windowHandler = window.openDialog(this.browserChromeUrl, name, "chrome,all,dialog=no"+windowArgs, null);
		propArray[0] = windowHandler;
	},
			
	// Loads stored properties for current window
	windowRecall: function(prefName, prefArray, overwriteTabs) {
		if (prefName && prefName.match(/^[^\.]+\./)[0] == this.prefBranchWindows) { // if auto-recall (where branches / sessions are fixed)
			prefArray[0] = prefArray[0].replace(new RegExp(this.winPrefPrefix), ""); // ditch the lame "prefix" we used to attach (n19)
			this.winName = prefArray[0]; // hijacks the existing pref-branch
			this.winSlot = this.winName.match(/\d+$/)[0]; // extract index from name-string
			this.hiddenObserver.reserveSlot(this.winSlot, true); } // "reserve" index, overriding if necessary
		var content = window._content;
		if (new RegExp("^"+prefArray[0]).test(window.name) == false) window.name = prefArray[0]+new Date().valueOf(); // child-recalled windows are named when opened
		if (overwriteTabs) { // if overwriting tabs, assume layout can be overridden also
			content.outerWidth  = prefArray[1];
			content.outerHeight = prefArray[2];
			content.screenX     = prefArray[3];
			content.screenY     = prefArray[4];
			content.moveTo(prefArray[3], prefArray[4]);
			if (prefArray[9] == "1") window.maximize(); // handle window-zoom (d1 n20)
			
			var chromeProperties = prefArray[5].split("");
			menubar.visible = 		this.boolToPref[chromeProperties[0]]; // menubar chrome
			toolbar.visible = 		this.boolToPref[chromeProperties[1]]; // toolbar chrome
			locationbar.visible = 	this.boolToPref[chromeProperties[2]]; // locationbar chrome
			personalbar.visible = 	this.boolToPref[chromeProperties[3]]; // personalbar chrome
			statusbar.visible = 	this.boolToPref[chromeProperties[4]]; // statusbar chrome
			scrollbars.visible = 	this.boolToPref[chromeProperties[5]]; // scrollbar chrome
		}

		// restore window-tabs
		var selectedtab      = prefArray[6];
		var tabCount         = prefArray[7];
		var tabHistoryAll    = prefArray[8];
		this.tabRecall(tabHistoryAll, selectedtab, overwriteTabs);
	},
	
	// Loads the appropriate number of recalled-tabs in a window
	tabRecall: function(tabHistoryAll, selectedtab, overwriteTabs) {
		var Tabbrowser = window.getBrowser();
		var sessionTabs = tabHistoryAll.split(this.D[3]);
		var currentTabs = new Array();
		var openTabCount = Tabbrowser.browsers.length;
		var showFX = !this.snapback_noFX;
		var x;
		
		if (showFX && overwriteTabs) Tabbrowser.mTabContainer.childNodes[0].parentNode.setAttribute("ss_f", 0); // fade-in prelim
		//if (overwriteTabs) Tabbrowser.mTabContainer.childNodes[0].setAttribute("ss_f", 0); // fade-in prelim for first-tab
		
		for (var t = 0 ; t < sessionTabs.length ; t++) {
			//sessionTabs[t] = sessionTabs[t].split(this.D[2]); // we'll do this later.
			if (!overwriteTabs || t >= openTabCount) // if we're not overwriting (current-window), OR we need another tab..
				currentTabs.push( (!showFX || overwriteTabs) ? Tabbrowser.addTab() : this.addPositionedTab(x,x,x,x, [['ss_f',0]]) ); // ..open a new tab
			else if (overwriteTabs && t < openTabCount)
				currentTabs.push(Tabbrowser.mTabContainer.childNodes[t]); // otherwise, reuse the existing tab.
		}

		// if overwriting, close any leftover tabs
		if (overwriteTabs)
			for (var i = sessionTabs.length; i < openTabCount; i++)
				Tabbrowser.removeTab(i);
		
		// initiate fade-in
		if (showFX) {
			if (overwriteTabs) { 
				Tabbrowser.mTabContainer.childNodes[0].boxObject.parentBox.setAttribute("ss_f", 0); // more fade-in prelim
				Tabbrowser.mTabContainer.childNodes[0].parentNode.removeAttribute("ss_f");          // ditto.
				this.flasher.start(Tabbrowser.mTabContainer.childNodes[0].boxObject.parentBox, true, "fade-inQ", 40); } // the fade.
			else
				for (var f = 0 ; f < sessionTabs.length ; f++)  
					this.flasher.start(currentTabs[f], true, "fade-in", null, (f+1<sessionTabs.length)?true:false, .75, (f==selectedtab)?currentTabs[f]:null, false, 500, false);
		}
		
		// restore tab-histories
		var isStartup = !this.activated;
		window.setTimeout(function() {SessionSaver.historyRecall(sessionTabs, currentTabs, selectedtab, overwriteTabs, isStartup);}, 100);
		
		// attach pref-observer, now that load is complete
		this.onLoadPtII("full");
	},
	
	// Loads the histories into recalled-tabs
	historyRecall: function(sessionTabs, currentTabs, selectedtab, overwriteTabs, isStartup, n) {
	
		var ioService = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
		for (var t = 0, previousTabIDs=[]; t < sessionTabs.length; t++) {
			var curTab     = currentTabs[t];
			var curBrowser = getBrowser().getBrowserForTab(curTab);
			var curWebNav  = curBrowser.webNavigation;

			// Check if we're loaded enough to continue
			if (t == 0) {
				try {  curWebNav.sessionHistory;  }
				catch(e) {
					if (((typeof(n) == 'undefined'?(n=0):n++)||true) && n < 10) // smokin some izzerb, that was flowin from the kizzerb.
						return window.setTimeout(function(){ SessionSaver.historyRecall(sessionTabs, currentTabs, selectedtab, overwriteTabs, isStartup, n); },100); // 10x retry-limit
				}
			}
			
			// Retrieve session history of current tab
			var newHistory = curWebNav.sessionHistory.QueryInterface(Components.interfaces.nsISHistoryInternal);
			
			// If necessary, clear current-session's history
			if (newHistory.count > 0) newHistory.PurgeHistory(newHistory.count);
			
			// tab-properties
			var tabSession  = sessionTabs[t].split(this.D[2]);
			var frameData   = (tabSession[0].charAt(0) == "f") ? tabSession.shift().slice(1) : null; // frame-data, if any (nightly 27)
			var postData    = (tabSession[0].charAt(0) == "p") ? tabSession.shift().slice(1) : null; // post-data,  if any (nightly 26)
					if (tabSession[0].charAt(0) != "z") tabSession.splice(0, 0, "z1.0"); // add text-zoom if not stored (history-string will be in slot[1])
			var textZoom    = parseInt( tabSession[0].substr(1, tabSession[0].length-1) ); // text-zoom (nightly 13)
			var activeIndex = parseInt( tabSession[1] );
			var tabHistory  = tabSession.slice(2); // the rest of our "session-array" is tab history

			// Reinstate saved-history
			activeIndex = (activeIndex < 0) ? 0 : ((activeIndex > tabHistory.length-1) ? tabHistory.length-1 : activeIndex ); // ensure active-index exists
			for (var i = 0; i < tabHistory.length; i++) {
				var entry = tabHistory[i].split(this.D[1]);
				var scrollPosition = entry[0].split(","); // array of x + y values
				var historyURL = entry[1];
				//if (historyURL == "about:blank" && tabHistory.length > 2) continue; // skip "blank" entries, if there's more
				
				var newEntry = Components.classes['@mozilla.org/browser/session-history-entry;1'].createInstance(Components.interfaces.nsISHEntry);
				var newURI = ioService.newURI(historyURL, null, null);
				newEntry.SetURI(newURI);
				newEntry.setScrollPosition( scrollPosition[0], scrollPosition[1] ); // x-pos, y-pos
				//newEntry.saveLayoutStateFlag = true;
				newEntry.loadType = Components.interfaces.nsIDocShellLoadInfo.loadHistory; // http://lxr.mozilla.org/seamonkey/source/docshell/base/nsIDocShellLoadInfo.idl#73
				if (postData) {
					var stringStream = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
					stringStream.setData(postData, -1);
					newEntry.postData = stringStream; } // set post-data -- this is only captured for the active-page
				
				newHistory.addEntry(newEntry, true);
				
				try{
				if (i == activeIndex) var activeScrollPosition = scrollPosition, 
						activeURL = newURI.spec,   activeHost = newURI.host; // get url + scroll-values for the active-page
				} catch(e) {}
			}
			
			// Reselect tab that was open when session was stored
			if (t == selectedtab && overwriteTabs) getBrowser().selectedTab = curTab;

			// Set SnapBack history, so the tab can be restored, even if closed before finished loading
			var ordinal = (typeof(curTab.ordinal) == 'number') ? curTab.ordinal : t; // get ordinal (tab-modifier, eg. miniT), or normal index
			var id = (!curTab.__ssSnapBackID) ? (curTab.__ssSnapBackID=""+this.tabCounter++) : curTab.__ssSnapBackID; // tag each browser, for snapback identification
			if (activeURL == "about:blank") var snapTitle = "", snapHost = activeURL; // about:blank has no title, and we still need its host to reflect the original, for recallScroll's location-load compare
			else snapTitle = activeURL, snapHost = activeHost;
			if (!(this.activeTabs[id] && this.activeTabs[id][6] in {'true':0})) { // snapback manually updates this array, so we don't need to test the active-temp -- it wont reflect.
				this.activeTabs[id] = [ordinal,sessionTabs[t],previousTabIDs.join(" "),id,snapTitle,snapHost,true]; // XXX flag-6 will also let onTabLoad know to lend us the Valid previousID-list
				if (this.activeTabsTemp) this.activeTabsTemp[id] = this.activeTabs[id];  }
			previousTabIDs.push(id);

			// Restore scroll-position + text-zoom + frame-stuff -- once tab loads
			if (isStartup && this.orbiterChild) this.orbiterChild++; // so we know when all startup-tabs have loaded
			curBrowser.__ssRecallParams = {  SessionSaver: this,
			                                 t:            t,
			                                 id:           id,
			                                 scrollX:      activeScrollPosition[0], // this avoids closure-access, on the locally-instantiated array
			                                 scrollY:      activeScrollPosition[1], 
			                                 frameData:    frameData, 
			                                 activeURL:    activeURL, 
			                                 textZoom:     textZoom,
			                                 curTab:       curTab, 
			                                 recallScroll: this.recallScroll  };
			
			var recallScroll = curBrowser.__ssRecallScroll = this.recallScroll;
			curBrowser.addEventListener('load', recallScroll, true); // <- Focal of scroll-restore (offloaded, now)
			function timedRecall(curBrowser){curBrowser.__ssRecallScroll(null,true);} // we'll pass the browser directly, since we're looping in the closure, and i'm not sure how "frozen" our spot in the loop-update stands
			setTimeout(timedRecall, 1500, curBrowser) // to speed-up "apparent" restoration
	
			// Jump to active history-index (stored when saved)
			if (tabSession.length > 1 && activeIndex >= 0) {
				try{ curWebNav.gotoIndex(activeIndex); }
				catch(e) { /*continue;*/ } // skip scroll-recall if we can't load the tab
			}
			
		}
		if (isStartup && this.orbiterChild)
			 this.orbiterChild--, // jump down to zero-based (we began at '1')
			 setTimeout(function(ssObj){ssObj.orbiterControl(true);},180000,this); // 3min fallback
	},	
	
	// Restores scroll-position + text-zoom + frame-stuff -- once tab loads
	recallScroll: function (evt, isTimedCall) {
		if ((isTimedCall && !this.__ssRecallParams) || !(evt && evt.originalTarget && evt.originalTarget.defaultView && evt.originalTarget.defaultView == evt.originalTarget.defaultView.top))
			return;
		var p = this.__ssRecallParams, check = 0; // we don't use 'check' yet, but it should allow us to remove the load-listener in advance, if the timeout correctly recalls everything first.
		var recallScroll = p.recallScroll, ssObj = p.SessionSaver, x = p.scrollX, y = p.scrollY; id = p.id; // id is actually declared, below
		if (!isTimedCall) {  delete this.__ssRecallParams; this.removeEventListener('load', recallScroll, true); }
		// Check for "snapback" flag -- for tabs which were opened, but whose history hasn't been added yet (pending timeout)
		if (ssObj.activeTabs[id] && ssObj.activeTabs[id][6] in {'true':0}) ssObj.activeTabs[id][6] = false; // Remove "snapback-pending" flag, so new history will be captured
		if (ssObj.activeTabsTemp && ssObj.activeTabsTemp[id] && ssObj.activeTabsTemp[id][6] in {'true':0}) ssObj.activeTabsTemp[id][6] = false;
		this.markupDocumentViewer.textZoom = p.textZoom;
		if (this.contentWindow.location != p.activeURL){/*alert((isTimedCall?"timed-":"")+"recallScroll failed: "+this.contentWindow.location+"  ->  "+p.activeURL);*/  return (isTimedCall) ? null : ssObj.orbiterControl(); } // the user probably loaded a new page, before this one had finished
		if (p.activeURL == "about:config") { // special case for about:config
			var textbox = this.contentDocument.getElementById("textbox"); 
			var tree    = this.contentDocument.getElementById("configTree"), row = parseInt(x);
			try{  textbox.value = unescape(y), textbox.focus(), textbox.doCommand();  } catch(e){} 
			setTimeout(function() {  try{textbox.doCommand();}catch(e){} setTimeout(function(){ try{tree.treeBoxObject.scrollToRow(row);}catch(e){} },0);   },0);   }
		else if (x>0||y>0) this.contentWindow.scrollTo(x,y), check++; // only scroll if we're going anywhere..
		// Restore frames, if possible
		if (!p.frameData)  return ssObj.orbiterControl(); // XXX orbiter
		var localFrames = this.contentWindow.frames;
		var frameInfo = p.frameData.split(':');
		var onlyById = (localFrames.length != frames.length);
		var onFrameLoad = function(){ this.removeEventListener('load', onFrameLoad, true); var s = this.__ssScroll; x2 =s[0],y2 =s[1]; delete this.__ssScroll; if (this.contentWindow.location == this.__ssUrl && (x2>0||y2>0)) this.contentWindow.scrollTo(x2,y2); /*setTimeout("throw 'frameData-III: "+p.t+"  ->  "+x2+":"+y2+"  ->  "+this.__ssUrl+"'");*/  return ssObj.orbiterControl(); };
		var local, deferred;
		for (var c = 0, checkHash = {}, checkUrl; c < frameInfo.length;   c++) frameInfo[c]=frameInfo[c].split(","), checkUrl=unescape(frameInfo[c][0]), (!checkHash[checkUrl] && (checkHash[checkUrl]={length:0})), checkHash[checkUrl][c] = checkHash[checkUrl].length++; // this way, we can determine how many came before a given entry
		for (var d = 0, frameHash = {}, frameUrl; d < localFrames.length; d++) local = localFrames[d].frameElement, frameUrl=local.contentWindow.location, (!frameHash[frameUrl] && (frameHash[frameUrl]=[])), frameHash[frameUrl].push(local), local.__ssFrameHashIndex = frameHash[frameUrl].length-1, local.__ssFrameURL = frameUrl;
		for (var f = 0, frameElem; f < frameInfo.length; f++)  {
			var url =unescape(frameInfo[f][0]), id =unescape(frameInfo[f][3]), x2 =parseInt(frameInfo[f][1]), y2 =parseInt(frameInfo[f][2]);
			if (id != '') { if (frameElem = this.contentDocument.getElementById(id)) if (typeof(frameElem.__ssFrameHashIndex)!='undefined') frameHash[frameElem.__ssFrameURL].splice(frameElem.__ssFrameHashIndex,1)[0]; checkHash[url].length--; }
			if (!frameElem) { // if we couldn't get by id, we'll lookup all frames matching this url and choose one as close to the original hierarchy as possible
				var cLength = checkHash[url].length, fLength = (frameHash[url])?frameHash[url].length:0, cPos = checkHash[url][f];
				if (fLength == 0) continue;
				if (cPos > fLength-1) { frameElem = frameHash[url].pop(); checkHash[url].length--;  }
				else { frameElem = frameHash[url].splice(Math.min(cPos,fLength-1),1)[0]; checkHash[url].length--; } // no need to remove the check's hashed index-value
			}
			if (!frameElem || !(x2>0||y2>0)) continue;
			var frameView = frameElem.contentWindow;
			var scrollMax = frameView.scrollMax ? {x:frameView.scrollMaxX,y:frameView.scrollMaxY} : {x:frameElem.contentDocument.width,y:frameElem.contentDocument.height}; // newer builds have .scrollMax(X/Y), but all we can get for older builds is the document's complete width/height, which are slightly larger than the max scroll-zone -- but only slightly.
			if (frameView && frameView.location == url && scrollMax.x >= x2 && scrollMax.y >= y2)
				(x2>0||y2>0) && frameView.scrollTo(x2,y2);
			else if (!frameElem.__ssUrl) { // only if the timed-call didn't already set this
				frameElem.__ssScroll = [x2,y2];
				frameElem.__ssUrl    = url;
				frameElem.addEventListener('load', onFrameLoad, true);
				if (frameView && frameView.location != url) frameView.location = url, deferred = true;   }
		}
		if (!deferred) ssObj.orbiterControl(); // XXX orbiter
	},

	// Returns all open windows of a specified type
	getWindows: function(windowType, frontToBack) {
		if (typeof(frontToBack) != "undefined") 
			var enumerator = this.windowMediator.getZOrderDOMWindowEnumerator(windowType?windowType:null, frontToBack); // windowType, eg. 'navigator:browser'
		else enumerator = this.windowMediator.getEnumerator(windowType?windowType:null);
		var windowArray = new Array();
		
		while (enumerator.hasMoreElements())
			windowArray.push(enumerator.getNext());
		
		return windowArray;
	},

	// Returns the owning browser, for a given webpage
	getBrowserForPage: function(page) {
		var browsers = window.getBrowser().browsers; // the .getBrowser method resolves tabbed vs. non-tabbed modes -- otherwise, we'd just get .browsers directly
		// contentWindow: local window  -  contentDocument: local document
		for (var b = 0, match = false; b < browsers.length &! match; b++) {
			try { if (browsers[b].contentDocument == page)  match = browsers[b]; } // end loop
			catch(e) { /*alert("SessionSaver: unable to access browsers[" + b + "].contentWindow:\n\n" + e);*/ }
		}
		return match;
	},

	// Checks if a shutdown request has been observed
	checkShutdownRequest: function(overrideClock, ignoreTime) {
		var shutdownRequested = (this.hiddenObserver && this.hiddenObserver.shutdownRequested); // check observer-object's flag
		// If the request was observed over 30 seconds ago, OR something new is loading, 
		// the user probably did something to keep things alive
		var ALongTimeAgo = (shutdownRequested && !ignoreTime &&
				(overrideClock ||
				(this.hiddenObserver.shutdownRequestedTime && 
						new Date().valueOf() - this.hiddenObserver.shutdownRequestedTime > 30000)));
		if (ALongTimeAgo) {
			shutdownRequested = this.hiddenObserver.shutdownRequested = false;
			this.hiddenObserver.saveConfirm = true;
			this.settingsBranch.setBoolPref("shutdown", false);
			this.hiddenObserver.observe(null, "SessionSaver-WindowCloseFlush", null); // flush any pending window-closures
			this.hiddenObserver.restoreWarnOnClose(); }  // restore browser.tabs.warnOnClose
		if (!shutdownRequested && this.cachedShutdownRequested) delete this.cachedShutdownRequested;
		return shutdownRequested;
	},

	// Checks if SessionSaver is loaded (to avoid "crash recovery" for new browser-windows)
	checkLoaded: function() {
		var alreadyLoaded = (typeof(this.hiddenWnd.SessionSaverObserver) != 'undefined'); // are we already loaded?
		
		if (!alreadyLoaded)
			this.hiddenWnd.SessionSaverLoader = this,
			this.Loader.loadSubScript("chrome://sessionsaver/content/sessionsaver.js", this.hiddenWnd);
		else
			this.hiddenWnd.SessionSaverObserver.observe(null, "SessionSaver-WindowCloseFlush", null); // flush any pending window-closures
		
		return alreadyLoaded;
	},

	// Set version-dependant prefs
	setPrefs: function() {
		this.prefBranchInitialized = "prefs_set";

		var current = this.version =   "0.2.1.27.1"; // eg:   0.2.1.27.1    ->    v.2 d1 nightly 27 pass1
		var prefVer = this.Branch.prefHasUserValue(this.prefBranchInitialized) ? this.Branch.getCharPref(this.prefBranchInitialized) : null;

		// critical changes across our builds can be handled, this way
		if (this.versionCheck(prefVer, "0.2.1.24.1")   == -1)
			this.settingsBranch.deleteBranch('mode'),             // remove deprecated prefs
			this.Branch.deleteBranch('default_session.'),
			this.switchSessionDelimiters(this.prefBranchWindows), // update delimiters
			this.switchSessionDelimiters(this.prefBranchStatic);

		if (this.versionCheck(prefVer, "0.2.1.25.3.4") == -1)
			if (this.rootBranch.getPrefType("javascript.options.showInConsole") == Components.interfaces.nsIPrefBranch.PREF_BOOL)
				this.rootBranch.setBoolPref("javascript.options.showInConsole", true); // show extension-errors

		if (this.versionCheck(prefVer, "0.2.1.27.1")   == -1)
			this.switchSessionPrefs(this.prefBranchStatic),       // update existing prefs to the new backup-suffix
			(this.crashLoad && this.settingsBranch.deleteBranch("crashload")), // we don't expose this pref, anymore -- default:true
			(this.settingsBranch.prefHasUserValue('filemenu') && !this.settingsBranch.getBoolPref('filemenu') && this.settingsBranch.deleteBranch("filemenu")); // we don't expose this pref, anymore -- default:false

		if (this.versionCheck(prefVer, "0.2.1.27.555") ==  0)     // internal build only
			this.switchSessionDelimitersBecause_rueMessedUp(this.prefBranchWindows), // reversion
			this.switchSessionDelimitersBecause_rueMessedUp(this.prefBranchStatic);  // two

		var isCurrent = (this.versionCheck(current, prefVer) == 0);
		if (!isCurrent) this.Branch.setCharPref(this.prefBranchInitialized, current) // update pref, if necessary
	},

	// Compare tokenized version-strings
	versionCheck: function(newVer, oldVer) {
		if (!newVer || ! oldVer) return (newVer||oldVer) ? (newVer?1:-1) : 0;
		var newArray = newVer.split("."), oldArray = oldVer.split(".");
		var n = 0, decided = 0;
		var hasDifferentLength = (oldArray.length != newArray.length);
		if (hasDifferentLength && newArray.length > oldArray.length) var longer = newArray, shorter = oldArray;
		else longer = oldArray, shorter = newArray;
		while (decided == 0 && longer.length > 0) {
			if (hasDifferentLength && !shorter[0]) { 
				while (parseInt(longer[0]) == 0) longer.shift(); 
				if (longer[0] && parseInt(longer.shift()) > 0) decided = longer; }
			else {
				var first = longer.shift(), second = shorter.shift();
				if (parseInt(first) > parseInt(second)) decided = longer;
				else if (parseInt(first) < parseInt(second)) decided = shorter; }
		}
		if (typeof(decided) == "object") decided = (decided == newArray) ? 1 : -1; // tri-state flag: -1:older, 0:same, 1:newer
		return decided;
	},
	
	// n24: it seems the pipe "|" is legal for urls, so we're moving to a new token-set
	switchSessionDelimiters: function(prefBranchSource) {
		//this.oldD = [" ",  "|", "||", "|||"];
		//this.D =    ["  ", "| "," |", " ||"];
		var d0 = new RegExp(this.oldD[0], "g");
		var d1 = new RegExp(this.oldD[1].replace(/(.)/g,"\\$1"), "g");
		var d2 = new RegExp(this.oldD[2].replace(/(.)/g,"\\$1"), "g");
		var d3 = new RegExp(this.oldD[3].replace(/(.)/g,"\\$1"), "g");
		var i2 = /\n/g;
		var i3 = /\t/g;
		var n0 = this.D[0];
		var n1 = this.D[1];
		var n2 = this.D[2];
		var n3 = this.D[3];
		isUpdatedRe = new RegExp(n0, "g");
		var branches = this.Branch.getChildList(prefBranchSource, {}); // array of pref-names holding window-sessions
		var sourceRe = new RegExp("^"+prefBranchSource);
		var sourceBranch = this.prefService.getBranch(this.prefBranch+prefBranchSource);
		for (var n in branches) { 
			var prefName = branches[n].replace(sourceRe, "");
			if (prefName in {"cookies":0,"zorder":0}) continue; // skip cookies + zorder
			if (sourceBranch.getPrefType(prefName) == Components.interfaces.nsIPrefBranch.PREF_STRING) {
				var string = sourceBranch.getCharPref(prefName);
				if (isUpdatedRe.test(string)) return; // XXX don't continue if the pref matches on our updated-delimiter
				else string = string.replace(d0,n0).replace(d3,"\t").replace(d2,"\n").replace(d1,n1).replace(i2,n2).replace(i3,n3);
				sourceBranch.setCharPref(prefName, string); }
		}
	},
	
	// n27: the old-style "rolling-suffix" wasn't good, so we're switching
	switchSessionPrefs: function(prefBranchSource) {
		var branches = this.Branch.getChildList(prefBranchSource, {}); // array of pref-names holding window-sessions
		var checkHash = {};
		var sourceRe = new RegExp("^("+prefBranchSource+".*?)[^\.]+$");
		var sourceBranch = this.prefService.getBranch(this.prefBranch+prefBranchSource);
		var testString = "_(SS_rolling-prior).";
		var testRe = new RegExp(testString.replace(/(\W)/g,"\\$1")+"$"); //  /\_\(SS\_rolling\-prior\)\./;
		setTimeout(function(){throw testRe;});
		// switch with case-variables
		for (var n in branches) { 
			var prefBranchTarget = branches[n].replace(sourceRe, "$1");
			if (checkHash[prefBranchTarget] || !testRe.test(prefBranchTarget)) continue;
			/*setTimeout(function(a){throw a.replace(/'/g,"`");},0,prefBranchTarget);*/
			if ((checkHash[prefBranchTarget] = true) && this.hiddenObserver.rollBranch(prefBranchTarget,prefBranchTarget.replace(testRe,".")))
				/*setTimeout(function(a){throw a.replace(/'/g,"`");},0,prefBranchTarget),*/ this.Branch.deleteBranch(prefBranchTarget); 
		}
	},
	
	// "no fear."
	switchSessionDelimitersBecause_rueMessedUp: function(prefBranchSource) {
		//this.oldD = [" ",  "|", "||", "|||"];
		//this.D =    ["  ", "| "," |", " ||"];
		var o0 = new RegExp(this.D[0], "g");
		var o1 = new RegExp(this.D[1].replace(/(.)/g,"\\$1"), "g");
		var o2 = new RegExp(this.D[2].replace(/(.)/g,"\\$1"), "g");
		var r0 = this.oldD[0];
		var r1 = this.oldD[1];
		var r2 = this.oldD[2];
		var branches = this.Branch.getChildList(prefBranchSource, {}); // array of pref-names holding window-sessions
		var sourceRe = new RegExp("^"+prefBranchSource);
		var sourceBranch = this.prefService.getBranch(this.prefBranch+prefBranchSource);
		for (var n in branches) { 
			var prefName = branches[n].replace(sourceRe, "");
			if (prefName in {"zorder":0}) continue; // skip zorder, but INCLUDE cookies -- per the mistake
			if (sourceBranch.getPrefType(prefName) == Components.interfaces.nsIPrefBranch.PREF_STRING) {
				var string = sourceBranch.getCharPref(prefName);
				string = string.replace(o1,"\n").replace(o2,r2).replace(/\n/g, r1).replace(o0,r0); // original:0321, reverse:120 (skip 3)
				sourceBranch.setCharPref(prefName, string); }
		}
	},
	
	// launch the settings-pane
	openSettings: function(url) {
		var wnd = this.windowMediator.getMostRecentWindow("sessionsaver:sessionsaverSettings");
		if (wnd && !wnd.closed) wnd.document.commandDispatcher.focusedWindow.focus(); // focusing the existing window..
		else wnd = window.openDialog((url||"chrome://sessionsaver/content/sessionsaverSettings.xul"),this.mb("settingstitle"), "chrome,centerscreen,resizable"); // ..or open it
		return wnd;
	},

	// trips before the oncommand, next
	menuClick: function(evt, item, parentMenuId) {
		item.unmodified = !(evt.ctrlKey && evt.metaKey && evt.altKey);
		item.ssShiftKey = evt.shiftKey; 
		item.ssButton = evt.button;
		item.ssClicked = true; 
		item.doCommand(); 
		(document.getElementById('menu_ToolsPopup') || document.getElementById('taskPopup')).hidePopup();
	},
	// the onclick first catches variant mouse-clicks, for this
	menuCommand: function(evt, item) {
		if (item.ssHandled) return; 
		item.ssHandled = true;
		
		var unmodified =  item.ssClicked ? item.unmodified : !(evt.ctrlKey && evt.metaKey && evt.altKey);
		var shiftKey =    item.ssClicked ? item.ssShiftKey : evt.shiftKey;
		var shiftClick =  shiftKey && unmodified;
		var leftClick =   item.ssClicked ? (item.ssButton==0) : (evt.button==0 || evt.button > 2 || evt.button < 0); // oddly, moz1.8a5 is sending 65535 as the button, for left-click
		var middleClick = item.ssClicked ? (item.ssButton==1) : (evt.button==1);
		
		var removalMenuIsHidden = !this.hiddenObserver.getDontWarn(2); //document.getElementById('sessionsaver-remove-mozillamenu').hidden;
		if (removalMenuIsHidden && shiftKey && !unmodified) { 
			alert(this.mb('removalactivating'));
			var idArray = ['sessionsaver-remove-mozillaseparator','sessionsaver-remove-firefoxseparator','sessionsaver-remove-mozillamenu','sessionsaver-remove-firefoxmenu'];
			while (idArray[0])  {  try{ document.getElementById(idArray.shift()).hidden = false; } catch(e) {}  }
			this.hiddenObserver.setDontWarn(2, true);
			alert(this.mb('removaltrynow'));
			return; }
		
		if (removalMenuIsHidden && (shiftClick || !leftClick) ) {
			var sessionBranch = item.getAttribute('br');
			var sessionDescription = item.getAttribute('desc');
			var forceWarn = middleClick; // middle-click forces the warning dialog (in theory -- untested) [works -rue]
			this.hiddenObserver.removeBranch(sessionBranch, sessionDescription, window, forceWarn); }
		else this.sessionRecall(null, item.value);
	},
	// our special removal-submenu -- needed for older browsers, alas
	menuRemoveCommand: function(item) {
		var sessionBranch = item.getAttribute('br');
		var sessionDescription = item.getAttribute('desc');
		this.hiddenObserver.removeBranch(sessionBranch, sessionDescription, window, null);
	},
	
	// Brilliant SnapBack -- resurrection for last-closed tabs + windows
	snapBackTab:    function(noFX, willFocus, userChoice) {   
		var stuff = (userChoice && ((userChoice = parseInt(userChoice)) >= 0)) ? this.closedTabs.splice(userChoice,1)[0] : this.closedTabs.shift(); // XXX splicing-out lends an array we then extract from
		var prevSelected = window.getBrowser().selectedTab;
		var sessionTabs = [stuff[1]];
		var snapBackID =   stuff[3];
		var ssTabAttr = noFX ? [] : [ ['ss_f',0] ];
		stuff[6] = true; // 'snapback pending' flag -- so we wont be overwritten before history-restore (asynchronous)

		var previousTabIDs = stuff[2].split(" ");
		var previousTabObj = {};
		for (var n = 0; n < previousTabIDs.length; n++) previousTabObj[ previousTabIDs[n] ] = n;
		var Tabs = window.getBrowser().mTabContainer.childNodes;
		for (var i = Tabs.length; i > 0; i--) if (Tabs[i-1].__ssSnapBackID in previousTabObj) break; // this will lend us one position ahead of whatever tab matches -- or zero, for no match
		for (var m = previousTabObj[i-1], j = i; j > 0 && m > 0; j--) if (previousTabObj[Tabs[j-1].__ssSnapBackID] != m--) { var alteredOrder = true; break; }
		var position = (!alteredOrder) ? i : Tabs.length; // if the tab-ordering was altered (eg. via miniT-drag) we'll just force-append after everything
		//var position = (!alteredOrder) ? i : stuff[0]; // if the tab-ordering was altered (eg. via miniT-drag) we'll just force-insert at the last-index;  ..otherwise, we'll try and locate
		//var position = i || stuff[0]; // on second-thought, we should always honour the last "known" tab -- even if it's been dragged. theoretically, a tab could be dragged from the right-edge to the left, and we shouldn't skip a beat.  also, we should never really encounter a situation where expected tabs suddenly "disappear". so we'll just 'OR' into the forced-position, if we hit zero on the id-scan
		
		var newTab = this.addPositionedTab(position, snapBackID, stuff, this, ssTabAttr); //this.tabRecall(this.closedTabs.shift(), null, false, ""+tabPosition);
		var currentTabs = [newTab];
		window.setTimeout( function() {SessionSaver.historyRecall(sessionTabs, currentTabs, null, false);}, 100);
		var Tabbrowser = window.getBrowser();
		if (!newTab.__ssSnapBackID) newTab.__ssSnapBackID = snapBackID; // if the custom addTab code didn't tag it, do so now
		this.activeTabs[snapBackID] = stuff; // temporarily add the tab-data, so it can be identified if "closed"  +  'snapback pending' flag
		if (this.activeTabsTemp) this.activeTabsTemp[snapBackID] = stuff;
		Tabbrowser.selectedTab = (willFocus) ? newTab : prevSelected; // if the restored tab is left of the selected tab, it shifts the viewer-linking, wrongly
		if (!noFX) this.flasher.start(newTab, true, 'fade-inQ', 40); // flash it   .:   "brilliant, indeed; most spectacular!"
	},
	snapBackWindow: function(noFX, userChoice) {   
		var stuff = (userChoice && ((userChoice = parseInt(userChoice)) >= 0)) ? this.hiddenObserver.closedWindows.splice(userChoice,1)[0] : this.hiddenObserver.closedWindows.shift(); // XXX splicing-out lends an array we then extract from
		var prefArray = stuff[1];
		this.childRecall( null, prefArray, false );   
	},
	snapBackEnable: function() { // called by Tools' popupShowing() event, set via pref-observer :: also called by pref-observer, directly
		// menu-items set by pref-observer load
		var snapTabsQueued = (this.closedTabs.length > 0); // any tabs in queue?
		var snapWindowsQueued = (this.hiddenObserver.closedWindows.length > 0); // any windows in queue?
		
		var check = this.snapTabs +" "+ this.snapWindows +" "+ this.snapDropdown +" "+ snapTabsQueued +" "+ snapWindowsQueued;
		if (this.snapParent.__ssCheck == check) return; // only continue if something changed
		
		var newChild = (this.snapTabs && snapTabsQueued) ? ((this.snapDropdown) ? this.snapTabsMenu : this.snapTabsMenuitem) : this.snapHidden[0];
		var oldChild = this.snapParent.__ssSnapTabItem;
		if (newChild != oldChild) { 
			var next = oldChild.nextSibling;
			this.snapParent.removeChild(oldChild);
			(next) ? this.snapParent.insertBefore(newChild, next) : this.snapParent.appendChild(newChild);
			this.snapParent.__ssSnapTabItem = newChild; }

		newChild = (this.snapTabs && this.snapWindows && snapWindowsQueued) ? ((this.snapDropdown) ? this.snapWindowsMenu : this.snapWindowsMenuitem) : this.snapHidden[1];
		oldChild = this.snapParent.__ssSnapWindowItem;
		if (newChild != oldChild) { 
			next = oldChild.nextSibling;
			this.snapParent.removeChild(oldChild);
			(next) ? this.snapParent.insertBefore(newChild, next) : this.snapParent.appendChild(newChild);
			this.snapParent.__ssSnapWindowItem = newChild; }
		
		this.snapParent.__ssCheck = check; // flag the popup with our current settings
	},
	addPositionedTab: function(position, snapBackID, ssStuff, ssObj, ssTabAttr) {
		this.TabbrowserPatchUp();
		var Tabbrowser = window.getBrowser();
		var n = null, x;
		if (position   == null)   position = x; 
		if (snapBackID == null) snapBackID = x; 
		if (ssStuff    == null)    ssStuff = x; 
		if (ssObj      == null)      ssObj = x; 
		if (ssTabAttr  == null)  ssTabAttr = x; 
		return Tabbrowser.__ssAddTabMod(/*'about:blank'*/ n,n,n,n, n,n,n,n, position,snapBackID,ssStuff,ssObj,ssTabAttr); // + padding ..just in case the signature changes
	},
	// Patches the Tabbrowser's add/remove -tab functions, and adjusts miniT if present
	TabbrowserPatchUp: function() {
		var Tabbrowser = window.getBrowser(); // not redundant, since we call from multiple points
		if (!Tabbrowser.addTab.__ssPatched) {
			if (!Tabbrowser.__ssAddTabMod) Tabbrowser.__ssAddTabMod = Tabbrowser.addTab; // fallback
			var functionString = ""+Tabbrowser.addTab; // coercion to string

			var searchArray = new Array(), replaceArray = new Array();
			var miniTOldSearch = new Array(), miniTOldReplace = new Array();
			var miniTNewSearch = new Array(), miniTNewReplace = new Array();
			searchArray[0]  = /var +position .*?[\;\r\n]/; // XXX Needs to come first, since we insert our 'var position' also
			searchArray[1]  = /this\.mTabContainer\.appendChild\(([^\)]+)\)\;/;
			searchArray[2]  = /this\.mPanelContainer\.appendChild\(([^\)]+)\)\;/;
			searchArray[3]  = /this\.mTabListeners\[position\] *?\= *?tabListener\;/;
			searchArray[4]  = /this\.mTabFilters\[position\] *?\= *?filter\;/;
			replaceArray[0] = "";
			replaceArray[1] = "var sentPosition=(typeof(arguments[8])!='undefined')?arguments[8]:this.mTabContainer.childNodes.length, snapBackID=arguments[9], ssStuff=arguments[10], ssObj=arguments[11], ssTabAttr=arguments[12];" /* + "setTimeout(function(){throw position;},0);" */
							+ "for (var ss_i = 0; ss_i < ssTabAttr.length; ss_i++) $1.setAttribute(ssTabAttr[ss_i][0],ssTabAttr[ss_i][1]);" // starting point for fade-in + others
								+ "var prevSelectedTab = this.mTabContainer.selectedIndex, ssNewTab = $1;"
									+ "if (snapBackID && ssStuff) { ssObj.activeTabs[ (ssNewTab.__ssSnapBackID=snapBackID) ] = ssStuff; if (ssObj.activeTabsTemp) ssObj.activeTabsTemp[snapBackID] = ssStuff;}" // complicatedly shorter ;P
									+ "var nextTab = this.mTabContainer.childNodes[sentPosition];"
									// XXX getBrowserForTab needs the tabs + panel containers aligned, so we'll do it, here (next)
									+ "if (nextTab) { var nextPanel = this.getBrowserForTab(nextTab); while (nextPanel.parentNode && nextPanel.parentNode != this.mPanelContainer) nextPanel = nextPanel.parentNode; }"
									+ "var position = (nextTab) ? sentPosition : this.mTabContainer.childNodes.length;"
										+ "(nextTab) ? this.mTabContainer.insertBefore(ssNewTab, nextTab) : this.mTabContainer.appendChild(ssNewTab);"
											+ "if (position < ++prevSelectedTab) this.mTabContainer.selectedIndex = prevSelectedTab;";
			replaceArray[2] = "var prevSelectedPanel = this.mPanelContainer.selectedIndex, ssNewPanel = $1;"
										+ "(nextPanel) ? this.mPanelContainer.insertBefore(ssNewPanel, nextPanel) : this.mPanelContainer.appendChild(ssNewPanel);"
											+ "if (position < ++prevSelectedPanel) this.mPanelContainer.selectedIndex = prevSelectedPanel;"; 
			replaceArray[3] = "this.mTabListeners.splice(position, 0, tabListener);";
			replaceArray[4] = "this.mTabFilters.splice(position, 0, filter);";
			miniTNewSearch[0]  = /this\.mPanelContainer\.lastChild/;		// new-skool miniT (only matters if we change stuff)
			miniTNewSearch[1]  = /(this\.moveTabTo\(.*?\,)(.*?)([\)\,])/g;	// ditto.
			miniTNewSearch[2]  = /(if *\()(t\.previousSibling\.)/;			// yikes- miniT presumes ( -- previousSibling's existence, which we can't, if snapping-back the first tab)
			miniTNewReplace[0] = "ssNewPanel";
			miniTNewReplace[1] = "$1position$3";
			miniTNewReplace[2] = "$1t.previousSibling && $2";
			miniTOldSearch[0]  = /this\.mTabs\[position\] *?\= *?t\;/; // old-skool miniT
			miniTOldReplace[0] = "this.mTabs.splice(position, 0, t);";
			// XXX remember: we're always starting with the original addTab -- multiple runs are fine
			var searchSuccess = false;
			for (var i = 0, fcopy = functionString; i < searchArray.length ; i++) {
				if (!searchArray[i].test(fcopy)) break;
				else fcopy = fcopy.replace(searchArray[i], replaceArray[i]); }
			if (i == searchArray.length) { searchSuccess = true; functionString = fcopy; }
			
			if (searchSuccess)
				for (i = 0; i < miniTNewSearch.length; i++) {					// these changes are dependant
					if (!miniTNewSearch[i].test(functionString)) continue;
					else functionString = functionString.replace(miniTNewSearch[i], miniTNewReplace[i]); }

			if (searchSuccess)
				for (i = 0; i < miniTOldSearch.length; i++) {					// ditto.
					if (!miniTOldSearch[i].test(functionString)) continue;
					else functionString = functionString.replace(miniTOldSearch[i], miniTOldReplace[i]); }

			if (searchSuccess) eval("Tabbrowser.__ssAddTabMod = "+new String(functionString));
			Tabbrowser.addTab.__ssPatched = true; // in case someone else (eg. miniT) modifies + reinstantiates
		}
		if (Tabbrowser.moveTabTo && !Tabbrowser.moveTabTo.__ssPatched) {
			functionString = ""+Tabbrowser.moveTabTo; // coercion to string

			var miniTSearch = new Array(), miniTReplace = new Array();
			miniTSearch[0]  = /(return *aTab\;)/;
			miniTReplace[0] = "SessionSaver.onTabLoad(); $1"; // we want to re-capture, after a drag
			searchSuccess = false;
			for (i = 0, fcopy = functionString; i < miniTSearch.length; i++) {
				if (!miniTSearch[i].test(fcopy)) break;
				fcopy = fcopy.replace(miniTSearch[i], miniTReplace[i]); }
			if (i == miniTSearch.length) { searchSuccess = true; functionString = fcopy; }
				
			if (searchSuccess) eval("Tabbrowser.moveTabTo = "+new String(functionString));
			Tabbrowser.moveTabTo.__ssPatched = true; // in case someone else (eg. miniT) modifies + reinstantiates
		}
	},
	
	// Lends fade-effect or flashing outline to items
	flasher: {
		loopLimit:       3, // number of times to repeat the loop
		flashLimit:      6, // number of flashes, inside the loop
		hiddenLimit:     6, // number of hidden-iterations, each loop-end
		fadeGradation: .25, // hard-wired: .25, .50, .75, or 1.0
		fadeMax:        10, // hard-wired, per our css
		// XXX runningTime overrides speed
		start: function(elem, append, flashType, speed, dontRun, overlap, overlapPrincipal, overlapFlip, runningTime, runRelative, timerType, dontResetFlash) {
			if (!this.windowInit) this.init(elem); // determine switch-style  ( -- older builds don't support .style for xul-elements)
			if (!append) this.stop();
			if (this.elemArray.length == 0) {									// if first-run..
				this.flashCount  = this.hiddenCount = this.loopCount = 0;		// reset counters
				this.touchInterval = 1;                                         // default-value for touch-interval
				this.flashType   = (flashType) ? flashType : "fade-in";			// determine effect-type
				this.speed       = (typeof(speed)=='number') ? speed : 120;		// determine speed
				this.overlap 	 = (overlap) ? overlap : 0;						// determine overlap (scale from 0-10)
				this.overlapFlip = (overlapFlip) ? true : false;				// determine if flipping overlap from edges toward principal
				this.runRelative = (runRelative) ? true : false;				// determine if smaller half (split by principal) should progress in averaged-sync with the larger
				this.runningTime = (runningTime) ? runningTime : 0;  			// determine maximum run-duration (in milliseconds)
				this.timerType   = this.timerConstants[timerType];    }         // timerType (defaults to setInterval)
			if (dontResetFlash) this.dontResetFlash = true;                     // timerType (defaults to setInterval)
			if (overlapPrincipal) this.overlapPrincipal = overlapPrincipal;		// our overlapPrincipal is the central element we overlap out from
			if (this.fastSwitching) this.origOutline[this.elemArray.length] = elem.style.MozOutline;
			if (this.flashConstants[this.flashType]) {
				if (!this.dontResetFlash || typeof(elem.__ssFlashCount)=='undefined') elem.__ssFlashCount = this.flashConstants[this.flashType]-1;
				else elem.__ssFlashCount = Math.max(0,elem.__ssFlashCount) || Math.min(10,elem.__ssFlashCount);  }
			(this.overlap && !overlapPrincipal) ?
					( (this.overlapPrincipal) ? 
							this.overlapRight.push(elem) : this.overlapLeft.unshift(elem) ) 
								: this.elemArray.push(elem);
			if (!dontRun && !this.timer) this.running();
		},
		flashConstants: {'flash':0,"fade-in":1,"fade-inQ":1,"fade-out":11,"fade-outQ":11},
		timerConstants: {setTimeout:['setTimeout','clearTimeout'],setInterval:['setInterval','clearInterval']},
		init: function(elem) {
			try{ elem.style.MozOutline; this.fastSwitching = true; } catch(e) {}
			this.switchOn = this.fastSwitching ? this.onNew : this.onOld;
			this.switchOff = this.fastSwitching ? this.offNew : this.offOld;
			this.elemArray = [], this.origOutline = [], this.overlapRight = [], this.overlapLeft = [];
			this.windowInit = true;
		},
		running: function() {
			if (!this.timer && this.overlap) {
				var choices = [this.overlapLeft,this.overlapRight]; // Left ->larger,  Right ->smaller
				this.overlapLeft     = (this.overlapLeft.length > this.overlapRight.length) ? choices.shift() : choices.pop();
				this.overlapRight    = choices[0];
				var singleGradation  = this.fadeMax / this.fadeGradation;
				var overlapGradation = this.overlap / this.fadeGradation;
				
				this.leftPasses      = singleGradation + (overlapGradation * this.overlapLeft.length);
				this.rightPasses     = singleGradation + (overlapGradation * this.overlapRight.length);
				this.leftSpeed       = (this.runningTime) ? (this.runningTime / this.leftPasses)  : (this.speed);
				this.rightSpeed      = (this.runningTime) ? (this.runningTime / this.rightPasses) : (this.speed);
				if (this.runningTime && !this.runRelative) this.rightSpeed = this.leftSpeed; 
				this.touchInterval = (this.runningTime) ? Math.round(this.rightSpeed / this.leftSpeed) : 1; // every n passes over the larger-half, we should touch the smaller-half
				if (!this.touchInterval) this.touchInterval = 1;
				this.speed = Math.round(this.leftSpeed);

				if (this.overlapFlip) {
					this.elemArray = []; this.overlapRight.unshift(this.overlapPrincipal); // ..because we reverse it, next
					this.elemArray.push(this.overlapLeft.reverse().shift());
					this.elemArray.push(this.overlapRight.reverse().shift()); }
			}
			switch(this.flashType) {
				case "fade-in":   this.fadeIn();       break; // Fade-in
				case "fade-inQ":  this.fadeInQuick();  break; // Fade-in Quick
				case "fade-out":  this.fadeOut();      break; // Fade-out
				case "fade-outQ": this.fadeOutQuick(); break; // Fade-out Quick
				case "flash":                           // Visible flash  +  Hidden-interval
					if (this.flashCount < this.flashLimit*2) {   (this.flashCount++ % 2) ? this.switchOff() : this.switchOn();   } // Visible-flashing
					else if (this.hiddenCount++ > this.hiddenLimit -1) this.flashCount = this.hiddenCount = (++this.loopCount) ? 0:0; // XXX Note: it's just a trick to increment loopCount on the same line
					break; }
			if (this.elemArray.length == 0 || this.loopCount > this.loopLimit -1) this.stop();	// max-looped: stop
			else {																				// still looping: continue
				if (!this.timerType) 
					this.timerType = /*(this.elemArray.length == 1 && (!this.overlap || !(this.overlapLeft.length || this.overlapRight.length)) ) ? 
						['setTimeout','clearTimeout'] :*/ ['setInterval','clearInterval'];
				if (!this.timer || this.timerType[0] == 'setTimeout') this.timer = window[this.timerType[0]](this.timedCall, this.speed, this);
			}
		},
		timedCall: function(flasher) {  flasher.running();  },
		stop: function() {
			if (this.timer) window[this.timerType[1]](this.timer);
			this.timerType = this.timer = null; // so we can determine if running, or not
			switch(this.flashType) {
				case "fade-in":   break;
				case "fade-inQ":  break;
				case "fade-out":  break;
				case "fade-outQ": break;
				case "flash":    this.switchOff(); break; }
			this.elemArray = [], this.origOutline = [], this.overlapRight = [], this.overlapLeft = [];
		},
		onNew:  function() { for (var i=0; i<this.elemArray.length; i++) this.elemArray[i].style.MozOutline = "#AB0000 dotted 2px !important";  },    // #050505
		offNew: function() { for (var i=0; i<this.elemArray.length; i++) this.elemArray[i].style.MozOutline = this.origOutline[i] ? this.origOutline[i] : 'none';  },
		onOld:  function() { for (var i=0; i<this.elemArray.length; i++) this.elemArray[i].setAttribute("style", "#AB0000 dotted 2px !important");  }, // #050505
		offOld: function() { for (var i=0; i<this.elemArray.length; i++) this.elemArray[i].removeAttribute("style");  },
		fadeIn: function() { 
			//this.loopLimit = ++this.loopCount +1; // keep the limit one ahead of the count
			var appendOrCueR = (!(this.loopCount % this.touchInterval));
			for (var i=0, appendL, appendR; i<this.elemArray.length; i++) {
				var elem = this.elemArray[i];
				if (this.overlap && (elem.__ssFlashCount >= this.overlap) && (i+1 == this.elemArray.length)) {
					if (appendOrCueR) // XXX technically, the next line should be indented; but wasn't, for faster editing
					if (!appendR && (appendR = this.overlapRight.shift()) ) { appendR.__ssRight = true; this.elemArray.push(appendR);}
					if (!appendL && (appendL = this.overlapLeft.shift() ) ) { appendL.__ssLeft  = true; this.elemArray.push(appendL);} 
				}
				var newCount = elem.__ssFlashCount+this.fadeGradation;
				if (newCount >= this.fadeMax) (newCount=this.fadeMax) && this.elemArray.splice(i,1);
				(!elem.__ssRight || appendOrCueR) ? elem.setAttribute("ss_f", elem.__ssFlashCount=newCount) : null;  }
		},
		fadeOut: function() { 
			//this.loopLimit = ++this.loopCount +1; // keep the limit one ahead of the count
			var appendOrCueR = (!(this.loopCount % this.touchInterval));
			for (var i=0, appendL, appendR; i<this.elemArray.length; i++) {
				var elem = this.elemArray[i];
				if (this.overlap && (elem.__ssFlashCount <= this.fadeMax - this.overlap) && (i+1 == this.elemArray.length)) {
					if (appendOrCueR) // XXX technically, the next line should be indented; but wasn't, for faster editing
					if (!appendR && (appendR = this.overlapRight.shift()) ) { appendR.__ssRight = true; this.elemArray.push(appendR);}
					if (!appendL && (appendL = this.overlapLeft.shift() ) ) { appendL.__ssLeft  = true; this.elemArray.push(appendL);} 
				}
				var newCount = elem.__ssFlashCount-this.fadeGradation;
				if (newCount <= 0) (newCount=0) && this.elemArray.splice(i,1);
				(!elem.__ssRight || appendOrCueR) ? elem.setAttribute("ss_f", elem.__ssFlashCount=newCount) : null;  }
		},
		fadeInQuick: function() { 
			for (var i=0, elem; (elem = this.elemArray[i]); i++) {
				var newCount = elem.__ssFlashCount+this.fadeGradation;
				if (newCount >= this.fadeMax) (newCount=this.fadeMax), this.elemArray.splice(i,1); //, (elem.__ssFlashCount=newCount), elem.removeAttribute("ss_f"); continue;}
				elem.setAttribute("ss_f", elem.__ssFlashCount=newCount);  }
		},
		fadeOutQuick: function() { 
			for (var i=0, elem; (elem = this.elemArray[i]); i++) {
				var newCount = elem.__ssFlashCount-this.fadeGradation;
				if (newCount <= 0) (newCount=0), this.elemArray.splice(i,1);
				elem.setAttribute("ss_f", elem.__ssFlashCount=newCount);  }
		}

	},
	
	// Observes shutdown-requests and SessionSaver notices
	observerObject: {
		// nsIObserver registration + flag
		load: function(loader) {
			this.windowMediator = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator); // for getWindows()
			this.prefService    = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService);
			this.prefBranch          = loader.prefBranch;
			this.prefBranchWindows   = loader.prefBranchWindows;
			this.prefBranchStatic    = loader.prefBranchStatic;    // all manually captured sessions
			this.staticBranchDefault = loader.staticBranchDefault; // the default manual-session
			this.prefBranchSettings  = loader.prefBranchSettings;
			this.Branch         = this.prefService.getBranch(loader.prefBranch); // sessionSaver's main branch
			this.rootBranch     = this.prefService.getBranch(null);
			this.settingsBranch = this.prefService.getBranch(this.prefBranch + this.prefBranchSettings); // sessionSaver's settings pref-branch
			this.windowBranch   = this.prefService.getBranch(this.prefBranch + this.prefBranchWindows);  // sessionSaver's windows pref-branch
			this.staticBranch   = this.prefService.getBranch(this.prefBranch + this.prefBranchStatic);   // sessionSaver's manual-capture pref-branch
			this.winLocalPrefix = loader.winLocalPrefix;
			this.closedWindows  = []; // for Brilliant Snapback - windows
			this.D = loader.D
			this.removalConfirmTitleTxt = loader.mb("removalconfirmtitle");
			this.removalConfirmMsgTxt   = loader.mb("removalconfirmmsg");
			this.removalConfirmWarnTxt  = loader.mb("removalconfirmwarn");
			this.continueTxt            = loader.mb("continue");
			this.cancelTxt              = loader.mb("cancel");
			this.removalFailedTxt       = loader.mb('removalfailed');
			this.shutdownConfirmBluefyreTitleTxt = loader.mb("bluetitle");
			this.shutdownConfirmBluefyreMsgTxt   = loader.mb("bluemsg");
			this.shutdownConfirmSaveTitleTxt   = loader.mb("savetitle");
			this.shutdownConfirmSavePreMsgTxt  = loader.mb("savepremsg");
			this.shutdownConfirmSavePostMsgTxt = loader.mb("savepostmsg");
			this.restoreTxt             = loader.mb("restore");
			this.deleteTxt              = loader.mb("delete");
			this.clearTxt               = loader.mb("clear");
			this.discardTxt             = loader.mb("discard");
			this.keepTxt                = loader.mb("keep");
			this.saveTxt                = loader.mb("backup");
			this.rollingPriorTxt        = loader.mb('rollingprior');
			// Placeholders - set by pref-observation
			this.autoMode       = null; this.crashLoad          = null;
			this.autoLoad       = null; this.autoLoadBranch     = null;
			this.bluefyreStyle  = null; this.bluefyreFlip       = null;
			this.shutdownSave   = null; this.shutdownSaveBranch = null;
			// Counters + Flags
			this.takenSlots        = new Array(); // "taken-name" array
			this.shutdownRequested = false;       // "shutdown requested"-flag
			this.lastSaved         = 0;           // monitor's the time between pref-file saves
			this.savePending       = false;       // flag to indicate if a save-timeout has been set
			this.windowsPending    = [];          // array of windows pending closure
			this.activeWindows     = [];          // hash of open-windows -- appended by checkLoaded and onUnload
			this.activeAsArray     = [];          // array, created from global-hash (above)
			this.pendingString     = "";          // string, created from pending window-removal-names
			this.saveConfirm       = true;        // so latent-shutdown can trip proper, if it needs to
			// QueryInterface properties
			this.nsISupports = Components.interfaces.nsISupports;
			this.nsISupportsWeakReference = Components.interfaces.nsISupportsWeakReference;
			this.nsIObserver = Components.interfaces.nsIObserver;
			this.NS_ERROR_NO_INTERFACE = Components.results.NS_ERROR_NO_INTERFACE;
			
			this.settingsBranch.setBoolPref("shutdown", false); // pref-flag, so the next session can determine if we crashed
			
			// in case anything delays the Hidden Window's Unload -- (and a latent session-removal timer activates)
			// ..also for [X]-closure-shutdown
			window.addEventListener("unload", function() {
					if (!SessionSaverObserver.shutdownRequested)
						SessionSaverObserver.observe(null, "quit-application-requested" /*"latent-shutdown"*/, null);
				}, true);

			try {
					var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
					observerService.addObserver(this, "SessionSaver-SavePrefFile", false);
					observerService.addObserver(this, "SessionSaver-WindowClosePending", false);
					observerService.addObserver(this, "SessionSaver-WindowCloseFlush", false);
					observerService.addObserver(this, "SessionSaver-WindowClosed", false);
					observerService.addObserver(this, "quit-application-requested", false); }
			catch (e) { alert("SessionSaver: exception when registering hidden observer: " + e + "\n"); }

			var pbi = this.rootBranch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
			try { pbi.addObserver(this.prefBranch + this.prefBranchSettings, this, true); } // keep this last, in case we hit an error.
			catch(e) { this.hiddenWnd.alert("SessionSaver: hidden prefs-Observer failed to attach: " + e + "\n"); return; }
			this.observe(null, null, "init"); // init pref-retrieval
			this.restoreWarnOnClose(); // restore browser.tabs.warnOnClose
		},
		// nsIObserver interface implementation
		observe: function(subject, topic, data) {
			switch(topic) {
			case "SessionSaver-SavePrefFile":
				// if any saves are pending, no need to continue
				if (this.savePending /*|| this.shutdownRequested*/) return;
				else if (this.shutdownRequested) return (subject) ? this.prefService.savePrefFile(null) : null; // save on shutdown window-closure
				var newWinName = data; // make sure new windows are added to z-order ( -- window-mediator doesn't catch stuff fast enough)
				
				// if the last-save was more than 10sec's ago, save again
				var timeElapsed =  new Date().valueOf() - this.lastSaved;
				if (timeElapsed > 10000)
					this.lastSaved = new Date().valueOf(),
					this.setCookies(),
					this.setZorder(null, newWinName),
					this.prefService.savePrefFile(null); // save the prefs to disk [nothing can follow]
				// otherwise, set a timeout to prevent thrashing
				else this.savePending = true,
					 setTimeout( function(observer, newWinName) { 
								if (observer.shutdownRequested == true) return;
								observer.lastSaved = new Date().valueOf();
								observer.savePending = false;
								observer.setCookies();
								observer.setZorder(null, newWinName);
								observer.prefService.savePrefFile(null); // save the prefs to disk [nothing can follow]
							}, 10000-timeElapsed, this, newWinName);
				break;			
			case "SessionSaver-WindowClosePending":
				this.windowsPending.push( [data,subject] ); // array: [winName,metadata]
				for (var i=0, localCopy=[]; i < this.windowsPending.length; i++) localCopy.push(this.windowsPending[i][0]);
				this.pendingString = localCopy.join(" ");   // for "setZorder" (down, below)
				break;		
			case "SessionSaver-WindowCloseFlush":
				while (this.windowsPending[0]) this.removeWin(this, this.windowsPending.shift());
				break;			
			case "SessionSaver-WindowClosed": // close-event observed: wait 3sec's, then (if really closed) remove stored window-session
				setTimeout(this.removeWin,3000, this,[data,subject]); // array: [winName,metadata]
				break;
			case "quit-application-requested": // if we're running partial or fully automated, save state on shutdown
				this.shutdownRequestedTime = new Date().valueOf();
				if (this.shutdownRequested) return; // newer browser-builds will send this topic more than once;  eg. every time the user clicks "OK" to "close with multiple tabs open?"
				this.shutdownRequested = true; // flag: so the unload-listeners stop tripping
				this.settingsBranch.setBoolPref("shutdown", true); // set pref-flag: we didn't crash
				this.removeWarnOnClose(); // dont let window-unloads beat us to the punch
				this.saveConfirm = true; // just to be sure.
				var isAuto = (this.autoLoad && this.autoLoadBranch == this.prefBranchWindows);
				var isModaConfirm = (isAuto || this.shutdownSave);
				if (isModaConfirm && this.bluefyreStyle && this.bluefyreFlip in {Shutdown:0,Both:0}) { // was 'if (this.autoModeSans'
					// XXX verify we have the most "universal" component for nsIPromptService
					var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
					if (isAuto) var msg = this.shutdownConfirmBluefyreMsgTxt, title = this.shutdownConfirmBluefyreTitleTxt, retainLabel = this.keepTxt, removeLabel = this.clearTxt;
					else            msg = this.shutdownConfirmSavePreMsgTxt+ this.shutdownSaveBranch.replace(this.prefBranchStatic,"").replace(/\.$/,"").replace(/[_]/g,"") +this.shutdownConfirmSavePostMsgTxt, title = this.shutdownConfirmSaveTitleTxt, retainLabel = this.saveTxt, removeLabel = this.discardTxt;
					try {
					this.saveConfirm = (0 == promptService.confirmEx(window,title,msg,promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 + promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1,retainLabel,removeLabel,null,null,{}) );
					} catch(e) {alert("saveConfirm failed: \n\n"+e);}
					if (!this.saveConfirm) this.Branch.deleteBranch(this.prefBranchWindows);
				}
				if (this.shutdownSave && this.saveConfirm) this.replicateAndRoll(this.prefBranchWindows, this.shutdownSaveBranch); // shutdown-copy (per pref)
				this.prefService.savePrefFile(null);
				break;
			case "latent-shutdown": // at this point all windows are closed, so real captures are futile
				this.shutdownRequested = true; // flag: so the unload-listeners stop tripping
				this.settingsBranch.setBoolPref("shutdown", true); // set pref-flag: we didn't crash
				if (this.shutdownSave==true && this.saveConfirm==true) this.replicateAndRoll(this.prefBranchWindows, this.shutdownSaveBranch); // shutdown-copy (per pref)
				this.prefService.savePrefFile(null);
				break;
			case "SessionSaver-CaptureAll": // called by "Manual Mode" saveSession menuitem -- NOT OBSERVED: manually invoked
				this.captureAll(this.prefBranchStatic + this.staticBranchDefault, true, true); // capture all currently open windows, suppressing auto-save
				break;
			default: // pref-change
				var prefName = data;
				
				var init = prefName == "init";
				if (!init) prefName = prefName.match(new RegExp("^"+this.prefBranch+this.prefBranchSettings+"(.*)$"))[1];
				if (prefName == "shutdown") return; // ignore the shutdown-flag

				if (init || "autoload.branch" == prefName)      this.autoLoadBranch     = (this.settingsBranch.prefHasUserValue('autoload.branch')) ? this.settingsBranch.getCharPref('autoload.branch') : this.prefBranchWindows; // default:'windows.'
				if (init || "autoload"        == prefName)      this.autoLoad           = !this.settingsBranch.prefHasUserValue('autoload')     || this.settingsBranch.getBoolPref('autoload');     // default:true
				if (init || "bluefyre"        == prefName)      this.bluefyreStyle      =  this.settingsBranch.prefHasUserValue('bluefyre')     && this.settingsBranch.getBoolPref('bluefyre');     // default:false
				if (init || "bluefyreflip"    == prefName) {    this.bluefyreFlip       =  this.settingsBranch.prefHasUserValue('bluefyreflip') ?  this.settingsBranch.getCharPref('bluefyreflip') : "Startup"; // default:"Startup"
						if (!(this.bluefyreFlip in {Startup:0,Shutdown:0,Both:0})) this.bluefyreFlip = "Startup"; } // forced-default: "Startup"
				if (init || "crashload"       == prefName)      this.crashLoad          = !this.settingsBranch.prefHasUserValue('crashload')    || this.settingsBranch.getBoolPref('crashload');    // default:true
				if (init || "shutdownsave"    == prefName)      this.shutdownSave       =  this.settingsBranch.prefHasUserValue('shutdownsave') && this.settingsBranch.getBoolPref('shutdownsave'); // default:true
				if (init || "snaptabs"        == prefName)      this.snapTabs           = !this.settingsBranch.prefHasUserValue('snaptabs')     || this.settingsBranch.getBoolPref('snaptabs'); // default:true
				if (init || "snapwindows"     == prefName)      this.snapWindows        =  this.settingsBranch.prefHasUserValue('snapwindows')  && this.settingsBranch.getBoolPref('snapwindows'); // default:false
				if (init || "shutdownsave.branch" == prefName)  this.shutdownSaveBranch = (this.settingsBranch.prefHasUserValue('shutdownsave.branch')) ? this.settingsBranch.getCharPref('shutdownsave.branch') : this.prefBranchStatic+this.staticBranchDefault; // default:'static.default.'
				var autoPrefChanged = /^(?:init|autoload\.branch|autoload|crashload|shutdownsave|snaptabs)$/.test(prefName);
				if (autoPrefChanged) {
					this.autoModeSans = this.crashLoad || (this.autoLoad && this.autoLoadBranch == this.prefBranchWindows) || this.shutdownSave;
					this.autoMode =  this.autoModeSans || this.snapTabs; }
				break;
			}
		},
		/*
			running-list of 'dontWarn' values:
				0. warn when removing stored-session
				1. persisted copy of browser.tabs.warnOnClose
				2. removalMenuIsShowing
		*/
		// gets an indexed-flag, from our collapsed pref-array
		convertObj: {'true':1,'false':0,'1':true,'0':false,'null':null,'':null,'undefined':null},
		getDontWarn: function(index) {
			var dontWarnValues = (this.settingsBranch.prefHasUserValue('dontwarn')) ? this.settingsBranch.getCharPref('dontwarn') : null; // default:null
			if (!dontWarnValues) return null;
			dontWarnValues = dontWarnValues.split(" "), value = (index >= 0) ? dontWarnValues[index] : null;
			return (value in this.convertObj) ? this.convertObj[value] : value;
		},
		// sets an indexed-flag, in our collapsed pref-array
		setDontWarn: function(index, value) {
			var dontWarnValues = (this.settingsBranch.prefHasUserValue('dontwarn')) ? this.settingsBranch.getCharPref('dontwarn').split(" ") : []; // default:[]
			var value = (index >= 0 && value in this.convertObj) ? 
					this.convertObj[value] : null;
			if (value != null) dontWarnValues[index] = String(value);
			else delete dontWarnValues[index];
			this.settingsBranch.setCharPref('dontwarn', dontWarnValues.join(" "));
		},
		removeWarnOnClose: function() {
				if (this.rootBranch.getPrefType("browser.tabs.warnOnClose") == Components.interfaces.nsIPrefBranch.PREF_BOOL
					&& this.rootBranch.getBoolPref("browser.tabs.warnOnClose") // we only care if it's 'true'
					&& this.getDontWarn(1) == null) { // XXX the user can force the warning by setting dontWarn.slot1 to 'warn'; the 'null' option keeps us from restoring more than once
				this.rootBranch.setBoolPref("browser.tabs.warnOnClose",false);
				this.setDontWarn(1,true); }
		},
		restoreWarnOnClose: function() {
			var previousSetting;
			if (this.rootBranch.getPrefType("browser.tabs.warnOnClose") == Components.interfaces.nsIPrefBranch.PREF_BOOL)
				if ((previousSetting=this.getDontWarn(1)) in {'true':0,'false':0}) // XXX the user can force the warning by setting dontWarn-1 to 'warn'; the 'null' option keeps us from restoring more than once
					this.rootBranch.setBoolPref("browser.tabs.warnOnClose", previousSetting),
					this.setDontWarn(1,null);
		},
		removeWin: function(observer, wndData){
			var winName = wndData[0], metadata = wndData[1];
			if (observer.shutdownRequested) return;
			var win = observer.retrieveWindow(winName);
			if (win && !win.closed) return; // continue only if the window is gone completely or closed
			
			observer.removeWindow(winName);
			if (observer.autoMode == true) { 
				var prefArray = observer.windowBranch.getCharPref(winName).split(observer.D[0]); // get stored window-session from pref
				observer.closedWindows.unshift( [metadata,prefArray] ); // for Brilliant SnapBack - windows
				observer.windowBranch.deleteBranch(winName);
				observer.observe(null, 'SessionSaver-SavePrefFile', null); }
		},
		// removes all children from a stored session-branch
		removeBranch: function(sessionBranch, sessionDescription, wnd, forceWarn) {
			if (sessionBranch == this.staticBranchDefault) return; // ignore default
			var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService); 
			var storedValue = (forceWarn==false) || this.getDontWarn(0); // allow 'forceWarn' to override in either direction  ( -- even though we never do this)
			// alert the user, if the "dontWarn" flag isn't set
			if (forceWarn || storedValue == false) {
				var dontWarn = {value:!storedValue};
				var buttonPressed = promptService.confirmEx(wnd,this.removalConfirmTitleTxt,this.removalConfirmMsgTxt+sessionDescription+"\n",promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 + promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1,this.continueTxt,this.cancelTxt,null,this.removalConfirmWarnTxt,dontWarn);
				this.setDontWarn(0, !dontWarn.value); // flipped
				if (buttonPressed == 1) return; }
			// zap.
			try{ this.staticBranch.deleteBranch(sessionBranch); } 
			catch(e) { alert(this.removalFailedTxt+e); }
		},
		// rolls a backup (of target), then replicates source to target
		replicateAndRoll: function(prefBranchSource, prefBranchTarget) {
			this.rollBranch(prefBranchTarget); // rolling-backup of the previous shutdown-save (if any)
			this.replicateBranch(prefBranchSource, prefBranchTarget); // the new copy
		},
		// rolls a backup of an existing branch
		rollBranch: function(prefBranchSource, newSourceName) {
			var rollingBackupBranch = ( newSourceName||prefBranchSource ).replace(/\.$/, this.rollingPriorTxt);
			return this.replicateBranch(prefBranchSource, rollingBackupBranch); // rolling-backup of the previous shutdown-save (if any)
		},
		//var appShell = Components.classes["@mozilla.org/appshell/appShellService;1"].getService(Components.interfaces.nsIAppShellService);  var hiddenWnd = appShell.hiddenDOMWindow; hiddenWnd.SessionSaverObserver.replicateBranch("windows.","replicateTest." );
		// replicates all children from the source-branch to the target-branch
		replicateBranch: function(prefBranchSource, prefBranchTarget) {
			if (!this.Branch.prefHasUserValue(prefBranchSource+"zorder")) return null; // only continue if the source-branch exists
			var branches = this.Branch.getChildList(prefBranchSource, {}); // array of pref-names holding window-sessions
			var sourceRe = new RegExp("^"+prefBranchSource.replace(/(\W)/g,"\\$1"));
			var sourceBranch = this.prefService.getBranch(this.prefBranch+prefBranchSource);
			var targetBranch = this.prefService.getBranch(this.prefBranch+prefBranchTarget);
			this.Branch.deleteBranch(prefBranchTarget); // empty the target, in preparation
			for (var n in branches) { 
				var prefName = branches[n].replace(sourceRe, "");
				switch (sourceBranch.getPrefType(prefName)) {
					case Components.interfaces.nsIPrefBranch.PREF_STRING: targetBranch.setCharPref(prefName, sourceBranch.getCharPref(prefName)) ; break;
					case Components.interfaces.nsIPrefBranch.PREF_INT:    targetBranch.setIntPref (prefName, sourceBranch.getIntPref (prefName)) ; break;
					case Components.interfaces.nsIPrefBranch.PREF_BOOL:   targetBranch.setBoolPref(prefName, sourceBranch.getBoolPref(prefName)) ; break;
				}
			}
			return true;
		},
		// captures all currently opened windows
		captureAll: function(prefBranchSession, suppressSave, saveOnLast) {
			if (prefBranchSession) this.Branch.deleteBranch(prefBranchSession); // remove old session
			for (var name in this.activeWindows) 
				if (this.activeWindows[name] && !this.activeWindows[name].closed && this.activeWindows[name].SessionSaver) 
					this.activeWindows[name].SessionSaver.onTabLoad(null, prefBranchSession, suppressSave); // save each window-state, suppressing auto-save if specified
			this.setCookies(prefBranchSession);
			this.setZorder(prefBranchSession);
			if (saveOnLast) this.prefService.savePrefFile(null);
		},
		// stores all session-cookies for active urls
		setCookies: function(prefBranchSession) {
			var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager); 
			var cookies = cookieManager.enumerator; 
			var activeHostHash = [];
			for (var n in this.activeWindows) {
				var win = this.activeWindows[n];
				if (!win || win.closed) continue; // skip if the window is gone or closed -- needed, since we don't remove windows from the hash, immediately
				var Tabbrowser = win.getBrowser();
				for (var i = 0; i < Tabbrowser.browsers.length; i++) {
					try { var tabHost = Tabbrowser.browsers[i].contentDocument.location.host; } catch(e) { continue; }
					if (tabHost) activeHostHash.push("(?:"+  tabHost.replace(/([^\.]+)?\.(?![^\.]+$)/g,"(?:$1\\.)?")  +")"); 
				}
			}
			if (activeHostHash.length != 0) var activeHostRe = new RegExp(activeHostHash.join("|")); // unset if there's no accessible windows -- also used to make sure we don't erase the cookies on a non-browser-win shutdown
			var sessionCookies = [];
			while (cookies.hasMoreElements()) {   
				var c = cookies.getNext().QueryInterface(Components.interfaces.nsICookie); 
				if (c.expires == 0) {
					var hostD=  c.host?c.host.replace(/^\./,''):null; // host-domain
					if (!hostD || (activeHostRe && !activeHostRe.test(hostD))) { continue; }
					var name = (c.name?c.name:"name") +"="+ (c.value?c.value:"")+";";
					var host = (c.isDomain&&hostD)?("domain="+hostD+";"):""; // dang- i was using "host=" instead of "domain=" (n25 p4)  -- http://lxr.mozilla.org/seamonkey/source/netwerk/cookie/src/nsCookieService.cpp#1558
					var path =  c.path?("path="+c.path+";"):"";
					var secure= c.isSecure?"secure;":"";
					var url = "http"+(c.isSecure?"s":"")+"://"+ (c.isDomain?c.host:hostD) +((c.path && c.path!="/")?c.path.replace(/^([^\/])/,"/$1"):""); // it seems we actually want the preceeding dot (.) before the host on domain-cookies
					//var expires = "expires=0;"; // we'll set this at recall, to save a little space
					sessionCookies.push(url+" "+name+host+path/*+expires*/+secure);
				}
			}
			var cookieString = sessionCookies.join("  |");
			if (!prefBranchSession) prefBranchSession = this.prefBranchWindows; // assume auto, if unspecified
			if (cookieString != "") this.Branch.setCharPref(prefBranchSession + "cookies", cookieString); // store array as string
			else if (activeHostRe && this.Branch.prefHasUserValue(prefBranchSession + "cookies")) this.Branch.deleteBranch(prefBranchSession + "cookies"); // don't store an empty string
		},
		// sets z-order pref
		setZorder: function(prefBranchSession, newWinName) {
			var name, zOrderString = new Array();
			var enumerator = this.windowMediator.getZOrderDOMWindowEnumerator("navigator:browser", false);
			while (enumerator.hasMoreElements())
				if ((name = enumerator.getNext().SessionSaver) && (name = name.winName)) zOrderString.push(name); // get each window's z-order -- but only if the window is loaded
			if (zOrderString.length < this.activeAsArray.length) { // some linux-builds don't retrieve full z-order? (n25 p5)
				var i = -1, z = 1;
				while (this.activeAsArray[++i])
					if (this.activeAsArray[i] != zOrderString[0]) zOrderString[z++] = this.activeAsArray[i];
			}
			zOrderString = zOrderString.join(",");
			if (newWinName && zOrderString.indexOf(newWinName) == -1) zOrderString = newWinName+","+zOrderString; // make sure new windows are added ( -- window-mediator doesn't catch stuff fast enough)
			if (!prefBranchSession) prefBranchSession = this.prefBranchWindows; // assume auto, if unspecified
			this.Branch.setCharPref(prefBranchSession + "zorder", zOrderString); // store array as string
		},
		// adds a window's listing to the global-hash
		addWindow: function(wnd, ssObj) {
			if (!ssObj.winName) { // session window-name (will be unique)
				 ssObj.winSlot = this.reserveSlot();
				 ssObj.winName = this.winLocalPrefix + ssObj.winSlot; } // build our unique name
			this.activeWindows[ssObj.winName] = wnd; // add our window to the global-hash
			this.activeAsArray = [];
			for (var n in this.activeWindows) if (this.pendingString.indexOf(n) == -1) this.activeAsArray.push(n);
		},
		// return's the window-obj for a listing
		retrieveWindow: function(winName) {
			return this.activeWindows[winName];
		},
		// removes a window's listing, after it's been closed
		removeWindow: function(winName) {
			var winSlot = winName.match(/\d+$/)[0];
			delete this.takenSlots[winSlot];
			delete this.activeWindows[winName];
			this.activeAsArray = [];
			for (var n in this.activeWindows) if (this.pendingString.indexOf(n) == -1) this.activeAsArray.push(n);
		},
		// reserves a particular slot (or next available) for window-naming
		reserveSlot: function(slot, override) {
			if (!slot || (this.takenSlots[slot] && !override)) slot = this.nameCounter();
			this.takenSlots[slot] = true;
			return slot;
		},
		// UNUSED: frees a particular slot for window-naming
		releaseSlot: function(slot) {
			delete this.takenSlots[slot];
			return slot;
		},
		// returns the next available "slot" for window-naming
		nameCounter: function() {
			var counter = 0;
			while (this.takenSlots[counter]) counter++;
			return counter;
		},
		// UNUSED: called by the hidden-wnd's unload event
		latentShutdown: function () {
			this.shutdownRequested = true; // flag: so the unload-listeners stop tripping
			this.settingsBranch.setBoolPref("shutdown", true); // set pref-flag: we didn't crash
		},
		// nsISupports interface implementation
		QueryInterface: function(iid) {
			if (!iid.equals(this.nsISupports) &&
				!iid.equals(this.nsISupportsWeakReference) &&
				!iid.equals(this.nsIObserver))
			{	dump("SessionSaver observer object: QI unknown interface: " + iid + "\n");
				throw this.NS_ERROR_NO_INTERFACE; }
	
			return this;
		}
	},
	
	// Pref-observer -- controls "Manual Mode" menuitems  +  "Auto Mode" listeners
	prefObserverLoad: function() {
		this.autoMode = null; // placeholders - set by "observe()"
		this.fileMenu = null;
		this.windowInit = false; // flag: are we initialized?
		
		// our "manual-mode" filemenu items
		this.menuItemArray = new Array();
		this.menuItemArray.push( document.getElementById("sessionsaver-separator-menuitem") );
		this.menuItemArray.push( document.getElementById("sessionsaver-header-menuitem") );
		this.menuItemArray.push( document.getElementById("sessionsaver-load-menuitem") );
		this.menuItemArray.push( document.getElementById("sessionsaver-save-menuitem") );

		// our "snapback" tools-menu items
		this.snapHidden = [document.createElement("menuitem"), document.createElement("menuitem")];
		this.snapHidden[0].hidden = true; this.snapHidden[1].hidden = true;
		this.snapTabsMenuitem =    (document.getElementById("sessionsaver-tabback-mozillaitem") || document.getElementById("sessionsaver-tabback-firefoxitem"));
		this.snapTabsMenu     =    (document.getElementById("sessionsaver-tabback-mozillamenu") || document.getElementById("sessionsaver-tabback-firefoxmenu"));
		this.snapWindowsMenuitem = (document.getElementById("sessionsaver-windowback-mozillaitem") || document.getElementById("sessionsaver-windowback-firefoxitem"));
		this.snapWindowsMenu     = (document.getElementById("sessionsaver-windowback-mozillamenu") || document.getElementById("sessionsaver-windowback-firefoxmenu"));
		this.toolsMenu  =          (document.getElementById("taskPopup") || document.getElementById("menu_ToolsPopup"));
		this.snapParent = 		   this.snapTabsMenuitem.parentNode;
		this.snapParent.removeChild(this.snapTabsMenu);
		this.snapParent.removeChild(this.snapWindowsMenu);
		this.snapParent.__ssSnapTabItem    = this.snapTabsMenuitem;
		this.snapParent.__ssSnapWindowItem = this.snapWindowsMenuitem;

		this.pbi = this.rootBranch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
		try { this.pbi.addObserver(this.prefBranch+this.prefBranchSettings, this, true); } // keep this last, in case we hit an error.
		catch(e) { alert("SessionSaver: prefs-Observer failed to attach: " + e + "\n"); return; }
		
		this.observe(null, null, "init"); // initialize the menuitems
	},

	// removes the observer-object from service -- called when the window is no longer open
	removeObserver: function() {
		this.pbi.removeObserver(this.prefBranch+this.prefBranchSettings, this);
		delete this;
	},
	
	// observer-function
	/* subject: [wrapped nsISupports :: nsIPrefBranch], nsIPrefBranchInternal -- topic: "changed" */
	observe: function(subject, topic, prefName) {

		// if we don't have a valid window (closed)
		if ( !(typeof(document) == 'object' && document) ) return this.removeObserver(); // remove observer + don't continue
		
		var init = prefName == "init";
		if (!init) prefName = prefName.match(new RegExp("^"+this.prefBranch+this.prefBranchSettings+"(.*)$"))[1];
		if (prefName == "shutdown") return; // ignore the shutdown-flag
		var addOrRemove;
		
		if (init || "autoload.branch" == prefName)      this.autoLoadBranch     = (this.settingsBranch.prefHasUserValue('autoload.branch')) ? this.settingsBranch.getCharPref('autoload.branch') : this.prefBranchWindows; // default:'windows.'
		if (init || "autoload"        == prefName)      this.autoLoad           = !this.settingsBranch.prefHasUserValue('autoload')      || this.settingsBranch.getBoolPref('autoload'); // default:true
		if (init || "crashload"       == prefName)      this.crashLoad          = !this.settingsBranch.prefHasUserValue('crashload')     || this.settingsBranch.getBoolPref('crashload'); // default:true
		if (init || "bluefyre"        == prefName)      this.bluefyreStyle      =  this.settingsBranch.prefHasUserValue('bluefyre')      && this.settingsBranch.getBoolPref('bluefyre');     // default:false
		if (init || "bluefyreflip"    == prefName) {    this.bluefyreFlip       =  this.settingsBranch.prefHasUserValue('bluefyreflip') ?  this.settingsBranch.getCharPref('bluefyreflip') : "Startup"; // default:"Startup"
				if (!(this.bluefyreFlip in {Startup:0,Shutdown:0,Both:0})) this.bluefyreFlip = "Startup"; }
		if (init || "shutdownsave"    == prefName)      this.shutdownSave       = !this.settingsBranch.prefHasUserValue('shutdownsave')  || this.settingsBranch.getBoolPref('shutdownsave'); // default:true
		if (init || "nofx"            == prefName)      this.snapback_noFX      =  this.settingsBranch.prefHasUserValue('nofx') && this.settingsBranch.getBoolPref('nofx'); // default:false
		if (init || "willfocus"       == prefName)      this.snapback_willFocus = !this.settingsBranch.prefHasUserValue('willfocus')  || this.settingsBranch.getBoolPref('willfocus'); // default:true
		if (init || "shutdownsave"    == prefName)      this.shutdownSave       = !this.settingsBranch.prefHasUserValue('shutdownsave')  || this.settingsBranch.getBoolPref('shutdownsave'); // default:true
		if (init || "snapdropdown"    == prefName)      this.snapDropdown       = !this.settingsBranch.prefHasUserValue('snapdropdown')  || this.settingsBranch.getBoolPref('snapdropdown'); // default:true
		if (init || "snaptabs"        == prefName)      var  snapTabsChanged    =  this.snapTabs != (this.snapTabs = !this.settingsBranch.prefHasUserValue('snaptabs') || this.settingsBranch.getBoolPref('snaptabs')); // default:true
		if (init || "snapwindows"     == prefName)      var  snapWindowsChanged =  this.snapWindows != (this.snapWindows = this.settingsBranch.prefHasUserValue('snapwindows') && this.settingsBranch.getBoolPref('snapwindows')); // default:false
		if (init || "shutdownsave.branch" == prefName)  this.shutdownSaveBranch = (this.settingsBranch.prefHasUserValue('shutdownsave.branch')) ? this.settingsBranch.getCharPref('shutdownsave.branch') : this.prefBranchStatic+this.staticBranchDefault; // default:'static.default.'
		if (init || prefName in {"shutdownsave":0,"shutdownsave.branch":0}) {
			var captureItemActive = (!this.shutdownSave || this.shutdownSaveBranch != this.prefBranchStatic+this.staticBranchDefault);
			this.menuItemArray[3].label = captureItemActive ? this.menuItemArray[3].getAttribute("activelabel") : this.menuItemArray[3].getAttribute("inactivelabel");
			this.menuItemArray[3].setAttribute("disabled", captureItemActive ? false:true);  }
		if ((init || snapTabsChanged || snapWindowsChanged) && (this.snapBackEnable()||true) && snapTabsChanged && (addOrRemove=(this.snapTabs)?"addEventListener":"removeEventListener")) 
			this.toolsMenu[addOrRemove]("popupshowing", ssSnapBackEnable, true); // SnapBack - enablement
		
		// Listeners
		var autoPrefChanged = /^(?:init|autoload\.branch|autoload|crashload|shutdownsave|snaptabs)$/.test(prefName);
		if (autoPrefChanged) {
			var newMode = this.crashLoad || (this.autoLoad && this.autoLoadBranch==this.prefBranchWindows) || this.shutdownsave || this.snapTabs;
			if (this.autoMode != (this.autoMode = newMode)) { // -also stores the mode
				var Tabbrowser = window.getBrowser();
				addOrRemove = (newMode) ? "addEventListener" : "removeEventListener"; // if entering auto-mode, add tab-listeners. otherwise, remove listeners if loaded.
				Tabbrowser[addOrRemove]('load', ssTabLoad, true);     // tab-save when loaded
				Tabbrowser[addOrRemove]('input', ssTextInput, true);  // text-field input
				Tabbrowser[addOrRemove]('unload', ssTabUnload, true); // tab-save on close
				if (newMode && this.windowInit) this.onTabLoad();     // if already loaded, capture the current session
			}
		}
		
		if (init || "overwritewindows" == prefName)  this.overwriteWindows  = !this.settingsBranch.prefHasUserValue('overwritewindows') || this.settingsBranch.getBoolPref('overwritewindows'); // default:true
		if (init || "overwritetabs"    == prefName)  this.overwriteTabs     = !this.settingsBranch.prefHasUserValue('overwritetabs')    || this.settingsBranch.getBoolPref('overwritetabs');    // default:true
		if (init || "concatenate"      == prefName)  this.concatenate       =  this.settingsBranch.prefHasUserValue('concatenate')      && this.settingsBranch.getBoolPref('concatenate');      // default:false
		if (init || "filemenu"         == prefName) { // File-menu items
			this.fileMenu = this.settingsBranch.prefHasUserValue('filemenu') && this.settingsBranch.getBoolPref('filemenu'); // default:false
			for (var n in this.menuItemArray) this.menuItemArray[n].hidden = !this.fileMenu; }
		
		if (init) this.windowInit = true;
		
	},
	
	// nsISupports interface implementation -- for weak-reference by pref-observer service
	QueryInterface: function(iid) {
		if (!iid.equals(Components.interfaces.nsISupports)
				&& !iid.equals(Components.interfaces.nsISupportsWeakReference)
				&& !iid.equals(Components.interfaces.nsIObserver)) {
			dump("SessionSaver Window Pref-Observer factory object: QI unknown interface: " + iid + "\n");
			throw Components.results.NS_ERROR_NO_INTERFACE; }
		return this;
	}
	
};


/*
** Window-load listeners + Hidden observer
*/

if (typeof(window.SessionSaverLoader) != "undefined") {
	window.SessionSaverObserver = window.SessionSaver.observerObject; // remember, we loaded this script a second time, locally
	SessionSaverObserver.load(window.SessionSaverLoader);
	window.SessionSaverLoader = null; // we can't delete them, so here's the next best thing
	window.SessionSaver = null;
	delete window.SessionSaverLoader;
	delete SessionSaver;
}
else if (document.getElementById("sessionsaverSettings")) { ;}// for settings-load -- to copy the flasher
else {
	// moz1.3.1 doesn't do anything if the listener isn't set to capture
	//   -- further, we can't remove a listener if it has inline-code.
	function ssLoad() { SessionSaver.onLoad(); }
	function ssClose(evt) { return SessionSaver.onClose(evt); } // XXX can now (theoretically) keep the window from closing
	function ssUnload(evt) { SessionSaver.onUnload(evt); }
	function ssTabLoad(evt) { SessionSaver.onTabLoad(evt); }
	function ssTextInput(evt) { SessionSaver.onTextInput(evt); }
	function ssTabUnload(evt) { SessionSaver.onTabUnload(evt); }
	function ssSnapBackEnable() { SessionSaver.snapBackEnable(); }
	
	window.addEventListener('load', ssLoad, true); // window startup-check (for crash-recovery)
	SessionSaver.mw = window.document.getElementById("main-window"); // the higher window doesn't have attribute-methods
	if (SessionSaver.mw.hasAttribute("onclose")) {
		SessionSaver.mw.__ssOrigOnclose = SessionSaver.mw.getAttribute("onclose");
		SessionSaver.mw.__ssModOnclose  = "if (!ssClose(event)) return false; " + SessionSaver.mw.__ssOrigOnclose;
		SessionSaver.mw.setAttribute("onclose", SessionSaver.mw.__ssModOnclose); } // window-capture on close
	else window.addEventListener('close', ssClose, true);
	window.addEventListener('unload', ssUnload, true); // window-remove on unload
	
	/*
		Most modern builds of the browser load 'about:blank' into the hidden-window -- which
		leaves us Un-able to run anything privileged in its context. We can get away with
		this for most stuff, since observers and such call with system privileges. But 
		setTimeouts will fail.
		
		The solution is to create an iframe in the hidden-window's document body, and set
		its location to a chrome-url. The trick is to set the location from a privileged
		call-thread. Just setting the "src" attribute will fail, since the iframe
		then loads asynchronously and suddenly doesn't have privilege to load chrome://... 
		Directly setting iframe.contentWindow.location keeps the subScriptLoader's
		privileges as parent for the load.
		
		XXX
		
		..oh yea: and the reason for all this is to keep from locking a reference to the
		first browser-window's instantiation context. Now, we're completely local to the 
		hidden-window.
	*/
	
	// Hidden window
	SessionSaver.hiddenWnd = Components.classes["@mozilla.org/appshell/appShellService;1"].getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow; // global hidden-window
	SessionSaver.Loader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader);
	
	if (SessionSaver.hiddenWnd.location == "about:blank" || SessionSaver.hiddenWnd.document.body) {
		// If the hidden-iframe already exists
		if (SessionSaver.hiddenIFrame = SessionSaver.hiddenWnd.document.getElementById("little-oasis")) {
			SessionSaver.hiddenWnd = SessionSaver.hiddenIFrame.contentWindow; }
		// ..or we need to create it
		else {
			SessionSaver.hiddenIFrame = SessionSaver.hiddenWnd.document.createElement("iframe");
			SessionSaver.hiddenIFrame.id = "little-oasis";
			SessionSaver.hiddenWnd.document.body.appendChild(SessionSaver.hiddenIFrame);
			SessionSaver.hiddenIFrame.contentWindow.location = "chrome://sessionsaver/content/little-oasis.html";
			SessionSaver.hiddenWnd = SessionSaver.hiddenIFrame.contentWindow; }
	}
}
