/*
** Session Saver 0.2d : rue + Pike
*/ 

var SessionSaverSettings = {

	init: function() {
		// Setup object properties
		this.rdf = 			Components.classes['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService);
		this.utils = 		Components.classes['@mozilla.org/rdf/container-utils;1'].getService(Components.interfaces.nsIRDFContainerUtils);
		this.prefService = 	Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService);
		this.prefBranch = 			"sessionsaver.";
		this.prefBranchWindows = 	"windows.";  // the "live" capture of the current session.
		this.prefBranchStatic = 	"static." ;  // all manually captured sessions.
		this.staticBranchDefault = 	"default.";  // the default manual-session.
		this.prefBranchSettings = 	"settings.";
		this.Branch = this.prefService.getBranch(this.prefBranch);
		this.settingsBranch = this.prefService.getBranch(this.prefBranch+this.prefBranchSettings);
		this.rdfPrefix = 'http://sessionsaver.mozilla.org/rdf#';
		
		//this.parentBox =              document.getElementById('parentBox');
		this.htmlMb =                   document.getElementById("Evaluator");
				this.htmlMb.addEventListener("load", this.getResult, true);
				this.sendCode("'&equiv;'"); // trips the evaluator, which lends our html-entity
		this.labelAuto   =              document.getElementById("mode-auto");
		this.checkboxAutoLoad =         document.getElementById('autoload');
		this.labelAutoLoadFrom =        document.getElementById('autoload-from-label');
		this.menuAutoLoadFrom =         document.getElementById('autoload-from');
		this.popupAutoLoadFrom =        document.getElementById('autoload-from-popup');
		this.checkboxBluefyreStyle =    document.getElementById('bluefyrestyle');
		this.flipButton =               document.getElementById('bluefyre-flip');
		//this.checkboxCrashLoad =      document.getElementById('crashload');
		//this.labelCrashLoadWarning =  document.getElementById('crashload-warning');
		this.manualSpacer =             document.getElementById("manual-spacer");
		this.labelManual =              document.getElementById("mode-manual");
		this.groupManual =              document.getElementById("manual-group");
		this.labelOverwrite =           document.getElementById('overwrite');
		this.checkboxOverwriteWindows = document.getElementById('overwritewindows');
		this.checkboxOverwriteTabs =    document.getElementById('overwritetabs');
		this.checkboxConcatenate =      document.getElementById('concatenate');
		this.checkboxShutdownSave =     document.getElementById('shutdownsave');
		this.labelShutdownSaveTo =      document.getElementById('shutdownsave-to-label');
		this.menuShutdownSaveTo =       document.getElementById('shutdownsave-to');
		this.popupShutdownSaveTo =      document.getElementById('shutdownsave-to-popup');
		//this.checkboxFileMenu =       document.getElementById('filemenu');
		this.spacerSnapBack =           document.getElementById("snapback-spacer");
		this.headerSnapBack =           document.getElementById("snapback-header");
		//this.labelSnapBack =          document.getElementById("snapback");
		this.labelSnapBack =            document.getElementById("snapback-label-group");
		this.groupSnapBack =            document.getElementById("snapback-group");
		this.checkboxSnapTabs =         document.getElementById("snapback-tabs");
		//this.checkboxSnapDropdown =   document.getElementById("snapback-dropdown");
		this.checkboxSnapWindows =      document.getElementById("snapback-windows");
		this.snapButton =               document.getElementById("snapback-dropdown-flip");
		this.expertButton =             document.getElementById("expert-settings");
		
		this.setSelections();
		
		//this.flipButton.addEventListener("command", function(){throw "zap";}, true);
		//this.checkboxBluefyreStyle.addEventListener("DOMAttrModified", function(){var res=""; for (var n in arguments[0])try{res+=n+": "+arguments[0][n]+"\n"}catch(e){};throw "attr: "+(this.getAttribute("checked")==arguments[0].newValue);}, true);
		/*
		this.checkboxAutoLoad       .addEventListener("click", function(){ if (this.hasAttribute("ss_f")) this.doCommand();}, true);
		this.checkboxBluefyreStyle  .addEventListener("click", function(){ if (this.hasAttribute("ss_f")) this.doCommand();}, true);
		this.flipButton             .addEventListener("click", function(){ if (this.hasAttribute("ss_f")) this.doCommand();}, true);
		this.checkboxShutdownSave   .addEventListener("click", function(){ if (this.hasAttribute("ss_f")) this.doCommand();}, true);
		*/ 
		// using 'onclick' would be nicer, but the click occurs before the checked-attribute changes
		this.checkboxAutoLoad       .addEventListener("DOMAttrModified", function(){ if (this.hasAttribute("ss_f") && this.getAttribute("checked") == arguments[0].newValue) this.doCommand();}, true);
		this.checkboxBluefyreStyle  .addEventListener("DOMAttrModified", function(){ if (this.hasAttribute("ss_f") && this.getAttribute("checked") == arguments[0].newValue) this.doCommand();}, true);
		//this.flipButton           .addEventListener("click",           function(){ if (this.hasAttribute("ss_f")) this.doCommand();}, true);
		this.checkboxShutdownSave   .addEventListener("DOMAttrModified", function(){ if (this.hasAttribute("ss_f") && this.getAttribute("checked") == arguments[0].newValue) this.doCommand();}, true);
		/*
		this.flipButton.addEventListener("DOMAttrModified", function(){throw("attr: "+arguments[0].attrName);}, true);
		this.flipButton.watch("disabled", function(name,old,newValue){alert("disabled: "+newValue);});
		this.flipButton.watch("disabled", function(name,old,newValue){alert("disabled: "+newValue);});
		this.flipButton.__ssDisabledGetter = this.flipButton.__lookupGetter__("disabled");
		this.flipButton.__ssDisabledSetter = this.flipButton.__lookupSetter__("disabled"), delete this.flipButton.disabled;
		this.flipButton.__defineGetter__("disabled", function(evt){alert("getter: "+evt);});
		this.flipButton.__defineSetter__("disabled", function(evt){alert("setter: "+evt);});
		*/
		
	},
	
	setSelections: function(autoLoadBranch, shutdownSaveBranch) {
		// pref-selections
		var autoLoad =          !this.settingsBranch.prefHasUserValue('autoload')           || this.settingsBranch.getBoolPref('autoload');         // default:true
		var bluefyreStyle =      this.settingsBranch.prefHasUserValue('bluefyre')           && this.settingsBranch.getBoolPref('bluefyre');         // default:false
		var bluefyreFlip =       this.settingsBranch.prefHasUserValue('bluefyreflip') ?        this.settingsBranch.getCharPref('bluefyreflip') : "Startup";     // default:"Startup"
				if (!(bluefyreFlip in {Startup:0,Shutdown:0,Both:0})) bluefyreFlip = "Startup";
		//var crashLoad =       !this.settingsBranch.prefHasUserValue('crashload')          || this.settingsBranch.getBoolPref('crashload');        // default:true
		var concatenate =        this.settingsBranch.prefHasUserValue("concatenate")        && this.settingsBranch.getBoolPref("concatenate");      // default:false
		var overwriteWindows =  !this.settingsBranch.prefHasUserValue('overwritewindows')   || this.settingsBranch.getBoolPref('overwritewindows'); // default:true
		var overwriteTabs =     !this.settingsBranch.prefHasUserValue('overwritetabs')      || this.settingsBranch.getBoolPref('overwritetabs');    // default:true
		var shutdownSave =       this.settingsBranch.prefHasUserValue('shutdownsave')       && this.settingsBranch.getBoolPref('shutdownsave');     // default:false
		//var fileMenu =         this.settingsBranch.prefHasUserValue('filemenu')           && this.settingsBranch.getBoolPref('filemenu');         // default:false
		var snapDropdown =      !this.settingsBranch.prefHasUserValue('snapdropdown')       || this.settingsBranch.getBoolPref('snapdropdown');     // default:true
		var snapTabs =          !this.settingsBranch.prefHasUserValue('snaptabs')           || this.settingsBranch.getBoolPref('snaptabs');         // default:true
		var snapWindows =        this.settingsBranch.prefHasUserValue('snapwindows')        && this.settingsBranch.getBoolPref('snapwindows');      // default:false
		var autoLoadBranch =    (this.settingsBranch.prefHasUserValue('autoload.branch'))     ? this.settingsBranch.getCharPref('autoload.branch') : this.prefBranchWindows; // default:'windows.'
		var shutdownSaveBranch= (this.settingsBranch.prefHasUserValue('shutdownsave.branch')) ? this.settingsBranch.getCharPref('shutdownsave.branch') : this.prefBranchStatic+this.staticBranchDefault; // default:'static.default.'
		this.checkboxAutoLoad           .setAttribute("checked", autoLoad);
		this.checkboxBluefyreStyle      .setAttribute("checked", bluefyreStyle);
		this.checkboxConcatenate        .setAttribute("checked", concatenate);
		//this.checkboxCrashLoad        .setAttribute("checked", crashLoad);
		this.checkboxOverwriteWindows   .setAttribute("checked", overwriteWindows);
		this.checkboxOverwriteTabs      .setAttribute("checked", overwriteTabs);
		this.checkboxShutdownSave       .setAttribute("checked", shutdownSave);
		//this.checkboxFileMenu         .setAttribute("checked", fileMenu);
		//this.checkboxSnapDropdown     .setAttribute("checked", snapDropdown);
		this.checkboxSnapTabs           .setAttribute("checked", snapTabs);
		this.checkboxSnapWindows        .setAttribute("checked", snapWindows);
		
		// disable appropriate selection(s)
		this.checkboxOverwriteTabs.disabled = !overwriteWindows;
		//this.checkboxSnapDropdown.disabled= !snapTabs;
		this.checkboxSnapWindows.disabled   = !snapTabs;
				
		// save original values of hidden-prefs
		this.bluefyreStyle_orig      = bluefyreStyle;
		this.bluefyreFlip_orig       = bluefyreFlip;
		this.autoLoadBranch_orig     = autoLoadBranch;
		this.shutdownSaveBranch_orig = shutdownSaveBranch;
		//this.fileMenu_orig         = fileMenu;
		this.snapDropdown_orig       = snapDropdown;
		this.snapTabs_orig           = snapTabs;
		this.snapWindows_orig        = snapWindows;
		
		// for onLoad() (below)
		this.bluefyreWillFlip   = bluefyreFlip;
		this.autoLoadBranch     = autoLoadBranch;
		this.shutdownSaveBranch = shutdownSaveBranch;
		this.snapDropdown       = snapDropdown;
		
		this.flasher = window.SessionSaver.flasher; // imported from sessionsaver.js
	},
		
	onLoad: function() {
		this.initPopups(this.autoLoadBranch, this.shutdownSaveBranch);
		this.bluefyreCheck(true);
		this.bluefyreFlip(this.bluefyreWillFlip);
		this.snapFlip(this.snapDropdown);
		
		// reveal expert-settings, as persisted
		this.showExpert();
	},
	
	initPopups: function(autoLoadBranch, shutdownSaveBranch) {
		// popup-menus' datasource
		var datasource = Components.classes['@mozilla.org/rdf/datasource;1?name=in-memory-datasource'].createInstance(Components.interfaces.nsIRDFDataSource);
		this.menuAutoLoadFrom.database.AddDataSource(datasource);
		this.menuShutdownSaveTo.database.AddDataSource(datasource);
		
		var sequence = this.utils.MakeSeq(datasource, this.rdf.GetResource('urn:root:sessions'));
		
		// don't list duplicates (branches have multiple prefs)
		var sessionArray = this.Branch.getChildList(this.prefBranchStatic, {}); // array of pref-names holding custom-sessions
		sessionArray.sort(); // the ordering is initially skewed / random
		sessionArray.unshift(this.prefBranchStatic+this.staticBranchDefault+"zorder"); // always include the default branch
		var checkHash = {}, defaultArray = [], branch;
		var checkRe = /(.*\.)[^\.]+$/, defaultRe = new RegExp("^"+ this.prefBranchStatic.replace(/([^\w\d])/g,"\\$1") +"default","i");
		for (var l = 0; l < sessionArray.length; l++) {
			branch = sessionArray[l] = sessionArray[l].match(checkRe)[1];
			if ( checkHash[branch]) { sessionArray.splice(l--,1); continue; }
			if ((checkHash[branch]=true) && defaultRe.test(branch)) defaultArray.push(sessionArray.splice(l--,1)[0]);
		}
		sessionArray = defaultArray.concat(sessionArray);
		var branchRe = new RegExp("^"+ this.prefBranchStatic +"(.*)\\.$"), underscoreRe = /[_]/g;
		for (var n = 0; n < sessionArray.length; n++) {
			var resource = this.rdf.GetResource(sessionArray[n]);
			var sessionDescription = sessionArray[n].match(branchRe)[1].replace(underscoreRe," ").split(" ");
			for (var x in sessionDescription) sessionDescription[x] = sessionDescription[x].replace(/^./, sessionDescription[x].charAt(0).toUpperCase())
			sessionDescription = sessionDescription.join(" ");
			var sessionLocation = sessionArray[n];
			if (sessionLocation == autoLoadBranch) var autoLoadIndex = n+1; // +1 because we have a hardcoded menuitem, here
			if (sessionLocation == shutdownSaveBranch) var shutdownSaveIndex = n;
			datasource.Assert(resource, this.rdf.GetResource(this.rdfPrefix + 'label'), this.rdf.GetLiteral(sessionDescription), true);
			datasource.Assert(resource, this.rdf.GetResource(this.rdfPrefix + 'value'), this.rdf.GetLiteral(sessionLocation), true);
			sequence.AppendElement(resource);
		}
		this.menuAutoLoadFrom.builder.rebuild();
		this.menuShutdownSaveTo.builder.rebuild();
		
		this.menuAutoLoadFrom.selectedIndex = (autoLoadIndex > 0) ? autoLoadIndex : 0;
		this.menuShutdownSaveTo.selectedIndex = (shutdownSaveIndex > 0) ? shutdownSaveIndex : 0;
		
		this.menuAutoLoadFrom.removeAttribute('sizetopopup');   // since moz1.3.1 overrides our xul on this -
		this.menuShutdownSaveTo.removeAttribute('sizetopopup');
	},
	
	sendCode: function(code) { // chrome://global/content/console.js
		//var code = document.getElementById("TextboxEval").value;
		var iframe = document.getElementById("Evaluator")
		iframe.setAttribute("src", "javascript: " + code); // XXX we can't set anything directly, because the .contentWindow getter can't get the docShell, for some reason
		//iframe.contentWindow.location = "javascript: " + code; //alert(iframe.prop);
		//alert(this.getResult());
	},
	
	getResult: function(evt) {
		var Evaluator = this;
		var doc = Evaluator.contentDocument;
		var resultRange = doc.createRange();
		resultRange.selectNode(doc.documentElement);
		var result = resultRange.toString();
		Evaluator.prop = result;
		//return result || "";
		//if (result)
			//gConsole.mCService.logStringMessage(result);
	},
	
	flasher: null, // placeholder -- set by init()
	newOrSavedFlasher: function(storedName, wnd) { // 'wnd' is only declared here (atop) to save space
		if (!this[storedName]) {
			var Flasher = new Function; Flasher.prototype = this.flasher;
			this[storedName] = new Flasher(), this[storedName].isNew = 1; }
		return this[storedName];
	},
	singlePulseFade: function(items, flasher, timeout, flashType, speed) {
		var z;
		for (var n in items)
			flasher.start(items[n], (n>0), flashType, speed, Boolean(items[n+1]),  z,z,z,z,z,"setTimeout", true ); // 12 params: elem, append, flashType, speed, dontRun, overlap, overlapPrincipal, overlapFlip, runningTime, runRelative, timerType, dontResetFlash
		if (flashType in {"fade-in":0,"fade-inQ":0}) flasher.active = false;
		else this[timeout] = setTimeout(this.singlePulseFade,550, items,flasher,timeout,"fade-inQ",20);
		// XXX look into .call() or somesuch, to allow an array to be passed as method-params -- so we can queue calls, and allow looping thus
		// 	-- maybe move elements to a second array, instead of splicing, to allow looping
		// XXX also, add 'fade-in(Q)-pulse' / 'fade-out(Q)-pulse'
	},
	
	bluefyreCheck: function(init) {
		var B = this.checkboxBluefyreStyle, //W = this.labelCrashLoadWarning,
		    F = this.flipButton,              
		    A = this.checkboxAutoLoad,        M = this.menuAutoLoadFrom,
		    S = this.checkboxShutdownSave,    T = this.labelShutdownSaveTo;
		var autoRestore      = (A.getAttribute("checked") == "true");
		var autoLoad         = (autoRestore && M.value == this.prefBranchWindows);
		var otherLoad        = (autoRestore && !autoLoad);
		var otherSelected    = (M.value != this.prefBranchWindows);
		var shutdownSave     = (S.getAttribute("checked") == "true");
		var bluefyreStartup  = (F.getAttribute('flipped') in {Startup:0, Both:0});
		var bluefyreShutdown = (F.getAttribute('flipped') in {Shutdown:0,Both:0});
		var bluefyreShutdownOnly = (F.getAttribute('flipped') in {Shutdown:0});
		
		//if (otherSelected) W.hasAttribute("style") && W.removeAttribute("style"); // was "if (autoLoad)"
		//else W.setAttribute("style", "display:none!important");
		//W.disabled = !autoRestore;
		
		var BSet = (B.getAttribute("checked") == "true");
		var willDisable = !(autoRestore || (shutdownSave && bluefyreShutdown)); //!((autoRestore && bluefyreStartup) || (shutdownSave && bluefyreShutdown)); // was (!autoLoad
		var BChanged = (B.disabled != willDisable) && ((B.disabled=willDisable)||true) || init;
		//(B.disabled != (tempB=!(autoLoad || (shutdownSave && bluefyreShutdown))) || init) && (BChanged = true) && (B.disabled = tempB);
		
		var flasher;
		if (!(flasher = this.newOrSavedFlasher("FlasherB"))) return;
		var flasherActive = (flasher.active || flasher.timer);
		var flasherIsNew =  (flasher.isNew-- == 1), n;
		if (flasherIsNew) {
			flasher.fadeGradation = .5;
			/*this.fadeStuff = function(flashType, speed) {
				flasher.start(B, false, flashType, speed, true,  n,n,n,n,n,n, true ); // 12 params: elem, append, flashType, speed, dontRun, overlap, overlapPrincipal, overlapFlip, runningTime, runRelative, timerType, dontResetFlash
				flasher.start(F, true,  flashType, speed, true,  n,n,n,n,n,n, true );
				flasher.start(T, true,  flashType, speed, true,  n,n,n,n,n,n, true );
				flasher.start(S, true,  flashType, speed, false, n,n,n,n,n,n, true);
				if (flashType == "fade-inQ") flasher.active = false;  };*/
		}
		var items = [B,F,T,S], timeout = "flasherBTimeout";
		if (BSet && /*BChanged &&*/ !B.disabled && (!autoRestore||bluefyreShutdownOnly)) { // if we're switching to 'enabled' with only shutdown-save
			if (flasherActive) return; // don't interrupt an existing fade
			flasher.active = true; 
			this.singlePulseFade(items,flasher,timeout,"fade-outQ",20);
			/*this[timeout] = setTimeout(this.singlePulseFade,550, items,flasher,timeout,"fade-inQ",20);*/ }
		else if (flasherActive && /*BChanged &&*/ (B.disabled || autoRestore)) // if we're switching to 'disabled' and already fading, stop + quickly fade-in
			clearTimeout(this[timeout]), this.singlePulseFade(items,flasher,timeout,"fade-inQ",2);
	},
	
	bluefyreFlip: function(flip) {
		if (typeof(flip) == 'undefined') 
			flip =  {Startup:"Shutdown",Shutdown:"Both",Both:"Startup"}[ SessionSaverSettings.flipButton.getAttribute('flipped') ];
		var prop = this.htmlMb.prop;
		var flipLabel = SessionSaverSettings.flipButton.getAttribute("label"+flip);
		SessionSaverSettings.flipButton.setAttribute("label", flipLabel+prop);
		SessionSaverSettings.flipButton.setAttribute("flipped", flip);
		this.bluefyreCheck();
		/*if (flip != "Shutdown")*/ sizeToContent();
	},
	
	convertObj: {'true':true,'false':false},

	snapFlip: function(flip) {
		if (typeof(flip) == 'undefined') 
			flip = {'true':false,'false':true}[ SessionSaverSettings.snapButton.getAttribute('flipped') ];
		var flipAttr = {'false':"sequential",'true':"dropdown"}[ flip ];
		var prop = this.htmlMb.prop;
		var flipLabel = SessionSaverSettings.snapButton.getAttribute("label"+flipAttr);
		SessionSaverSettings.snapButton.setAttribute("label", flipLabel+prop);
		SessionSaverSettings.snapButton.setAttribute("flipped", flip);
	},

	// "OK" button was clicked
	onAccept: function() {
		this.settingsBranch.setBoolPref("autoload",         (this.checkboxAutoLoad          .getAttribute("checked") == "true") ? true:false);
		//this.settingsBranch.setBoolPref("crashload",      (this.checkboxCrashLoad         .getAttribute("checked") == "true") ? true:false);
		this.settingsBranch.setBoolPref("concatenate",      (this.checkboxConcatenate       .getAttribute("checked") == "true") ? true:false);
		this.settingsBranch.setBoolPref("overwritewindows", (this.checkboxOverwriteWindows  .getAttribute("checked") == "true") ? true:false);
		this.settingsBranch.setBoolPref("overwritetabs",    (this.checkboxOverwriteTabs     .getAttribute("checked") == "true") ? true:false);
		this.settingsBranch.setBoolPref("shutdownsave",     (this.checkboxShutdownSave      .getAttribute("checked") == "true") ? true:false);

		// only save expert-prefs if they've changed
		if (this.autoLoadBranch_orig     != this.menuAutoLoadFrom.value)    this.settingsBranch.setCharPref("autoload.branch",     this.menuAutoLoadFrom.value);
		if (this.shutdownSaveBranch_orig != this.menuShutdownSaveTo.value)	this.settingsBranch.setCharPref("shutdownsave.branch", this.menuShutdownSaveTo.value);
		if (this.bluefyreStyle_orig != (this.checkboxBluefyreStyle.getAttribute("checked") == "true")) this.settingsBranch.setBoolPref("bluefyre",     !this.bluefyreStyle_orig);
		if (this.bluefyreFlip_orig  != (this.flipButton           .getAttribute("flipped")          )) this.settingsBranch.setCharPref("bluefyreflip",  this.flipButton.getAttribute("flipped"));
		//if (this.fileMenu_orig    != (this.checkboxFileMenu     .getAttribute("checked") == "true")) this.settingsBranch.setBoolPref("filemenu",     !this.fileMenu_orig);
		//if (this.snapDropdown_orig!= (this.checkboxSnapDropdown .getAttribute("checked") == "true")) this.settingsBranch.setBoolPref("snapdropdown", !this.snapDropdown_orig);
		if (this.snapDropdown_orig  != (this.snapButton           .getAttribute("flipped") == "true")) this.settingsBranch.setBoolPref("snapdropdown", !this.snapDropdown_orig);
		if (this.snapTabs_orig      != (this.checkboxSnapTabs     .getAttribute("checked") == "true")) this.settingsBranch.setBoolPref("snaptabs",     !this.snapTabs_orig);
		if (this.snapWindows_orig   != (this.checkboxSnapWindows  .getAttribute("checked") == "true")) this.settingsBranch.setBoolPref("snapwindows",  !this.snapWindows_orig);
		
		this.prefService.savePrefFile(null); // save the prefs to disk
	},
	
	// reveal expert-settings
	showExpert: function(hide) {
		if (typeof(hide) == 'undefined') 
			hide = (this.expertButton.getAttribute('revealed') == "false");
		var shouldHide = hide ? true : false;
		this.labelAutoLoadFrom      .hidden = shouldHide;
		this.menuAutoLoadFrom       .hidden = shouldHide;
		//this.labelCrashLoadWarning.hidden = shouldHide;
		this.labelShutdownSaveTo    .hidden = shouldHide;
		this.menuShutdownSaveTo     .hidden = shouldHide;
		//this.checkboxFileMenu     .hidden = shouldHide; // who cares about the file-menu, really.
		this.spacerSnapBack         .hidden = shouldHide;
		this.labelSnapBack          .hidden = shouldHide;
		this.groupSnapBack          .hidden = shouldHide;
		//this.checkboxSnapDropdown .hidden = shouldHide;
		this.checkboxSnapTabs       .hidden = shouldHide;
		this.checkboxSnapWindows    .hidden = shouldHide;

		//if (!shouldHide) this.labelAuto.hasAttribute("style") && this.labelAuto.removeAttribute("style");
		//else this.labelAuto.setAttribute("style", "visibility:hidden!important");
		//this.labelAuto            .hidden = shouldHide;
		this.flipButton             .hidden = shouldHide;
		this.checkboxBluefyreStyle  .hidden = shouldHide;
		this.manualSpacer           .hidden = shouldHide;
		this.labelManual            .hidden = shouldHide;
		this.groupManual            .hidden = shouldHide;
		
		var prop = this.htmlMb.prop;
		var expertLabel = this.expertButton.getAttribute(shouldHide?"labelHidden":"labelShowing");
		this.expertButton.setAttribute("label", expertLabel+prop);
		this.expertButton.setAttribute("revealed", !shouldHide);
		sizeToContent();
	}
};

/*
**  fire -!
*/
SessionSaverSettings.init();