// Click on tab or tab bar; middle-click, ctrl-click, right-click
//
var onDoubleClick = false;

function TM_checkClick (event) {
  try {
    var ctrlClick = gPref.getBoolPref("extensions.tabmix.ctrlClick");
    var undoClose = gPref.getBoolPref("extensions.tabmix.undoClose");
    var tabFlip = gPref.getBoolPref("extensions.tabmix.tabFlip");
    var tabFlipDelay = gPref.getIntPref("extensions.tabmix.tabFlipDelay");
  }
  catch(e){}

  onDoubleClick = false;
  var target = event.originalTarget;
  var aTab = target;
  while ( aTab.localName != "tabs" ) {
    if ( aTab.localName == "tab" )
      break;
    if ( aTab.parentNode )
      aTab = aTab.parentNode;
    else
      return;
  }
  var clickOutTabs = aTab.localName == "tabs";

  if ( clickOutTabs && ( ( event.button == 1 ) || ( ctrlClick && event.button == 0 && event.ctrlKey ) ) )
    gBrowser.undoRemoveTab();
  if ( ctrlClick && !clickOutTabs && event.button == 0 && event.ctrlKey )
    gBrowser.removeTab(aTab);

  if ( !clickOutTabs && event.button == 0 && event.shiftKey && !event.ctrlKey && !event.altKey ) {
    try {
      var pref = gPref.getIntPref("extensions.tabmix.shiftClickTab");
    }
    catch(e){}
    TMclickAction( pref, aTab );
  }
  if ( !clickOutTabs && event.button == 0 && !event.shiftKey && !event.ctrlKey && !event.altKey &&
       aTab.hasAttribute("clickOnCurrent") ) {
    aTab.removeAttribute("clickOnCurrent");
    window.setTimeout( function () {
                          if ( tabFlip && !onDoubleClick )
                            gBrowser.previousTab(aTab);
                        }, tabFlipDelay );
  }

  if( event.button == 2 ) {
    var cIndex = clickOutTabs ? gBrowser.mCurrentTab.ordinal : aTab.ordinal;

    var duplicateMenu = document.getElementById("tm-duplicateTab");
    var undoCloseTabMenu = document.getElementById("tm-undoCloseTab");
    var undoCloseListMenu = document.getElementById("tm-undoCloseList");
    var closeAllMenu = document.getElementById("tm-closeAllTabs");
    var closeRightMenu = document.getElementById("tm-closeRightTabs");
    var closeLeftMenu = document.getElementById("tm-closeLeftTabs");
    var closeSepMenu = document.getElementById("tm-separator");
    var lockTabMenu = document.getElementById("tm-lockTab");
    var protectTabMenu = document.getElementById("tm-protectTab");
    var speSepMenu = document.getElementById("tm-separator-2");
    var docShellMenu = document.getElementById("tm-docShell");
    var renameTabMenu = document.getElementById("tm-renametab");

    try {
      duplicateMenu.hidden = !gPref.getBoolPref("extensions.tabmix.duplicateMenu");
      renameTabMenu.hidden = !gPref.getBoolPref("extensions.tabmix.renameTabMenu");       
      closeAllMenu.hidden = !gPref.getBoolPref("extensions.tabmix.closeAllMenu");
      closeRightMenu.hidden = !gPref.getBoolPref("extensions.tabmix.closeRightMenu");
      closeLeftMenu.hidden = !gPref.getBoolPref("extensions.tabmix.closeLeftMenu");
      undoCloseTabMenu.hidden = !gPref.getBoolPref("extensions.tabmix.undoCloseTabMenu") || !undoClose;
      undoCloseListMenu.hidden = !gPref.getBoolPref("extensions.tabmix.undoCloseListMenu") || !undoClose;
      lockTabMenu.hidden = !gPref.getBoolPref("extensions.tabmix.lockTabMenu");     
      protectTabMenu.hidden = !gPref.getBoolPref("extensions.tabmix.protectTabMenu");
      docShellMenu.hidden = !gPref.getBoolPref("extensions.tabmix.docShellMenu");
      closeSepMenu.hidden = closeRightMenu.hidden && closeLeftMenu.hidden && closeAllMenu.hidden;
      speSepMenu.hidden = lockTabMenu.hidden && protectTabMenu.hidden && docShellMenu.hidden;
    }
    catch(e){}

    undoCloseTabMenu.setAttribute( "disabled", gBrowser.closedTabs.length < 1  );
    undoCloseListMenu.setAttribute( "disabled", gBrowser.closedTabs.length < 1 );
    closeRightMenu.setAttribute( "disabled", cIndex == gBrowser.mTabContainer.childNodes.length - 1 );
    closeLeftMenu.setAttribute( "disabled", cIndex == 0 );
    lockTabMenu.setAttribute( "disabled", clickOutTabs );
    protectTabMenu.setAttribute( "disabled", clickOutTabs );
    docShellMenu.setAttribute( "disabled", clickOutTabs );

    if ( !lockTabMenu.hidden )
      lockTabMenu.setAttribute( "checked",
                                clickOutTabs ?
                                false : aTab.hasAttribute("locked") );
    if ( !protectTabMenu.hidden )
      protectTabMenu.setAttribute( "checked",
                                clickOutTabs ?
                                false : aTab.hasAttribute("protected") );
  }
}

function TM_checkContentMenu () {
  try {
    var showLockTab = gPref.getBoolPref("extensions.tabmix.lockTabContent");
    var showProtectTab = gPref.getBoolPref("extensions.tabmix.protectTabContent");
    var showTabsList = gPref.getBoolPref("extensions.tabmix.tabsList");
    var showUndoCloseTab = gPref.getBoolPref("extensions.tabmix.undoCloseTabContent");
    var showUndoCloseList = gPref.getBoolPref("extensions.tabmix.undoCloseListContent");
    var undoClose = gPref.getBoolPref("extensions.tabmix.undoClose");
  }
  catch(e){}

  var tabsListMenu = document.getElementById("tm-tabsList");
  var lockTabMenu = document.getElementById("tm-content-lockTab");
  var protectTabMenu = document.getElementById("tm-content-protectTab");
  var undoCloseTabMenu = document.getElementById("tm-content-undoCloseTab");
  var undoCloseListMenu = document.getElementById("tm-content-undoCloseList");
  var undoCloseSep = document.getElementById("tm-content-undoCloseSep");
  var contentClick = gContextMenu.isTextSelected || gContextMenu.onTextInput ||
                     gContextMenu.onLink || gContextMenu.onImage;

  lockTabMenu.hidden = !showLockTab || contentClick;
  lockTabMenu.setAttribute("checked", gBrowser.mCurrentTab.hasAttribute("locked"));
  protectTabMenu.hidden = !showProtectTab || contentClick;
  protectTabMenu.setAttribute("checked", gBrowser.mCurrentTab.hasAttribute("protected"));
  tabsListMenu.hidden = !showTabsList || contentClick;
  undoCloseTabMenu.hidden = ( gBrowser.closedTabs.length < 1 ) || !showUndoCloseTab || !undoClose || contentClick;
  undoCloseListMenu.hidden = ( gBrowser.closedTabs.length < 1 ) || !showUndoCloseList || !undoClose || contentClick;
  undoCloseSep.hidden = undoCloseTabMenu.hidden && undoCloseListMenu.hidden;
}

function TMclickAction ( pref, aTab ) {
  switch ( pref ) {
    case 0 :
      break;
    case 1 :
      BrowserOpenTab();
      break;
    case 2 :
      gBrowser.removeCurrentTab();
      break;
    case 3 :
      gBrowser.duplicateTab(aTab);
      break;
    case 4 :
      BrowserReload();
      break;
    case 5 :
      gBrowser.protectTab(aTab);
      break;
    case 6 :
      gBrowser.lockTab(aTab);
      break;
  }
}

// Double click function
//
function TMonTabBarDblClick (e) {
  if ( e.button != 0 || e.ctrlKey || e.shiftKey || e.altKey || e.metaKey )
    return;
  onDoubleClick = true;
  var aTab = e.originalTarget;
  while ( aTab.localName != "tabs" ) {
    if ( aTab.localName == "tab" )
      break;
    aTab = aTab.parentNode;
  }
  if ( aTab.localName == "tabs" ) {
    BrowserOpenTab();
    return;
  }
  try {
    var pref = gPref.getIntPref("extensions.tabmix.dblClickTab");
  }
  catch(e){}

  TMclickAction( pref, aTab );
}

// Replace Tab Bar updateContextTab function to catch mouse down on tabs
//
function TMupdateContextTab (e) {

  var aTab = e.originalTarget;
  while ( aTab.localName != "tabs" ) {
    if ( aTab.localName == "tab" )
      break;
    aTab = aTab.parentNode;
  }
  this.mContextTab = aTab;
  if ( aTab.localName == "tabs" )
    this.mContextTab = document.popupNode;
}

// Replace Tab Bar onDrop function to catch dropping URLS on tabs
//
function TMonDrop (aEvent, aXferData, aDragSession) {
  var url = transferUtils.retrieveURLFromData(aXferData.data, aXferData.flavour.contentType);

  // valid urls don't contain spaces ' '; if we have a space it isn't a valid url so bail out
  if (!url || !url.length || url.indexOf(" ", 0) != -1)
    return;

  var bgLoad = this.mPrefs.getBoolPref("browser.tabs.loadInBackground");

  var aTab = aEvent.originalTarget;
  while ( aTab.localName != "tabs" ) {
    if ( aTab.localName == "tab" )
      break;
    aTab = aTab.parentNode;
  }
  if ( aTab.localName == "tabs" )
    aTab = this.addTab(getShortcutOrURI(url));
  else
    this.getBrowserForTab(aTab).loadURI(getShortcutOrURI(url));

  if (this.mCurrentTab != aTab && !bgLoad)
    this.selectedTab = aTab;
}

// Create undoclosetab list
// code from undoclosetab_20041126_enhanced version, by Turonah
//
function createUndoCloseList (popup, tablistflush) {
  // Remove any existing menu items
  while(popup.hasChildNodes()) {
    popup.removeChild(popup.lastChild);
  }
  // Grab the list of closed tabs
  var ctabs = gBrowser.closedTabs;

  for(var i = ctabs.length - 1; i >= 0; i--) {
    var tab = ctabs[i];
    var tabSH = tab[1];   // Grab the session history for the tab
    // Grab the title and uri (make the uri friendly text)
    var title = tab[2];
    var uri = tabSH.getEntryAtIndex(tabSH.index, false).URI;
    if ( gPref.getBoolPref("extensions.tabmix.titlefrombookmark") ) {
    var bookMarkName = getTitleFromBookmark(uri.spec);
    if (bookMarkName) title = bookMarkName;
    }
    if ( uri.scheme == "about" && title == "" )
      uri = title = "about:blank";
    else if ( uri.scheme == "about" )
      uri = title;
    else
      uri = uri.scheme + ":\/\/" + uri.host + uri.path;

    // Insert a menu item for each closed tab in the cache
    var mi = document.createElement("menuitem");
    mi.setAttribute("class", "menuitem-iconic bookmark-item");
    mi.setAttribute("label", (ctabs.length - i) + ": " + ((title) ? title : uri));
    mi.setAttribute("image", tab[3]);
    mi.setAttribute("accesskey", "" + (ctabs.length - i));
    mi.closeTabIndex = i;
    popup.appendChild(mi);
  }
    var mi = document.createElement("menuseparator");
  popup.appendChild(mi);
  mi = document.createElement("menuitem");
  mi.setAttribute("label", tablistflush);
  mi.closeTabIndex = -1;
  popup.appendChild(mi);
}

function undoCloseTab (index) {
  var ctabs = gBrowser.closedTabs;
    if(index >= 0)
  {
  var aTab = ctabs.splice(index, 1)[0];
  gBrowser.restoreTab(aTab[0], aTab[1]);
    for (var i = index; i < ctabs.length; i++)
    {
      if (ctabs[i][0] >= aTab[0]) ctabs[i][0]++;
    }
  }
  else
  {
    while(ctabs.length > 0)
    {
      ctabs.pop();
    }
  }
    if(ctabs.length < 1)
  {   
    if (document.getElementById("btn_undoclose")) document.getElementById("btn_undoclose").setAttribute("disabled",true) ;   
  }
}

function createTabsList (popup) {
  while(popup.hasChildNodes()) {
    popup.removeChild(popup.lastChild);
  }

  var tabs = gBrowser.mTabContainer.childNodes;

  for(var i = 0; i <= tabs.length - 1; i++) {
    var mi = document.createElement("menuitem");
    mi.setAttribute("class", "menuitem-iconic bookmark-item");
    mi.setAttribute("label", tabs[i].label);
    mi.setAttribute("image", tabs[i].getAttribute("image"));
    if ( gBrowser.mCurrentTab.ordinal == i )
      mi.setAttribute("style", "font-weight: bold;");
    mi.tabIndex = i;
    popup.appendChild(mi);
  }
}

