/***** Preference Dialog Functions *****/
//
var gPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var lists = ["divertedWindowOpen","generalWindowOpen",
             "clicktab","shiftClickTab","focusTab","tabBarPosition","tabScroll","speLink","externalLinkTarget"];
var checkboxes = ["flexTabs","addTabDrag","loadHome","openBookmarks","openUrl","openSearch","openHistory","openTabNext",
                  "tabbarscrolling","mouseHoverSelect","singleWindow",
                  "progressMeter","openTabNextInverse","showDuplicate","showCloseRight","showCloseLeft",
                  "showUndoClose","showDocShell","ctrlClick","showUndoCloseList","tabBarSpace",
                  "unreadTab","undoClose","keepWindow","showUndoCloseListContent","showUndoCloseContent",
                  "lockTabMenu","showCloseAll","tabsList","protectTabMenu","linkTarget","extraIcons",
                  "protectTabContent","lockTabContent","newTabButton","sessionRestore","tabFlip", 
                 
"showRenametab","bookastitle","keeptab","undoClosepos", "warnOnClose"];
var inversePrefCheckboxes = ["selectTab","selectTabBH","openBMKGroups","selectDivertedTab","hideTabBarButton",
                         "selectTabUrl", "showtabbar"];
var intlists = ["tabXDelay","minWidth","maxWidth","undoCloseCache","mouseOverSelectDelay","tabFlipDelay" ];
var singlehides = ["generalWindowOpen.window","divertedWindowOpen.some","divertedWindowOpen.none",
"externalLinkTarget.window"];

var parentCheckboxes = ["openTabNext","undoClose","undoClose","undoClose","undoClose","undoClose","undoClose","showTabX","showTabX","flexTabs","flexTabs","mouseHoverSelect","tabFlip"];
var dependantOnCheckboxes = ["openTabNextInverse","undoClosepos","undoCloseCache","showUndoClose","showUndoCloseList","showUndoCloseListContent","showUndoCloseContent","tabXMode","tabXDelay","minWidth","maxWidth","mouseOverSelectDelay","tabFlipDelay"];

// load all preferences into the dialog
function TBPL_EMinit()
{
  TM_loadTabXMode(false);

  var label = document.getElementById('extra2-label').getAttribute('label');
  if (label)
    document.documentElement.getButton('extra2').setAttribute('label', label);

  try {
    for (var i = 0; i < checkboxes.length; ++i) {
      var checkbox = document.getElementById(checkboxes[i]);
      checkbox.checked = gPref.getBoolPref(checkbox.getAttribute("prefstring"));
    }

    for (i = 0; i < inversePrefCheckboxes.length; ++i) {
      var checkboxinverse = document.getElementById(inversePrefCheckboxes[i]);
      checkboxinverse.checked = !gPref.getBoolPref(checkboxinverse.getAttribute("prefstring"));
    }

    for (i = 0; i < intlists.length; i++) {
      var intlist = document.getElementById(intlists[i]);
      intlist.value =  gPref.getIntPref(intlist.getAttribute("prefstring"));
    }

    for (i = 0; i < lists.length; i++) {
      var element = document.getElementById(lists[i]);
      var prefstring = element.getAttribute("prefstring");
      element.selectedItem = element.getElementsByAttribute("value", gPref.getIntPref(prefstring))[0];
    }
  }
  catch (e) {
  }

  var singleWindowSetting = document.getElementById("singleWindow");
  TM_checkSingleWindow( singleWindowSetting.checked );
  TM_checkDependant();
}

      
function TM_loadTabXMode (restore) {
  if (restore)
    gPref.lockPref("extensions.tabmix.tabXMode");
  if (restore)
    var tabXMode = 0;
  else
    var tabXMode = gPref.getIntPref("extensions.tabmix.tabXMode");
  if (restore)
    gPref.unlockPref("extensions.tabmix.tabXMode");
  document.getElementById("showTabX").setAttribute( "checked", (tabXMode != 0) );
  if (tabXMode == 1)
    document.getElementById("showTabX.always").setAttribute("selected","true");
  if (tabXMode == 2)
    document.getElementById("showTabX.hover").setAttribute("selected","true");
}

function TM_setTabXMode () {
  var pref;
  if ( document.getElementById( "showTabX.always" ).getAttribute( "selected" ) )
    pref = 1;
  if ( document.getElementById( "showTabX.hover" ).getAttribute( "selected" ) )
    pref = 2;
  if ( !document.getElementById( "showTabX" ).getAttribute( "checked" ) )
    pref = 0;
  gPref.setIntPref("extensions.tabmix.tabXMode", pref);
}

// save all preferences entered into the dialog
function TBPL_EMsave()
{
  var singleWindowSetting = document.getElementById("singleWindow");
  TM_checkSingleWindow( singleWindowSetting.checked );
  TM_verifyWidth();
  TM_setTabXMode ();

  try {
    for (var i = 0; i < checkboxes.length; ++i) {
      var checkbox = document.getElementById(checkboxes[i]);
      gPref.setBoolPref(checkbox.getAttribute("prefstring"), checkbox.checked);
    }

    for (i = 0; i < inversePrefCheckboxes.length; ++i) {
      var checkboxinverse = document.getElementById(inversePrefCheckboxes[i]);
      gPref.setBoolPref(checkboxinverse.getAttribute("prefstring"), !checkboxinverse.checked);
    }

    for (i = 0; i < lists.length; i++) {
      var element = document.getElementById(lists[i]);
      gPref.setIntPref(element.getAttribute("prefstring"), element.selectedItem.value);
    }

    for (i = 0; i < intlists.length; i++) {
      var intElement = document.getElementById(intlists[i]);
      gPref.setIntPref(intElement.getAttribute("prefstring"), intElement.value);
    }
  }
  catch (e) {
  }

  return true;
}

function  TM_verifyWidth() {
   var minWidth = document.getElementById("minWidth");
   var maxWidth = document.getElementById("maxWidth");
   var tempWidth;

   if ( minWidth.value > maxWidth.value ) { // vraiment bizarre...
     if ( minWidth.value < 100 && maxWidth.value > 99 )
       ;
     else {
       tempWidth = minWidth.value;
       minWidth.value = maxWidth.value;
       maxWidth.value = tempWidth;
     }
   }
   else if ( minWidth.value > 99 && maxWidth.value < 100 ) {
     tempWidth = minWidth.value;
     minWidth.value = maxWidth.value;
     maxWidth.value = tempWidth;
   }

   if ( minWidth.value < 30 || minWidth.value > 250 )
     minWidth.value = 30;
   if ( maxWidth.value > 1000 || maxWidth.value < 30 )
     maxWidth.value = 250;

   return;
}

function TM_checkSingleWindow ( enableSingleWindow ) {
  var externalLink = document.getElementById("externalLinkTarget");
  var divertedWindow = document.getElementById("divertedWindowOpen");
  var generalWindow = document.getElementById("generalWindowOpen");
  if ( enableSingleWindow ) {
    if ( generalWindow.selectedItem.value == 2 ) {
      generalWindow.value = 3;
      generalWindow.selectedItem.value = 3;
    }
    if ( divertedWindow.selectedItem.value != 0 ) {
      divertedWindow.value = 0;
      divertedWindow.selectedItem.value = 0;
    }
    if ( externalLink.selectedItem.value == 2 ) {
      externalLink.value = 3;
      externalLink.selectedItem.value = 3;
    }
  }
  for (var i = 0; i < singlehides.length; ++i) {
    var singlehide = document.getElementById(singlehides[i]);
    singlehide.setAttribute("disabled", enableSingleWindow);
  }
}

function TM_checkDependant () {
  for (var i = 0; i < parentCheckboxes.length; ++i ) {
    var parentCheckbox = document.getElementById(parentCheckboxes[i]);
    var dependantOnCheckbox = document.getElementById(dependantOnCheckboxes[i]);
    if(parentCheckbox.getAttribute("inverseDependency"))
      dependantOnCheckbox.disabled = parentCheckbox.checked;
    else
      dependantOnCheckbox.disabled = !parentCheckbox.checked;
  }
  if( document.getElementById( 'showTabX.always' ).selected )
    document.getElementById('tabXDelay').disabled=true;
}

// Restore default settings (uses data \defaults\preferences\tabmix.js, when installed only) by Chas Tucker
function TM_defaultSetting () {
  try {
    for (var i = 0; i < checkboxes.length; ++i) {
      var checkbox = document.getElementById(checkboxes[i]);
      gPref.lockPref(checkbox.getAttribute("prefstring"));
      checkbox.checked = gPref.getBoolPref(checkbox.getAttribute("prefstring"));
      gPref.unlockPref (checkbox.getAttribute("prefstring"));
    }
    for (i = 0; i < inversePrefCheckboxes.length; ++i) {
      var checkboxinverse = document.getElementById(inversePrefCheckboxes[i]);
      !gPref.lockPref(checkboxinverse.getAttribute("prefstring"));
      checkboxinverse.checked = !gPref.getBoolPref(checkboxinverse.getAttribute("prefstring"));
      !gPref.unlockPref(checkboxinverse.getAttribute("prefstring"));
    }
    for (i = 0; i < intlists.length; i++) {
      var intlist = document.getElementById(intlists[i]);
      gPref.lockPref(intlist.getAttribute("prefstring"));
      intlist.value =  gPref.getIntPref(intlist.getAttribute("prefstring"));
      gPref.unlockPref(intlist.getAttribute("prefstring"));
    }
    for (i = 0; i < lists.length; i++) {
      var element = document.getElementById(lists[i]);
      var prefstring = element.getAttribute("prefstring");
      element.getElementsByAttribute("value", gPref.lockPref(prefstring))[0];
      element.selectedItem = element.getElementsByAttribute("value", gPref.getIntPref(prefstring))[0];
      element.getElementsByAttribute("value", gPref.unlockPref(prefstring))[0];
    }
    TM_loadTabXMode(true);
    TM_checkDependant();
  }
  catch (e) {
  }
}