// code based on Tab X 0.5 enhanced version by Morac, modified by Hemiola SUN

var nsIPrefServiceObj = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
var tabxBranch = "extensions.tabmix.";
var tabxPrefs = nsIPrefServiceObj.getBranch(tabxBranch);

var prefStrings = [ "tabXMode", "tabBarMode", "hideTabBarButton", "maxWidth", "minWidth", "tabBarPosition",
                    "singleWindow", "progressMeter", "tabBarSpace", "unreadTab", "tabsList", "speLink",
                    "extraIcons", "newTabButton" ];

var singledisabledlists = ["context-openlink"];
var addtabx;
var tabscroll;
var hidebutton;
var max_width;
var min_width;
var flexTabs;
var tabbarposition;
var singleWindowMode;
var progress;
var tabBarSpace;
var unreadTab;
var tabsList;
var alwaysNewTab;
var showIcons;
var showNewTabButton;


// Function that shows or hides the tabbar close button and
// changes the tab close icon to either the theme's or tab x's version.
//
function TMupdateSettings()
{
  if (!getBrowser()) return;

  var i;
  var max_width;
  var min_width;

  try {
    addtabx = tabxPrefs.getIntPref("tabXMode");
    tabscroll = tabxPrefs.getIntPref("tabBarMode");
    hidebutton = tabxPrefs.getBoolPref("hideTabBarButton");
    max_width  = tabxPrefs.getIntPref("maxWidth");
    min_width  = tabxPrefs.getIntPref("minWidth");
    flexTabs = tabxPrefs.getBoolPref("flexTabs");
    tabbarposition = tabxPrefs.getIntPref("tabBarPosition");
    singleWindowMode = tabxPrefs.getBoolPref("singleWindow");
    progress = tabxPrefs.getBoolPref("progressMeter");
    tabBarSpace = tabxPrefs.getBoolPref("tabBarSpace");
    unreadTab = tabxPrefs.getBoolPref("unreadTab");
    tabsList = tabxPrefs.getBoolPref("tabsList");
    alwaysNewTab = tabxPrefs.getIntPref("speLink");
    showIcons = tabxPrefs.getBoolPref("extraIcons");
    showNewTabButton = tabxPrefs.getBoolPref("newTabButton");
  }
  catch(e) {
    max_width = 250;
    min_width = 50;
    flexTabs = false;
  }

  var allTabs = getBrowser().mTabContainer.childNodes;
  var tabBar = getBrowser().mTabContainer;
  var tabBox = getBrowser().mTabBox;

  if ( tabbarposition==1 )
    tabBox.setAttribute("dir","rtl");
  if ( tabbarposition==0 )
    tabBox.setAttribute("dir","ltr");

  switch ( tabscroll ) {
    case 0:
      tabBar.setAttribute("flowing", "singlebar");
      break;
    case 1:
      tabBar.setAttribute("flowing", "scrollbutton");
      break;
    case 2:
      tabBar.setAttribute("flowing", "multibar");
      tabBar.collapsedTabs = 0;
      break;
  }
  for (i = 0; i < allTabs.length; i++) {
    allTabs[i].maxWidth = max_width;
    allTabs[i].minWidth = min_width;
   if (flexTabs) {
   if (allTabs[i].hasAttribute("width")) allTabs[i].removeAttribute("width");
   if (allTabs[i].hasAttribute("flex")) allTabs[i].removeAttribute("flex");
   } else {
   allTabs[i].setAttribute("width", "0")
   allTabs[i].setAttribute("flex", "100");
       }
    if ( alwaysNewTab == 1 )
      allTabs[i].setAttribute("locked", "true");
    else if ( tabBar.getAttribute("lockAllTab") == "true" )
      allTabs[i].removeAttribute("locked");
    switch ( addtabx ) {
    case 0 :
      allTabs[i].setAttribute("tabx", "no-button");
      break;
    case 1 :
      allTabs[i].setAttribute("tabx", "always");
      break;
    case 2 :
      allTabs[i].setAttribute("tabx", "showhover");
      break;
    }
  }
  tabBar.setAttribute("closebutton", !hidebutton);
  tabBar.setAttribute("progress", progress);
  tabBar.setAttribute("tabBarSpace", tabBarSpace);
  tabBar.setAttribute("unread", unreadTab);
  tabBar.setAttribute("extraIcons", showIcons );
  tabBar.setAttribute("lockAllTab", alwaysNewTab == 1 );
  tabBar.setAttribute("newTab", showNewTabButton );

  tabBarScrollStatus();
  if ( tabBarWidth == -1 ) // initialize the value of "tabBarWidth"
    window.setTimeout( function () {
                        tabBarWidth = gBrowser.mTabContainer.boxObject.width;
                      }, 100 );

  // code for Single Window Mode...
  // disable the "Open New Window action
  var cmdNewWindow = document.getElementById("cmd_newNavigator");
  if (originalNewNavigator == "" ) // get the original command
    originalNewNavigator = cmdNewWindow.getAttribute("oncommand");
  if ( singleWindowMode )
    cmdNewWindow.setAttribute("oncommand","BrowserOpenTab();");
  else
    cmdNewWindow.setAttribute("oncommand",originalNewNavigator);

  //hides some menuitem
  for (i = 0; i < singledisabledlists.length; ++i) {
    var singledisabledlist = document.getElementById(singledisabledlists[i]);
    singledisabledlist.setAttribute("disabled", singleWindowMode);
  }
  var menuFile = document.getElementById("menu_FilePopup");
  menuFile.firstChild.setAttribute("hidden", singleWindowMode); // why can't i disable it...

  // hide or show the list of opened tabs in the tools menu
  document.getElementById("tm-tabsList").hidden = !tabsList;
}

// Function to catch when a new window is created and update icons if needed
//
function tabxOnLoad(event)
{
  // add event for creating a new tab
  getBrowser().mTabContainer.addEventListener("DOMNodeInserted", tabxTabAdded, true);

  // add event for closing a tab
  getBrowser().mTabContainer.addEventListener("DOMNodeRemoved", tabxTabClosed, true);

  // add event for mouse scrolling on tab bar, necessary for linux
  getBrowser().mTabContainer.addEventListener("DOMMouseScroll", TMtabBarScroll, false);
  if (window.navigator.platform.search("Linux") != -1)
    document.getElementById("navigator-toolbox").addEventListener("DOMMouseScroll", TMtabBarScroll, false);

  // update icons if needed
  TMupdateSettings();
}

function tabxTabClosed(event)
{
  var tabs = getBrowser().mTabContainer.childNodes;
  var tabBar = getBrowser().mTabContainer;
  var firstTab = tabs[0];

  if ( getBrowser().mCurrentTab.ordinal == event.target.ordinal )
    tabBar.setAttribute("close","true");

  if ( tabscroll != 2 ) {
    tabBar.collapsedTabs--;
    tabBar.canScrollTabsLeft = firstTab.collapsed;
    window.setTimeout( function() {
                         tabBar.canScrollTabsRight = !tabBar.rightEnd;
                       }, 50 );
  }
  else {
    if ( tabBar.getAttribute("multibar") == "scrollbar" && firstTab.collapsed &&
         !inSameRow( tabs[tabs.length-1], tabs[tabs.length-2] ) &&
         ( tabs[tabs.length-1].boxObject.y ) <= ( tabBar.boxObject.y + tabBar.boxObject.height ) ) {
      tabBar.rowScroll(-1);
      tabBar.canScrollTabsLeft = firstTab.collapsed;
    }
    window.setTimeout( function() {
                         if ( getNumberOfRows() == 1 )
                           tabBar.removeAttribute("multibar");
                         else if ( getNumberOfRows() <= tabBar.maxRow )
                           tabBar.setAttribute("multibar", "true");
                         setTabBarHeight();
                         tabBar.canScrollTabsRight = !tabBar.rightEnd;
                         checkBeforeAndAfter();
                       }, 50 );
  }
  setTabBarHeight();
}

// Function to catch when new tabs are created and update tab icons if needed
// In addition clicks and doubleclick events are trapped.
//
function tabxTabAdded(event)
{
  if (event.target.nodeName == "tab") {
    try {
      max_width  = tabxPrefs.getIntPref("maxWidth");
      min_width  = tabxPrefs.getIntPref("minWidth");
      flexTabs = tabxPrefs.getBoolPref("flexTabs");
    }
    catch(e) {
      max_width = 250;
      min_width = 30;
      flexTabs = false;
      }

    var tabItems = event.target;
    switch ( addtabx ) {
    case 0 :
      tabItems.setAttribute("tabx", "no-button");
      break;
    case 1 :
      tabItems.setAttribute("tabx", "always");
      break;
    case 2 :
      tabItems.setAttribute("tabx", "showhover");
      break;
    }   
    tabItems.maxWidth = max_width;
    tabItems.minWidth = min_width;
   if (flexTabs) {
      if (tabItems.hasAttribute("width")) tabItems.removeAttribute("width");
      if (tabItems.hasAttribute("flex")) tabItems.removeAttribute("flex");
        } else {
      tabItems.setAttribute("width", "0")
      tabItems.setAttribute("flex", "100");
         }
    if ( alwaysNewTab == 1 )
      tabItems.setAttribute("locked", "true");

    tabBarScrollStatus();
  }
}

function tabBarScrollStatus ()
{
  var allTabs = getBrowser().mTabContainer.childNodes;
  var tabBar = getBrowser().mTabContainer;

  tabBar.canScrollTabsLeft = allTabs[0].collapsed;
  tabBar.canScrollTabsRight = !tabBar.rightEnd;

  if ( tabscroll == 2 ) {
    tabBar.setAttribute("multibar", "true");
    var rows = getNumberOfRows();
    if ( rows == 1 )
      tabBar.removeAttribute("multibar");
    else if ( rows > tabBar.maxRow )
      tabBar.setAttribute("multibar", "scrollbar");
  }
  else
    tabBar.removeAttribute("multibar");
  setTabBarHeight();
}

function checkBeforeAndAfter()
{
var tab = getBrowser().mTabContainer.selectedItem;
var prev = tab.previousSibling, next = tab.nextSibling;
if (prev) {if ( !inSameRow(prev, tab) ) prev.removeAttribute("beforeselected");
else prev.setAttribute("beforeselected", "true");}
if (next) {if ( !inSameRow(next, tab) ) next.removeAttribute("afterselected");
else next.setAttribute("afterselected", "true");}
}

function getRowHeight ()
{
  var tabBar = getBrowser().mTabContainer;
  var tabs = getBrowser().mTabContainer.childNodes;

  var i = j = tabBar.collapsedTabs;
  if ( tabs[j].getAttribute("selected") == "true" )
    j++;
  while ( inSameRow( tabs[i], tabs[j] ) )
    i++;
  if ( !tabs[i] ) // only one row
    return tabs[j].baseY - tabs[j].boxObject.y;
  if ( tabs[i].getAttribute("selected") == "true" )
    i++;
  return tabs[i].baseY - tabs[j].baseY;
}

function setTabBarHeight () {
  var tabBar = getBrowser().mTabContainer;
  var tabhbox = document.getElementById("scroll-tabs-frame");
  if ( tabBar.getAttribute("flowing") == "multibar" && tabBar.getAttribute("multibar") == "scrollbar" ) {
    tabhbox.style.maxHeight = tabhbox.style.height = getRowHeight() * tabBar.maxRow + "px";
    document.getElementById("tabmix-tabs-closebutton-box").pack = "start";
  }
  else {
    if ( tabBar.getAttribute("flowing") == "multibar" && tabBar.getAttribute("multibar") == "true")
      document.getElementById("tabmix-tabs-closebutton-box").pack = "start";
    else
      document.getElementById("tabmix-tabs-closebutton-box").pack = "center";
    tabhbox.style.maxHeight = "none";
    tabhbox.style.height = "auto";
  }
}

function getNumberOfRows ()
{
  var tabBar = getBrowser().mTabContainer;
  var tabs = getBrowser().mTabContainer.childNodes;
  var len = tabs.length;
  var i, j;
  i = j = tabBar.collapsedTabs;

  if ( i == 0 && inSameRow(tabs[0], tabs[len-1]) )
    return 1;

  while ( inSameRow(tabs[i], tabs[j]) )
    i++;
  var numbersInRow = i - j;

  var lastRow = len % numbersInRow;

  return (len-lastRow) / numbersInRow + ( lastRow == 0 ? 0 : 1 );
}

function inSameRow (tab1, tab2)
{
  if ( !tab1 || !tab2 )
    return false;
  if ( !tabscroll || tabscroll != 2 )
    return true;
  var top1 = tab1.boxObject.y, top2 = tab2.boxObject.y;
  var base1 = tab1.baseY, base2 = tab2.baseY;
  var topH = Math.min(top1, top2), topL = Math.max(top1, top2);
  var baseH = Math.min(base1, base2), baseL = Math.max(base1, base2);

  if ( topH == topL || baseH == baseL )
    return true;

  return ( baseH > (top1+base1)/2 && baseH > (top2+base2)/2 && topL < (top1+base1)/2 && topL < (top2+base2)/2 ) ?
    true : false;
}

function tabBarWidthChange () {
  var tabBar = getBrowser().mTabContainer;
  var tabhbox = document.getElementById("scroll-tabs-frame");
  var tabs = getBrowser().mTabContainer.childNodes;
  if ( tabBarWidth == tabBar.boxObject.width )
    return;

  var oldCollapsed = tabBar.collapsedTabs;
  var i = 0;
  if ( tabscroll != 2 && tabBarWidth < tabBar.boxObject.width ) {
    while ( tabs[ oldCollapsed + i ] &&
            tabs[ oldCollapsed + i ].boxObject.x + tabs[ oldCollapsed + i ].boxObject.width <
              tabhbox.boxObject.x + tabhbox.boxObject.width )
      i++;
    tabBar.collapsedTabs = 0;
    tabBar.ensureTabIsVisible( oldCollapsed + i - 1 );
    tabBarScrollStatus();
  }
  else if ( tabscroll == 2 ) {
    tabBar.collapsedTabs = 0;
    tabBarScrollStatus();
    tabBar.ensureTabIsVisible( tabs.length - 1);
    tabBar.ensureTabIsVisible( oldCollapsed );
    checkBeforeAndAfter();
  }
  else
    tabBarScrollStatus();

  tabBarWidth = tabBar.boxObject.width;
}

// Function to catch changes to Tab Mix preferences and update existing windows and tabs
//
function tabxPrefObserver() {
  try {
    var pref = nsIPrefServiceObj.getBranch(null);
    this.pbi = pref.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
    this.pbi.addObserver(tabxBranch, this, true);
  }
  catch(e) {
    alert("Tabx: prefs-Observer failed to attach: " + e + "\n");
  }
}

tabxPrefObserver.prototype = {
  // nsISupports interface implementation -- for weak-reference by pref-observer service
  QueryInterface: function(iid) {
    if (!iid.equals(Components.interfaces.nsISupports)
        && !iid.equals(Components.interfaces.nsISupportsWeakReference)
        && !iid.equals(Components.interfaces.nsIObserver)) {
      dump("Tab X pref-observer factory object: QI unknown interface: " + iid + "\n");
      throw Components.results.NS_ERROR_NO_INTERFACE;
    }
    return this;
  },

  // removes the observer-object from service -- called when the window is no longer open
  removeObserver: function() {
    this.pbi.removeObserver(tabxBranch, this);
    delete this;
  },

  /* Observer-function */
  /* subject: [wrapped nsISupports :: nsIPrefBranch], nsIPrefBranch Internal
     topic: "changed"*/
  observe: function(subject, topic, prefName) {

    // if we don't have a valid window (closed)
    if ( !(typeof(document) == 'object' && document) ) {
      this.removeObserver(); // remove the observer..
      return;  // ..and don't continue
    }

    TMupdateSettings();
  }
}

function TMtabBarScroll (event)
{
  var tabs = getBrowser().mTabContainer.childNodes;
  var tabBar = getBrowser().mTabContainer;

  for (var i = 0; i < tabs.length; i++)
    tabs[i].setAttribute("showbutton","off");

  var shouldMoveFocus = gPref.getBoolPref("extensions.tabmix.enableScrollSwitch");
  if (shouldMoveFocus)
    if (typeof(getBrowser().moveTabTo)=="undefined") tabBar.advanceSelectedTab(event.detail > 0 ? 1 : -1 );
else tabBar.advanceSelectedTab(event.detail > 0 ? 1 : -1 , true);
  else if ( gPref.getIntPref("extensions.tabmix.tabBarMode") != 2 ) {
    if ( event.detail > 0 )
      tabBar.collapsedTabs++;
    else
      tabBar.collapsedTabs--;
  }
  else if ( gPref.getIntPref("extensions.tabmix.tabBarMode") == 2 ) {
    if ( event.detail > 0 )
      tabBar.rowScroll(1);
    else
      tabBar.rowScroll(-1);
  }
}
