/*
 * tabmix.js
 *
 * code by Hemiola SUN
 */
var gPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var gObserver = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
var WindowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);

var originalNewNavigator = "";
var tabBarWidth = -1;

function TM_init()
{
  // replace browser handlers with ours so it recognizes when tabs are acted on
  gBrowser.onTabBarDblClick = TMonTabBarDblClick;
  gBrowser.updateContextTab = TMupdateContextTab;
  gBrowser.onDrop = TMonDrop;

  gBrowser.mTabBox.insertBefore(document.getElementById('vide-bar'), gBrowser.mTabBox.firstChild);

  gBrowser.closedTabs = [];
  TM_creatMenuItems();

  gBrowser.mTabContainer.addEventListener( "click", TM_checkClick, false);
  document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", TM_checkContentMenu, false);
  document.getElementById("content").onresize = tabBarWidthChange;

  // override the duplicate tab function of All-in-One Gestures
  if (typeof aioDupTab == 'function') {
    aioDupTab = function() { gBrowser.duplicateTab(gBrowser.mCurrentTab); };
  }
// for session restore
window.setTimeout( function () {
if ( gPref.getBoolPref("extensions.tabmix.sessionsRestore") )
SessionRestore.loadClosedTabs(); }, 0 );

var goMenu = document.getElementById("goPopup").parentNode;
goMenu.setAttribute("oncommand", "var url = event.target.getAttribute('statustext'); if (url) TMopenUILink(url, event, false, true);");
// for Browser:Home open in new tab if the curren tab is locked
window.BrowserHome = TM_BrowserHome;
}



function TM_deinit ()
{
  if ( gPref.getBoolPref("extensions.tabmix.sessionsRestore") ) {
    SessionRestore.clearAllClosedTabs();
    SessionRestore.cacheClosedTabs();
    SessionRestore.saveClosedTabs();
 gPref.setIntPref("extensions.tabmix.sessionsRestore.index",gBrowser.mTabContainer.selectedIndex);
  }
}

// Create new items in the context menu of tab bar
//

var newMenuItems = ["tm-duplicateTab","tm-renametab","tm-separator",
                    "tm-closeAllTabs","tm-closeLeftTabs","tm-closeRightTabs",
                    "tm-undoCloseList","tm-undoCloseTab","tm-separator-2",
                    "tm-docShell","tm-protectTab","tm-lockTab"];
var newMenuOrders = [ 1, 2, 6, 8, 9,
                      10, 12, 13,
                      15, 16, 17, 18 ];

function TM_creatMenuItems () {
  for ( var i = 0; i < newMenuItems.length; i++ ) {
    var newMenuItem = document.getElementById(newMenuItems[i]);
    gBrowser.mStrip.firstChild.nextSibling.insertBefore( newMenuItem,
      gBrowser.mStrip.firstChild.nextSibling.childNodes[ newMenuOrders[i] ] );
    newMenuItem.hidden = true;
  }
}