var windowType = null;

// Clears the user agent
function useragentswitcher_clearUserAgent()
{
    window.opener.useragentswitcher_appName     = null;
    window.opener.useragentswitcher_appVersion  = null;
    window.opener.useragentswitcher_description = null;
    window.opener.useragentswitcher_platform    = null;
    window.opener.useragentswitcher_userAgent   = null;
}

// Initializes the user agent dialog box
function useragentswitcher_initializeUserAgent()
{
    var stringBundle = document.getElementById("useragentswitcher-string-bundle");

    windowType = window.arguments[0];

    // If the window type is add
    if(windowType == "add")
    {
        document.title = stringBundle.getString("useragentswitcher_addUserAgentTitle");
    }
    else if(windowType == "default")
    {
        var description = document.getElementById("useragentswitcher.description");

        useragentswitcher_retrieveDefault();

        document.title    = stringBundle.getString("useragentswitcher_defaultUserAgentTitle");
        description.value = stringBundle.getString("useragentswitcher_defaultDescription");

        description.setAttribute("readonly", true);
        document.getElementById("useragentswitcher.app.name").setAttribute("readonly", true);
        document.getElementById("useragentswitcher.app.version").setAttribute("readonly", true);
        document.getElementById("useragentswitcher.platform").setAttribute("readonly", true);
        document.getElementById("useragentswitcher.user.agent").setAttribute("readonly", true);
        document.getElementById("useragentswitcher.vendor").setAttribute("readonly", true);
        document.getElementById("useragentswitcher.vendor.sub").setAttribute("readonly", true);
    }
    else if(windowType == "edit")
    {
        document.title = stringBundle.getString("useragentswitcher_editUserAgentTitle");

        document.getElementById("useragentswitcher.app.name").value    = window.arguments[1];
        document.getElementById("useragentswitcher.app.version").value = window.arguments[2];
        document.getElementById("useragentswitcher.description").value = window.arguments[3];
        document.getElementById("useragentswitcher.platform").value    = window.arguments[4];
        document.getElementById("useragentswitcher.user.agent").value  = window.arguments[5];
        document.getElementById("useragentswitcher.vendor").value      = window.arguments[6];
        document.getElementById("useragentswitcher.vendor.sub").value  = window.arguments[7];
    }
}

// Retrieves the default user agent
function useragentswitcher_retrieveDefault()
{

    var appName            = null;
    var appVersion         = null;
    var description        = null;
    var platform           = null;
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
    var string             = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
    var userAgent          = null;
    var vendor             = null;
    var vendorSub          = null;

    // If the app name is being overridden
    if(preferencesService.prefHasUserValue("general.appname.override"))
    {
        appName = preferencesService.getComplexValue("general.appname.override", Components.interfaces.nsISupportsString).data.trim();
        preferencesService.clearUserPref("general.appname.override");
    }

    // If the app version is being overridden
    if(preferencesService.prefHasUserValue("general.appversion.override"))
    {
        appVersion = preferencesService.getComplexValue("general.appversion.override", Components.interfaces.nsISupportsString).data.trim();
        preferencesService.clearUserPref("general.appversion.override");
    }

    // If the platform is being overridden
    if(preferencesService.prefHasUserValue("general.platform.override"))
    {
        platform = preferencesService.getComplexValue("general.platform.override", Components.interfaces.nsISupportsString).data.trim();
        preferencesService.clearUserPref("general.platform.override");
    }

    // If the user agent is being overridden
    if(preferencesService.prefHasUserValue("general.useragent.override"))
    {
        userAgent = preferencesService.getComplexValue("general.useragent.override", Components.interfaces.nsISupportsString).data.trim();
        preferencesService.clearUserPref("general.useragent.override");
    }

    // If the vendor is being overridden
    if(preferencesService.prefHasUserValue("general.useragent.vendor"))
    {
        vendor = preferencesService.getComplexValue("general.useragent.vendor", Components.interfaces.nsISupportsString).data.trim();
        preferencesService.clearUserPref("general.useragent.vendor");
    }

    // If the vendor sub is being overridden
    if(preferencesService.prefHasUserValue("general.useragent.vendorSub"))
    {
        vendorSub = preferencesService.getComplexValue("general.useragent.vendorSub", Components.interfaces.nsISupportsString).data.trim();
        preferencesService.clearUserPref("general.useragent.vendorSub");
    }

    document.getElementById("useragentswitcher.app.name").value    = navigator.appName;
    document.getElementById("useragentswitcher.app.version").value = navigator.appVersion;
    document.getElementById("useragentswitcher.platform").value    = navigator.platform;
    document.getElementById("useragentswitcher.user.agent").value  = navigator.userAgent;
    document.getElementById("useragentswitcher.vendor").value      = navigator.vendor;
    document.getElementById("useragentswitcher.vendor.sub").value  = navigator.vendorSub;

    // If the app name was being overridden
    if(appName)
    {
        string.data = appName;
        preferencesService.setComplexValue("general.appname.override", Components.interfaces.nsISupportsString, string);
    }

    // If the app version was being overridden
    if(appVersion)
    {
        string.data = appVersion;
        preferencesService.setComplexValue("general.appversion.override", Components.interfaces.nsISupportsString, string);
    }

    // If the platform was being overridden
    if(platform)
    {
        string.data = platform;
        preferencesService.setComplexValue("general.platform.override", Components.interfaces.nsISupportsString, string);
    }

    // If the user agent was being overridden
    if(userAgent)
    {
        string.data = userAgent;
        preferencesService.setComplexValue("general.useragent.override", Components.interfaces.nsISupportsString, string);
    }

    // If the vendor was being overridden
    if(vendor)
    {
        string.data = vendor;
        preferencesService.setComplexValue("general.useragent.vendor", Components.interfaces.nsISupportsString, string);
    }

    // If the vendor sub was being overridden
    if(vendorSub)
    {
        string.data = vendorSub;
        preferencesService.setComplexValue("general.useragent.vendorSub", Components.interfaces.nsISupportsString, string);
    }
}

// Saves a user agent
function useragentswitcher_saveUserAgent()
{
    // If the window type is add or edit
    if(windowType == "add" || windowType == "edit")
    {
        var appName      = document.getElementById("useragentswitcher.app.name").value.trim();
        var appVersion   = document.getElementById("useragentswitcher.app.version").value.trim();
        var description  = document.getElementById("useragentswitcher.description").value.trim();
        var platform     = document.getElementById("useragentswitcher.platform").value.trim();
        var stringBundle = document.getElementById("useragentswitcher-string-bundle");
        var userAgent    = document.getElementById("useragentswitcher.user.agent").value.trim();
        var vendor       = document.getElementById("useragentswitcher.vendor").value.trim();
        var vendorSub    = document.getElementById("useragentswitcher.vendor.sub").value.trim();

        // If the description is empty
        if(!description)
        {
            alert(stringBundle.getString("useragentswitcher_emptyDescription"));

            return false;
        }
        else
        {
            window.opener.useragentswitcher_appName     = appName;
            window.opener.useragentswitcher_appVersion  = appVersion;
            window.opener.useragentswitcher_description = description;
            window.opener.useragentswitcher_platform    = platform;
            window.opener.useragentswitcher_userAgent   = userAgent;
            window.opener.useragentswitcher_vendor      = vendor;
            window.opener.useragentswitcher_vendorSub   = vendorSub;

            return true;
        }
    }
    else
    {
        return true;
    }
}
