var useragentswitcher_optionsDataBoolean = new Array();
var useragentswitcher_optionsDataInteger = new Array();
var useragentswitcher_optionsDataString  = new Array();

var useragentswitcher_appName     = null;
var useragentswitcher_appVersion  = null;
var useragentswitcher_description = null;
var useragentswitcher_platform    = null;
var useragentswitcher_userAgent   = null;
var useragentswitcher_vendor      = null;
var useragentswitcher_vendorSub   = null;

// Adds a user agent
function useragentswitcher_addUserAgent()
{
    var pageDocument = document.getElementById("useragentswitcher-options-iframe").contentDocument;
    var userAgentBox = pageDocument.getElementById("useragentswitcher-listbox");

    window.openDialog("chrome://useragentswitcher/content/options/dialogs/user_agent.xul", "useragentswitcher-user-agent-dialog", "centerscreen,chrome,modal,resizable", "add");

    // If the description is set
    if(useragentswitcher_description)
    {
        var newItem = userAgentBox.appendItem(useragentswitcher_description, useragentswitcher_userAgent);

        newItem.setAttribute("appname", useragentswitcher_appName);
        newItem.setAttribute("appversion", useragentswitcher_appVersion);
        newItem.setAttribute("platform", useragentswitcher_platform);
        newItem.setAttribute("vendor", useragentswitcher_vendor);
        newItem.setAttribute("vendorsub", useragentswitcher_vendorSub);

        userAgentBox.ensureElementIsVisible(newItem);
        userAgentBox.selectItem(newItem);
    }
}

// Handles changing the options page
function useragentswitcher_changePage(pageList)
{
    useragentswitcher_storeOptions();

    document.getElementById("useragentswitcher-options-iframe").setAttribute("src", pageList.selectedItem.getAttribute("value"));
}

// Deletes a user agent
function useragentswitcher_deleteUserAgent()
{
    var pageDocument = document.getElementById("useragentswitcher-options-iframe").contentDocument;
    var userAgentBox = pageDocument.getElementById("useragentswitcher-listbox");
    var selectedItem = userAgentBox.selectedItem;
    var stringBundle = document.getElementById("useragentswitcher-string-bundle");

    // If an item is selected and the deletion is confirmed
    if(selectedItem && confirm(stringBundle.getString("useragentswitcher_deleteConfirmation")))
    {
        userAgentBox.removeChild(selectedItem);
    }
}

// Edits a user agent
function useragentswitcher_editUserAgent()
{
    var pageDocument = document.getElementById("useragentswitcher-options-iframe").contentDocument;
    var userAgentBox = pageDocument.getElementById("useragentswitcher-listbox");
    var selectedItem = userAgentBox.selectedItem;

    // If an item is selected
    if(selectedItem)
    {
        var appName    = "";
        var appVersion = "";
        var platform   = "";
        var vendor     = "";
        var vendorSub  = "";

        // If the selected item has an app name attribute
        if(selectedItem.hasAttribute("appname"))
        {
            appName = selectedItem.getAttribute("appname");
        }

        // If the selected item has an app version attribute
        if(selectedItem.hasAttribute("appversion"))
        {
            appVersion = selectedItem.getAttribute("appversion");
        }

        // If the selected item has a platform attribute
        if(selectedItem.hasAttribute("platform"))
        {
            platform = selectedItem.getAttribute("platform");
        }

        // If the selected item has a vendor attribute
        if(selectedItem.hasAttribute("vendor"))
        {
            vendor = selectedItem.getAttribute("vendor");
        }

        // If the selected item has a vendorsub attribute
        if(selectedItem.hasAttribute("vendorsub"))
        {
            vendorSub = selectedItem.getAttribute("vendorsub");
        }

        window.openDialog("chrome://useragentswitcher/content/options/dialogs/user_agent.xul", "useragentswitcher-user-agent-dialog", "centerscreen,chrome,modal,resizable", "edit", appName, appVersion, selectedItem.label, platform, selectedItem.value, vendor, vendorSub);

        // If the description is set
        if(useragentswitcher_description)
        {
            selectedItem.label = useragentswitcher_description;
            selectedItem.value = useragentswitcher_userAgent;

            selectedItem.setAttribute("appname", useragentswitcher_appName);
            selectedItem.setAttribute("appversion", useragentswitcher_appVersion);
            selectedItem.setAttribute("platform", useragentswitcher_platform);
            selectedItem.setAttribute("vendor", useragentswitcher_vendor);
            selectedItem.setAttribute("vendorsub", useragentswitcher_vendorSub);

            userAgentBox.ensureElementIsVisible(selectedItem);
        }
    }
}

// Exports user agents to an XML file
function useragentswitcher_exportUserAgents()
{
    var filePicker   = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
    var result       = null;
    var stringBundle = document.getElementById("useragentswitcher-string-bundle");

    filePicker.defaultExtension = "xml";
    filePicker.defaultString    = "useragentswitcher.xml";

    filePicker.appendFilter(stringBundle.getString("useragentswitcher_xmlFileDescription"), "*.xml");
    filePicker.init(window, stringBundle.getString("useragentswitcher_exportUserAgentsTitle"), filePicker.modeSave);
    result = filePicker.show();

    // If the user selected a style sheet
    if(result == filePicker.returnOK || result == filePicker.returnReplace)
    {
        var element        = null;
        var file           = filePicker.file;
        var listItem       = null;
        var outputStream   = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
        var pageDocument   = document.getElementById("useragentswitcher-options-iframe").contentDocument;
        var userAgentBox   = pageDocument.getElementById("useragentswitcher-listbox");
        var userAgentCount = userAgentBox.getRowCount();
        var xmlDocument    = document.implementation.createDocument("", "", null);
        var rootElement    = xmlDocument.createElement("useragentswitcher");
        var xmlSerializer  = new XMLSerializer();

        // If the file does not exist
        if(!file.exists())
        {
            file.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 00444);
        }

        // Loop through the possible user agents
        for(var i = 1; i <= userAgentCount; i++)
        {
            element  = xmlDocument.createElement("useragent");
            listItem = userAgentBox.getItemAtIndex(i - 1);

            element.setAttribute("description", listItem.label.trim());
            element.setAttribute("useragent", listItem.value.trim());

            // If the list item has an app name attribute
            if(listItem.hasAttribute("appname"))
            {
                element.setAttribute("appname", listItem.getAttribute("appname").trim());
            }

            // If the selected item has an app version attribute
            if(listItem.hasAttribute("appversion"))
            {
                element.setAttribute("appversion", listItem.getAttribute("appversion").trim());
            }

            // If the selected item has a platform attribute
            if(listItem.hasAttribute("platform"))
            {
                element.setAttribute("platform", listItem.getAttribute("platform").trim());
            }

            // If the selected item has a vendor attribute
            if(listItem.hasAttribute("vendor"))
            {
                element.setAttribute("vendor", listItem.getAttribute("vendor").trim());
            }

            // If the selected item has a vendorsub attribute
            if(listItem.hasAttribute("vendorsub"))
            {
                element.setAttribute("vendorsub", listItem.getAttribute("vendorsub").trim());
            }

            rootElement.appendChild(element);
        }

        xmlDocument.appendChild(rootElement);

        outputStream.init(file, 0x04 | 0x08 | 0x20, 00444, null);
        xmlSerializer.serializeToStream(xmlDocument, outputStream, "utf-8");
        outputStream.close();
    }
}

// Evaluates the specified xpath on the specified element returning an array of the matching elements
function useragentswitcher_evaluateXPath(expression, element)
{
    var evaluationResults = null;
    var matchingElement   = null;
    var matchingElements  = new Array();
    var ownerDocument     = element.ownerDocument;
    var xPathEvaluator    = new XPathEvaluator();
    var resolver          = xPathEvaluator.createNSResolver(element.documentElement);

    evaluationResults = xPathEvaluator.evaluate(expression, element, resolver, 0, null);

    // While there are more matching elements
    while((matchingElement = evaluationResults.iterateNext()) != null)
    {
        matchingElements.push(matchingElement);
    }

    return matchingElements;
}

// Imports user agents from an XML file
function useragentswitcher_importUserAgents()
{
    var filePicker   = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
    var stringBundle = document.getElementById("useragentswitcher-string-bundle");

    filePicker.appendFilter(stringBundle.getString("useragentswitcher_xmlFileDescription"), "*.xml");
    filePicker.init(window, stringBundle.getString("useragentswitcher_importUserAgentsTitle"), filePicker.modeOpen);

    // If the user selected an XML file
    if(filePicker.show() == filePicker.returnOK)
    {
        var file     = filePicker.file;
        var filePath = file.path;

        // If the file exists, is a file and is readable
        if(file.exists() && file.isFile() && file.isReadable())
        {
            var request     = new XMLHttpRequest();
            var xmlDocument = null;

            request.open("get", "file://" + filePath, false);
            request.send(null);

            xmlDocument = request.responseXML;

            // If the file could not be parsed correctly
            if(xmlDocument.documentElement.nodeName == "parsererror")
            {
                alert(stringBundle.getFormattedString("useragentswitcher_importParserError", [filePath]));
            }
            else
            {
                var appName          = null;
                var appVersion       = null;
                var newItem          = null;
                var pageDocument     = document.getElementById("useragentswitcher-options-iframe").contentDocument;
                var platform         = null;
                var userAgent        = null;
                var userAgentBox     = pageDocument.getElementById("useragentswitcher-listbox");
                var userAgentElement = null;
                var userAgents       = useragentswitcher_evaluateXPath("//useragent", xmlDocument);
                var vendor           = null;
                var vendorSub        = null;

                // If no user agents were found
                if(userAgents.length == 0)
                {
                    alert(stringBundle.getFormattedString("useragentswitcher_importParserError", [filePath]));
                }
                else if(pageDocument.getElementById("useragentswitcher.import.overwrite").checked)
                {
                    // While there are user agents
                    while(userAgentBox.getRowCount() > 0)
                    {
                        userAgentBox.removeItemAt(0);
                    }
                }

                // Loop through the user agents
                for(var i in userAgents)
                {
                    userAgentElement = userAgents[i];

                    // If the user agent has a description
                    if(userAgentElement.hasAttribute("description"))
                    {
                        appName    = "";
                        appVersion = "";
                        platform   = "";
                        userAgent  = "";
                        vendor     = "";
                        vendorSub  = "";

                        // If the user agent element has an app name attribute
                        if(userAgentElement.hasAttribute("appname"))
                        {
                            appName = userAgentElement.getAttribute("appname");
                        }

                        // If the user agent element has an app version attribute
                        if(userAgentElement.hasAttribute("appversion"))
                        {
                            appVersion = userAgentElement.getAttribute("appversion");
                        }

                        // If the user agent element has a platform attribute
                        if(userAgentElement.hasAttribute("platform"))
                        {
                            platform = userAgentElement.getAttribute("platform");
                        }

                        // If the user agent element has a useragent attribute
                        if(userAgentElement.hasAttribute("useragent"))
                        {
                            userAgent = userAgentElement.getAttribute("useragent");
                        }

                        // If the user agent element has a vendor attribute
                        if(userAgentElement.hasAttribute("vendor"))
                        {
                            vendor = userAgentElement.getAttribute("vendor");
                        }

                        // If the user agent element has a vendorsub attribute
                        if(userAgentElement.hasAttribute("vendorsub"))
                        {
                            vendorSub = userAgentElement.getAttribute("vendorsub");
                        }

                        newItem = userAgentBox.appendItem(userAgentElement.getAttribute("description"), userAgent);

                        newItem.setAttribute("appname", appName);
                        newItem.setAttribute("appversion", appVersion);
                        newItem.setAttribute("platform", platform);
                        newItem.setAttribute("vendor", vendor);
                        newItem.setAttribute("vendorsub", vendorSub);
                    }
                }

                userAgentBox.ensureIndexIsVisible(0);
            }
        }
        else
        {
            alert(stringBundle.getFormattedString("useragentswitcher_importFileFailed", [filePath]));
        }
    }
}

// Initializes the general page
function useragentswitcher_initializeGeneral()
{
    var pageDocument       = document.getElementById("useragentswitcher-options-iframe").contentDocument;
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    // If the hide menu preference is set
    if(typeof useragentswitcher_optionsDataBoolean["useragentswitcher.menu.hide"] != "undefined")
    {
        pageDocument.getElementById("useragentswitcher.menu.hide").checked = useragentswitcher_optionsDataBoolean["useragentswitcher.menu.hide"];
    }
    else if(preferencesService.prefHasUserValue("useragentswitcher.menu.hide"))
    {
        pageDocument.getElementById("useragentswitcher.menu.hide").checked = preferencesService.getBoolPref("useragentswitcher.menu.hide");
    }
    else
    {
        pageDocument.getElementById("useragentswitcher.menu.hide").checked = false;
    }
}

// Initializes the options dialog box
function useragentswitcher_initializeOptions()
{
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
    var selectedPage       = document.getElementById("useragentswitcher-page-list").selectedItem.getAttribute("value");

    // If this is the general page
    if(selectedPage.indexOf("general") != -1)
    {
        useragentswitcher_initializeGeneral();
    }
    else if(selectedPage.indexOf("user_agents") != -1)
    {
        useragentswitcher_initializeUserAgents();
    }
}

// Initializes the user agents page
function useragentswitcher_initializeUserAgents()
{
    var appName            = null;
    var appNameValue       = null;
    var appVersion         = null;
    var appVersionValue    = null;
    var description        = null;
    var descriptionValue   = null;
    var listItem           = null;
    var pageDocument       = document.getElementById("useragentswitcher-options-iframe").contentDocument;
    var platform           = null;
    var platformValue      = null;
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
    var userAgent          = null;
    var userAgentBox       = pageDocument.getElementById("useragentswitcher-listbox");
    var userAgentCount     = 0;
    var userAgentValue     = null;
    var vendor             = null;
    var vendorSub          = null;
    var vendorSubValue     = null;
    var vendorValue        = null;

    // If the user agents count preference is set
    if(typeof useragentswitcher_optionsDataInteger["useragentswitcher.user.agents.count"] != "undefined")
    {
        userAgentCount = useragentswitcher_optionsDataInteger["useragentswitcher.user.agents.count"];
    }
    else if(preferencesService.prefHasUserValue("useragentswitcher.user.agents.count"))
    {
        userAgentCount = preferencesService.getIntPref("useragentswitcher.user.agents.count");
    }

    // Loop through the possible user agents
    for(var i = 1; i <= userAgentCount; i++)
    {
	    appName     = "useragentswitcher." + i + ".appname";
	    appVersion  = "useragentswitcher." + i + ".appversion";
	    description = "useragentswitcher." + i + ".description";
	    platform    = "useragentswitcher." + i + ".platform";
	    userAgent   = "useragentswitcher." + i + ".useragent";
	    vendor      = "useragentswitcher." + i + ".vendor";
	    vendorSub   = "useragentswitcher." + i + ".vendorsub";

        // If the app name is set
        if(typeof useragentswitcher_optionsDataString[appName] != "undefined")
        {
            appNameValue = useragentswitcher_optionsDataString[appName].trim();
        }
        else if(preferencesService.prefHasUserValue(appName))
        {
	        appNameValue = preferencesService.getComplexValue(appName, Components.interfaces.nsISupportsString).data.trim();
        }
        else
        {
            appNameValue = null;
        }

        // If the app version is set
        if(typeof useragentswitcher_optionsDataString[appVersion] != "undefined")
        {
            appVersionValue = useragentswitcher_optionsDataString[appVersion].trim();
        }
        else if(preferencesService.prefHasUserValue(appVersion))
        {
	        appVersionValue = preferencesService.getComplexValue(appVersion, Components.interfaces.nsISupportsString).data.trim();
        }
        else
        {
            appVersionValue = null;
        }

        // If the description is set
        if(typeof useragentswitcher_optionsDataString[description] != "undefined")
        {
            descriptionValue = useragentswitcher_optionsDataString[description].trim();
        }
        else if(preferencesService.prefHasUserValue(description))
        {
	        descriptionValue = preferencesService.getComplexValue(description, Components.interfaces.nsISupportsString).data.trim();
        }
        else
        {
            descriptionValue = null;
        }

        // If the platform is set
        if(typeof useragentswitcher_optionsDataString[platform] != "undefined")
        {
            platformValue = useragentswitcher_optionsDataString[platform].trim();
        }
        else if(preferencesService.prefHasUserValue(platform))
        {
	        platformValue = preferencesService.getComplexValue(platform, Components.interfaces.nsISupportsString).data.trim();
        }
        else
        {
            platformValue = null;
        }

        // If the user agent is set
        if(typeof useragentswitcher_optionsDataString[userAgent] != "undefined")
        {
            userAgentValue = useragentswitcher_optionsDataString[userAgent].trim();
        }
        else if(preferencesService.prefHasUserValue(userAgent))
        {
	        userAgentValue = preferencesService.getComplexValue(userAgent, Components.interfaces.nsISupportsString).data.trim();
        }
        else
        {
            userAgentValue = null;
        }

        // If the vendor is set
        if(typeof useragentswitcher_optionsDataString[vendor] != "undefined")
        {
            vendorValue = useragentswitcher_optionsDataString[vendor].trim();
        }
        else if(preferencesService.prefHasUserValue(vendor))
        {
	        vendorValue = preferencesService.getComplexValue(vendor, Components.interfaces.nsISupportsString).data.trim();
        }
        else
        {
            vendorValue = null;
        }

        // If the vendor sub is set
        if(typeof useragentswitcher_optionsDataString[vendorSub] != "undefined")
        {
            vendorSubValue = useragentswitcher_optionsDataString[vendorSub].trim();
        }
        else if(preferencesService.prefHasUserValue(vendorSub))
        {
	        vendorSubValue = preferencesService.getComplexValue(vendorSub, Components.interfaces.nsISupportsString).data.trim();
        }
        else
        {
            vendorSubValue = null;
        }

        // If the description is set
        if(descriptionValue)
        {
            listItem = userAgentBox.appendItem(descriptionValue, userAgentValue);

            listItem.setAttribute("appname", appNameValue);
            listItem.setAttribute("appversion", appVersionValue);
            listItem.setAttribute("platform", platformValue);
            listItem.setAttribute("vendor", vendorValue);
            listItem.setAttribute("vendorsub", vendorSubValue);
        }
    }

    // If the import overwrite preference is set
    if(typeof useragentswitcher_optionsDataBoolean["useragentswitcher.import.overwrite"] != "undefined")
    {
        pageDocument.getElementById("useragentswitcher.import.overwrite").checked = useragentswitcher_optionsDataBoolean["useragentswitcher.import.overwrite"];
    }
    else if(preferencesService.prefHasUserValue("useragentswitcher.import.overwrite"))
    {
        pageDocument.getElementById("useragentswitcher.import.overwrite").checked = preferencesService.getBoolPref("useragentswitcher.import.overwrite");
    }
    else
    {
        pageDocument.getElementById("useragentswitcher.import.overwrite").checked = false;
    }

    useragentswitcher_userAgentBoxSelected();
}

// Moves the selected item down
function useragentswitcher_moveDown()
{
    var pageDocument   = document.getElementById("useragentswitcher-options-iframe").contentDocument;
    var userAgentBox   = pageDocument.getElementById("useragentswitcher-listbox");
    var selectedIndex  = userAgentBox.selectedIndex;
    var selectedItem   = userAgentBox.selectedItem;
    var userAgentCount = userAgentBox.getRowCount();

    // If an item is selected and it is not at the bottom
    if(selectedItem && selectedIndex != userAgentCount - 1)
    {
        userAgentBox.selectItem(userAgentBox.insertBefore(selectedItem, userAgentBox.getNextItem(selectedItem, 2)));
    }
}

// Moves the selected item up
function useragentswitcher_moveUp()
{
    var pageDocument  = document.getElementById("useragentswitcher-options-iframe").contentDocument;
    var userAgentBox  = pageDocument.getElementById("useragentswitcher-listbox");
    var selectedIndex = userAgentBox.selectedIndex;
    var selectedItem  = userAgentBox.selectedItem;

    // If an item is selected and it is not at the top
    if(selectedItem && selectedIndex != 0)
    {
        userAgentBox.selectItem(userAgentBox.insertBefore(selectedItem, userAgentBox.getPreviousItem(selectedItem, 1)));
    }
}

// Resets the user's options
function useragentswitcher_resetOptions()
{
    var stringBundle = document.getElementById("useragentswitcher-string-bundle");

    // If the reset is confirmed
    if(confirm(stringBundle.getString("useragentswitcher_resetConfirmation")))
    {
        var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

        useragentswitcher_localizedOptionsSetup = false;
        useragentswitcher_optionsDataBoolean    = new Array();
        useragentswitcher_optionsDataInteger    = new Array();
        useragentswitcher_optionsDataString     = new Array();

        preferencesService.deleteBranch("useragentswitcher.");

        useragentswitcher_setupDefaultOptions();
        useragentswitcher_setupLocalizedOptions();
        useragentswitcher_initializeOptions();
    }
}

// Saves the user's options
function useragentswitcher_saveOptions()
{
    var option             = null;
    var optionValue        = null;
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
    var string             = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);

    // Make sure current page is stored
    useragentswitcher_storeOptions();

    // Loop through the boolean options
    for(option in useragentswitcher_optionsDataBoolean)
    {
        preferencesService.setBoolPref(option, useragentswitcher_optionsDataBoolean[option]);
    }

    // Loop through the integer options
    for(option in useragentswitcher_optionsDataInteger)
    {
        optionValue = useragentswitcher_optionsDataInteger[option];

        // If the option value is set
        if(optionValue)
        {
            preferencesService.setIntPref(option, optionValue);
        }
        else if(preferencesService.prefHasUserValue(option))
        {
            preferencesService.clearUserPref(option);
        }
    }

    // Loop through the string options
    for(option in useragentswitcher_optionsDataString)
    {
        optionValue = useragentswitcher_optionsDataString[option];

        // If the option value is set or the preference currently has a value
        if(optionValue || preferencesService.prefHasUserValue(option))
        {
            string.data = optionValue;

            preferencesService.setComplexValue(option, Components.interfaces.nsISupportsString, string);
        }
    }
}

// Stores the user's options to be saved later
function useragentswitcher_storeOptions()
{
    var iFrame       = document.getElementById("useragentswitcher-options-iframe");
    var iFrameSrc    = iFrame.getAttribute("src");
    var pageDocument = iFrame.contentDocument;

    // If this is the general page
    if(iFrameSrc.indexOf("general") != -1)
    {
        useragentswitcher_optionsDataBoolean["useragentswitcher.menu.hide"]     = pageDocument.getElementById("useragentswitcher.menu.hide").checked;
    }
    else if(iFrameSrc.indexOf("user_agents") != -1)
    {
        var appName            = null;
        var appVersion         = null;
        var description        = null;
        var listItem           = null;
        var platform           = null;
        var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
        var userAgent          = null;
        var userAgentBox       = pageDocument.getElementById("useragentswitcher-listbox");
        var userAgentCount     = 0;
        var vendor             = null;
        var vendorSub          = null;

        // If the user agents count preference is set
        if(preferencesService.prefHasUserValue("useragentswitcher.user.agents.count"))
        {
            userAgentCount = preferencesService.getIntPref("useragentswitcher.user.agents.count");
        }

        // Loop through the previous user agents
        for(var i = 1; i <= userAgentCount; i++)
        {
            appName     = "useragentswitcher." + i + ".appname";
            appVersion  = "useragentswitcher." + i + ".appversion";
            description = "useragentswitcher." + i + ".description";
            platform    = "useragentswitcher." + i + ".platform";
            userAgent   = "useragentswitcher." + i + ".useragent";
            vendor      = "useragentswitcher." + i + ".vendor";
            vendorSub   = "useragentswitcher." + i + ".vendorsub";

            useragentswitcher_optionsDataString[appName]     = "";
            useragentswitcher_optionsDataString[appVersion]  = "";
            useragentswitcher_optionsDataString[description] = "";
            useragentswitcher_optionsDataString[platform]    = "";
            useragentswitcher_optionsDataString[userAgent]   = "";
            useragentswitcher_optionsDataString[vendor]      = "";
            useragentswitcher_optionsDataString[vendorSub]   = "";
        }

        userAgentCount = userAgentBox.getRowCount();

        // Loop through the possible user agents
        for(i = 1; i <= userAgentCount; i++)
        {
            appName     = "useragentswitcher." + i + ".appname";
            appVersion  = "useragentswitcher." + i + ".appversion";
            description = "useragentswitcher." + i + ".description";
            listItem    = userAgentBox.getItemAtIndex(i - 1);
            platform    = "useragentswitcher." + i + ".platform";
            userAgent   = "useragentswitcher." + i + ".useragent";
            vendor      = "useragentswitcher." + i + ".vendor";
            vendorSub   = "useragentswitcher." + i + ".vendorsub";

            // If the list item has an app name attribute
            if(listItem.hasAttribute("appname"))
            {
                useragentswitcher_optionsDataString[appName] = listItem.getAttribute("appname").trim();
            }

            // If the selected item has an app version attribute
            if(listItem.hasAttribute("appversion"))
            {
                useragentswitcher_optionsDataString[appVersion] = listItem.getAttribute("appversion").trim();
            }

            // If the selected item has a platform attribute
            if(listItem.hasAttribute("platform"))
            {
                useragentswitcher_optionsDataString[platform] = listItem.getAttribute("platform").trim();
            }

            // If the selected item has a vendor attribute
            if(listItem.hasAttribute("vendor"))
            {
                useragentswitcher_optionsDataString[vendor] = listItem.getAttribute("vendor").trim();
            }

            // If the selected item has a vendorsub attribute
            if(listItem.hasAttribute("vendorsub"))
            {
                useragentswitcher_optionsDataString[vendorSub] = listItem.getAttribute("vendorsub").trim();
            }

            useragentswitcher_optionsDataString[description] = listItem.label.trim();
            useragentswitcher_optionsDataString[userAgent]   = listItem.value.trim();
        }

        useragentswitcher_optionsDataBoolean["useragentswitcher.import.overwrite"]  = pageDocument.getElementById("useragentswitcher.import.overwrite").checked;
        useragentswitcher_optionsDataInteger["useragentswitcher.user.agents.count"] = userAgentCount;
    }
}

// Called whenever the user agent box is selected
function useragentswitcher_userAgentBoxSelected()
{
    var pageDocument   = document.getElementById("useragentswitcher-options-iframe").contentDocument;
    var selectedItem   = pageDocument.getElementById("useragentswitcher-listbox").selectedItem;
    var deleteButton   = pageDocument.getElementById("useragentswitcher-delete");
    var editButton     = pageDocument.getElementById("useragentswitcher-edit");
    var moveDownButton = pageDocument.getElementById("useragentswitcher-move-down");
    var moveUpButton   = pageDocument.getElementById("useragentswitcher-move-up");

    // If an item is selected
    if(selectedItem)
    {
        deleteButton.disabled   = false;
        editButton.disabled     = false;
        moveDownButton.disabled = false;
        moveUpButton.disabled   = false;
    }
    else
    {
        deleteButton.disabled   = true;
        editButton.disabled     = true;
        moveDownButton.disabled = true;
        moveUpButton.disabled   = true;
    }
}

// Views the default user agent
function useragentswitcher_viewDefault()
{
    window.openDialog("chrome://useragentswitcher/content/options/dialogs/user_agent.xul", "useragentswitcher-user-agent-dialog", "centerscreen,chrome,modal,resizable", "default");
}
