var useragentswitcher_localizedOptionsSetup = false;
var useragentswitcher_quitObserver          = false;

useragentswitcher_initialize();

// Displays the about dialog
function useragentswitcher_about()
{
    window.openDialog("chrome://useragentswitcher/content/about/about.xul", "useragentswitcher-about-dialog", "centerscreen,chrome,modal,resizable");
}

// Handles the browser being closed
function useragentswitcher_browserClose(event)
{
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    // If the reset on close preference is set to true
    if(preferencesService.prefHasUserValue("useragentswitcher.reset.onclose") && preferencesService.getBoolPref("useragentswitcher.reset.onclose"))
    {
        var windowCount       = 0;
        var windowEnumeration = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getEnumerator("navigator:browser");

        // Loop through the open windows
        while(windowEnumeration.hasMoreElements())
        {
            windowEnumeration.getNext();
            windowCount++;
        }

        // If this is the last window closing
        if(windowCount == 1)
        {
            useragentswitcher_reset();
        }
    }
}

// Changes the options
function useragentswitcher_changeOptions()
{
    var hideMenuPreference = false;
    var menu               = document.getElementById("useragentswitcher-menu");
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    // If the hide menu preference is set
    if(preferencesService.prefHasUserValue("useragentswitcher.menu.hide"))
    {
        hideMenuPreference = preferencesService.getBoolPref("useragentswitcher.menu.hide");
    }

    // If the menu exists
    if(menu)
    {
        menu.setAttribute("hidden", hideMenuPreference);
    }
}

// Displays the user agent switcher menu
function useragentswitcher_displayUserAgentSwitcherMenu(menu)
{
    var appName               = null;
    var appNamePreference     = null;
    var appVersion            = null;
    var appVersionPreference  = null;
    var defaultMenu           = null;
    var description           = null;
    var descriptionPreference = null;
    var menuItem              = null;
    var mode                  = null;
    var optionsSeparator      = null;
    var platform              = null;
    var platformPreference    = null;
    var preferencesService    = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
    var userAgent             = null;
    var userAgentCount        = 0;
    var userAgentPreference   = null;
    var vendor                = null;
    var vendorPreference      = null;
    var vendorSub             = null;
    var vendorSubPreference   = null;

    // If the user agents count preference is set
    if(preferencesService.prefHasUserValue("useragentswitcher.user.agents.count"))
    {
        userAgentCount = preferencesService.getIntPref("useragentswitcher.user.agents.count");
    }

    // If this is the menu
    if(menu.getAttribute("id") == "useragentswitcher-popup-menu")
    {
        defaultMenu      = menu.getElementsByAttribute("id", "useragentswitcher-default-menu")[0];
        optionsSeparator = menu.getElementsByAttribute("id", "useragentswitcher-separator-menu")[0];
    }
    else
    {
        defaultMenu      = menu.getElementsByAttribute("id", "useragentswitcher-default-toolbar")[0];
        optionsSeparator = menu.getElementsByAttribute("id", "useragentswitcher-separator-toolbar")[0];
    }

    useragentswitcher_removeGeneratedMenuItems(menu, defaultMenu.getAttribute("id"));

    // If the default menu exists
    if(defaultMenu)
    {
        defaultMenu.setAttribute("checked", !preferencesService.prefHasUserValue("general.useragent.override"));
    }

    // Loop through the possible user agents
	for(var i = 1; i <= userAgentCount; i++)
	{
	    appName     = "useragentswitcher." + i + ".appname";
	    appVersion  = "useragentswitcher." + i + ".appversion";
	    description = "useragentswitcher." + i + ".description";
	    platform    = "useragentswitcher." + i + ".platform";
	    userAgent   = "useragentswitcher." + i + ".useragent";
	    vendor      = "useragentswitcher." + i + ".vendor";
	    vendorSub   = "useragentswitcher." + i + ".vendorsub";

        // If the description is set
        if(preferencesService.prefHasUserValue(description))
        {
            appNamePreference     = "";
            appVersionPreference  = "";
	        descriptionPreference = preferencesService.getComplexValue(description, Components.interfaces.nsISupportsString).data.trim();
            platformPreference    = "";
            userAgentPreference   = "";
            vendorPreference      = "";
            vendorSubPreference   = "";

            // If the app name is set
            if(preferencesService.prefHasUserValue(appName))
            {
    	        appNamePreference = preferencesService.getComplexValue(appName, Components.interfaces.nsISupportsString).data.trim();
            }

            // If the app version is set
            if(preferencesService.prefHasUserValue(appVersion))
            {
    	        appVersionPreference = preferencesService.getComplexValue(appVersion, Components.interfaces.nsISupportsString).data.trim();
            }

            // If the platform is set
            if(preferencesService.prefHasUserValue(platform))
            {
    	        platformPreference = preferencesService.getComplexValue(platform, Components.interfaces.nsISupportsString).data.trim();
            }

            // If the user agent is set
            if(preferencesService.prefHasUserValue(userAgent))
            {
    	        userAgentPreference = preferencesService.getComplexValue(userAgent, Components.interfaces.nsISupportsString).data.trim();
            }

            // If the vendor is set
            if(preferencesService.prefHasUserValue(vendor))
            {
    	        vendorPreference = preferencesService.getComplexValue(vendor, Components.interfaces.nsISupportsString).data.trim();
            }

            // If the vendor sub is set
            if(preferencesService.prefHasUserValue(vendorSub))
            {
    	        vendorSubPreference = preferencesService.getComplexValue(vendorSub, Components.interfaces.nsISupportsString).data.trim();
            }

            // If the description is not blank
            if(descriptionPreference != "")
            {
                menuItem = document.createElement("menuitem");

                // If all the override values are set to this item's values
                if(preferencesService.prefHasUserValue("general.appname.override") && preferencesService.getComplexValue("general.appname.override", Components.interfaces.nsISupportsString).data.trim() == appNamePreference &&
                   preferencesService.prefHasUserValue("general.appversion.override") && preferencesService.getComplexValue("general.appversion.override", Components.interfaces.nsISupportsString).data.trim() == appVersionPreference &&
                   preferencesService.prefHasUserValue("general.platform.override") && preferencesService.getComplexValue("general.platform.override", Components.interfaces.nsISupportsString).data.trim() == platformPreference &&
                   preferencesService.prefHasUserValue("general.useragent.override") && preferencesService.getComplexValue("general.useragent.override", Components.interfaces.nsISupportsString).data.trim() == userAgentPreference &&
                   preferencesService.getComplexValue("general.useragent.vendor", Components.interfaces.nsISupportsString).data.trim() == vendorPreference &&
                   preferencesService.getComplexValue("general.useragent.vendorSub", Components.interfaces.nsISupportsString).data.trim() == vendorSubPreference)
                {
                    menuItem.setAttribute("checked", true);
                }

                menuItem.setAttribute("label", descriptionPreference);
                menuItem.setAttribute("oncommand", "useragentswitcher_switchUserAgent('" + useragentswitcher_escapeString(appNamePreference) + "', '" + useragentswitcher_escapeString(appVersionPreference) + "', '" + useragentswitcher_escapeString(platformPreference) + "', '" + useragentswitcher_escapeString(userAgentPreference) + "', '" + useragentswitcher_escapeString(vendorPreference) + "', '" + useragentswitcher_escapeString(vendorSubPreference) + "')");
                menuItem.setAttribute("type", "radio");

                // If the menu, menu item and options separator exist
                if(menu && menuItem && optionsSeparator)
                {
                    menu.insertBefore(menuItem, optionsSeparator);
                }
            }
        }
	}
}

// Escapes all apostrophes and backslashes in a string
function useragentswitcher_escapeString(string)
{
    // If the string is set
    if(string)
    {
        return encodeURIComponent(string).replace(new RegExp("'", "gi"), "\\'");
    }

    return "";
}

// Opens the help
function useragentswitcher_help()
{
    getBrowser().addTab("http://chrispederick.com/work/firefox/useragentswitcher/documentation/");
}

// Initializes the extension
function useragentswitcher_initialize()
{
    useragentswitcher_setupDefaultOptions();

    // Try to remove the close event listener
    try
    {
        window.removeEventListener("close", useragentswitcher_browserClose, true);
    }
    catch(exception)
    {
        // Do nothing
    }

    // Try to remove the load event listener
    try
    {
        window.removeEventListener("load", useragentswitcher_pageLoad, true);
    }
    catch(exception)
    {
        // Do nothing
    }

    window.addEventListener("close", useragentswitcher_browserClose, true);
    window.addEventListener("load", useragentswitcher_pageLoad, true);
}

// Displays the options dialog
function useragentswitcher_options()
{
    window.openDialog("chrome://useragentswitcher/content/options/options.xul", "useragentswitcher-options-dialog", "centerscreen,chrome,modal,resizable");

    useragentswitcher_changeOptions();
}

// Handles the page being loaded
function useragentswitcher_pageLoad(event)
{
    var eventTarget = event.target;

    // If the page is the target
    if(eventTarget && eventTarget.hasAttribute && eventTarget.hasAttribute("id") && eventTarget.getAttribute("id").toLowerCase() == "content")
    {
        useragentswitcher_changeOptions();

        // If the localized options have not been setup
        if(!useragentswitcher_localizedOptionsSetup)
        {
            useragentswitcher_setupLocalizedOptions();
        }

        // If not already observing quits
        if(!useragentswitcher_quitObserver)
        {
            var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

            // Try to remove the observer
            try
            {
                observerService.removeObserver(UserAgentSwitcherQuitObserver, "quit-application-requested");
            }
            catch(exception)
            {
                // Do nothing
            }

            observerService.addObserver(UserAgentSwitcherQuitObserver, "quit-application-requested", false);

            useragentswitcher_quitObserver = true;
        }

        useragentswitcher_updateButton();
    }
}

// Removes all the generated menu items from the menu
function useragentswitcher_removeGeneratedMenuItems(menu, defaultMenuId)
{
    var menuItem       = null;
    var radioMenuItems = menu.getElementsByAttribute("type", "radio");

    // Loop through the radio menu items
    for(var i = 0; i < radioMenuItems.length; i++)
    {
        menuItem = radioMenuItems[i];

        // If this is not the default menu
        if(!menuItem.hasAttribute("id") || menuItem.getAttribute("id") != defaultMenuId)
        {
            menu.removeChild(menuItem);
        }
    }

    radioMenuItems = menu.getElementsByAttribute("type", "radio");

    // Loop through the menu items again because of the change to the behavior of getElementsByAttribute
    while(radioMenuItems.length > 1)
    {
        menuItem = radioMenuItems[1];

        // If this is not the default menu
        if(!menuItem.hasAttribute("id") || menuItem.getAttribute("id") != defaultMenuId)
        {
            menu.removeChild(menuItem);
        }
    }
}

// Resets the user agent
function useragentswitcher_reset()
{
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    // If an override app name is set
    if(preferencesService.prefHasUserValue("general.appname.override"))
    {
        preferencesService.clearUserPref("general.appname.override");
    }

    // If an override app version is set
    if(preferencesService.prefHasUserValue("general.appversion.override"))
    {
        preferencesService.clearUserPref("general.appversion.override");
    }

    // If an override platform is set
    if(preferencesService.prefHasUserValue("general.platform.override"))
    {
        preferencesService.clearUserPref("general.platform.override");
    }

    // If an override user agent is set
    if(preferencesService.prefHasUserValue("general.useragent.override"))
    {
        preferencesService.clearUserPref("general.useragent.override");
    }

    // If an override vendor is set
    if(preferencesService.prefHasUserValue("general.useragent.vendor"))
    {
        preferencesService.clearUserPref("general.useragent.vendor");
    }

    // If an override vendor sub is set
    if(preferencesService.prefHasUserValue("general.useragent.vendorSub"))
    {
        preferencesService.clearUserPref("general.useragent.vendorSub");
    }

    useragentswitcher_updateButton();
}

// Sets up the default options
function useragentswitcher_setupDefaultOptions()
{
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    // Set default reset on close
    if(!preferencesService.prefHasUserValue("useragentswitcher.reset.onclose"))
    {
        preferencesService.setBoolPref("useragentswitcher.reset.onclose", true);
    }
}

// Sets up the localized options
function useragentswitcher_setupLocalizedOptions()
{
    var stringBundle = document.getElementById("useragentswitcher-string-bundle");

    // If the string bundle is set
    if(stringBundle)
    {
        var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
        var string             = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);

        // Convert maximum user agents preference to user agents count
        if(!preferencesService.prefHasUserValue("useragentswitcher.user.agents.count") && preferencesService.prefHasUserValue("useragentswitcher.maximum.useragents"))
        {
            preferencesService.setIntPref("useragentswitcher.user.agents.count", preferencesService.getIntPref("useragentswitcher.maximum.useragents"));
            preferencesService.clearUserPref("useragentswitcher.maximum.useragents");
        }
        else if(!preferencesService.prefHasUserValue("useragentswitcher.user.agents.count"))
        {
            preferencesService.setIntPref("useragentswitcher.user.agents.count", 3);
        }

        // Set default user agents
        if(!preferencesService.prefHasUserValue("useragentswitcher.1.description"))
        {
            string.data = "Microsoft Internet Explorer";
            preferencesService.setComplexValue("useragentswitcher.1.appname", Components.interfaces.nsISupportsString, string);

            string.data = "4.0 (compatible; MSIE 6.0; Windows NT 5.1)";
            preferencesService.setComplexValue("useragentswitcher.1.appversion", Components.interfaces.nsISupportsString, string);

            string.data = stringBundle.getString("useragentswitcher_userAgentInternetExplorer");
            preferencesService.setComplexValue("useragentswitcher.1.description", Components.interfaces.nsISupportsString, string);

            string.data = "Win32";
            preferencesService.setComplexValue("useragentswitcher.1.platform", Components.interfaces.nsISupportsString, string);

            string.data = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)";
            preferencesService.setComplexValue("useragentswitcher.1.useragent", Components.interfaces.nsISupportsString, string);

            string.data = "";
            preferencesService.setComplexValue("useragentswitcher.1.vendor", Components.interfaces.nsISupportsString, string);

            string.data = "";
            preferencesService.setComplexValue("useragentswitcher.1.vendorsub", Components.interfaces.nsISupportsString, string);
        }
        if(!preferencesService.prefHasUserValue("useragentswitcher.2.description"))
        {
            string.data = "Netscape";
            preferencesService.setComplexValue("useragentswitcher.2.appname", Components.interfaces.nsISupportsString, string);

            string.data = "4.8 [en] (Windows NT 5.1; U)";
            preferencesService.setComplexValue("useragentswitcher.2.appversion", Components.interfaces.nsISupportsString, string);

            string.data = stringBundle.getString("useragentswitcher_userAgentNetscape");
            preferencesService.setComplexValue("useragentswitcher.2.description", Components.interfaces.nsISupportsString, string);

            string.data = "Win32";
            preferencesService.setComplexValue("useragentswitcher.2.platform", Components.interfaces.nsISupportsString, string);

            string.data = "Mozilla/4.8 [en] (Windows NT 5.1; U)";
            preferencesService.setComplexValue("useragentswitcher.2.useragent", Components.interfaces.nsISupportsString, string);

            string.data = "";
            preferencesService.setComplexValue("useragentswitcher.2.vendor", Components.interfaces.nsISupportsString, string);

            string.data = "";
            preferencesService.setComplexValue("useragentswitcher.2.vendorsub", Components.interfaces.nsISupportsString, string);
        }
        if(!preferencesService.prefHasUserValue("useragentswitcher.3.description"))
        {
            string.data = "Opera";
            preferencesService.setComplexValue("useragentswitcher.3.appname", Components.interfaces.nsISupportsString, string);

            string.data = "8.0 (Windows NT 5.1; U; en)";
            preferencesService.setComplexValue("useragentswitcher.3.appversion", Components.interfaces.nsISupportsString, string);

            string.data = stringBundle.getString("useragentswitcher_userAgentOpera");
            preferencesService.setComplexValue("useragentswitcher.3.description", Components.interfaces.nsISupportsString, string);

            string.data = "Win32";
            preferencesService.setComplexValue("useragentswitcher.3.platform", Components.interfaces.nsISupportsString, string);

            string.data = "Opera/8.0 (Windows NT 5.1; U; en)";
            preferencesService.setComplexValue("useragentswitcher.3.useragent", Components.interfaces.nsISupportsString, string);

            string.data = "";
            preferencesService.setComplexValue("useragentswitcher.3.vendor", Components.interfaces.nsISupportsString, string);

            string.data = "";
            preferencesService.setComplexValue("useragentswitcher.3.vendorsub", Components.interfaces.nsISupportsString, string);
        }

        useragentswitcher_localizedOptionsSetup = true;
    }
}

// Switches the user agent
function useragentswitcher_switchUserAgent(appName, appVersion, platform, userAgent, vendor, vendorSub)
{
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
    var string             = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);

    string.data = decodeURIComponent(appName);
    preferencesService.setComplexValue("general.appname.override", Components.interfaces.nsISupportsString, string);

    string.data = decodeURIComponent(appVersion);
    preferencesService.setComplexValue("general.appversion.override", Components.interfaces.nsISupportsString, string);

    string.data = decodeURIComponent(platform);
    preferencesService.setComplexValue("general.platform.override", Components.interfaces.nsISupportsString, string);

    string.data = decodeURIComponent(userAgent);
    preferencesService.setComplexValue("general.useragent.override", Components.interfaces.nsISupportsString, string);

    string.data = decodeURIComponent(vendor);
    preferencesService.setComplexValue("general.useragent.vendor", Components.interfaces.nsISupportsString, string);

    string.data = decodeURIComponent(vendorSub);
    preferencesService.setComplexValue("general.useragent.vendorSub", Components.interfaces.nsISupportsString, string);

    useragentswitcher_updateButton();
}

// Updates the button
function useragentswitcher_updateButton()
{
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
    var userAgentButton    = document.getElementById("useragentswitcher-toolbar-button");

    // If the user agent button is set
    if(userAgentButton)
    {
        // If the user agent is overridden
        if(preferencesService.prefHasUserValue("general.useragent.override"))
        {
            userAgentButton.setAttribute("default", "false");
        }
        else if(userAgentButton.hasAttribute("default"))
        {
            userAgentButton.removeAttribute("default");
        }
    }
}

// Quit observer
var UserAgentSwitcherQuitObserver =
{
    // Observes quits
    observe: function(subject, topic, data)
    {
        var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

        // If the reset on close preference is set to true
        if(preferencesService.prefHasUserValue("useragentswitcher.reset.onclose") && preferencesService.getBoolPref("useragentswitcher.reset.onclose"))
        {
            useragentswitcher_reset();
        }

        return false;
    }
}
